function varargout = agent_gui_fictitious_agent_da(varargin)

% Name: agent_gui_fictitious_agent_da.m
% Location: MALT/agentClasses/@ficticious_agent/agent_gui_fictitious_agent_da.m
% Purpose:  Pops up a GUI for the agent that is to be created/edited
%           and returns the updated agent (in this case, a determined
%           agent)
% Input Parameters:  1 Parameter - agent object
% Output Parameters: updated agent object
%
% GUIDE COMMENTS LISTED BELOW
% ---------------------------
% AGENT_GUI_FICTITIOUS_AGENT_DA M-file for agent_gui_fictitious_agent_da.fig
%      AGENT_GUI_FICTITIOUS_AGENT_DA, by itself, creates a new AGENT_GUI_FICTITIOUS_AGENT_DA or raises the existing
%      singleton*.
%
%      H = AGENT_GUI_FICTITIOUS_AGENT_DA returns the handle to a new AGENT_GUI_FICTITIOUS_AGENT_DA or the handle to
%      the existing singleton*.
%
%      AGENT_GUI_FICTITIOUS_AGENT_DA('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in AGENT_GUI_FICTITIOUS_AGENT_DA.M with the given input arguments.
%
%      AGENT_GUI_FICTITIOUS_AGENT_DA('Property','Value',...) creates a new AGENT_GUI_FICTITIOUS_AGENT_DA or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before agent_gui_fictitious_agent_da_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to agent_gui_fictitious_agent_da_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help agent_gui_fictitious_agent_da

% Last Modified by GUIDE v2.5 01-Jul-2005 15:37:32

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @agent_gui_fictitious_agent_da_OpeningFcn, ...
                   'gui_OutputFcn',  @agent_gui_fictitious_agent_da_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before agent_gui_fictitious_agent_da is made visible.
function agent_gui_fictitious_agent_da_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to agent_gui_fictitious_agent_da (see VARARGIN)

currAgent = varargin{1};
if isempty( currAgent ) % ie. we are adding an agent
	 % Create a default currAgent structure if it is empty
	 % ie. it has not been created previously
    currAgent = struct( 'date', date, 'algorithm', get(handles.nameAgent, 'String' ),...
        'number', 1, 'actions', [], 'strategy', '', 'count', [],...
        'beliefUpdateRate', 0.9, 'beliefDecayRate', 0.999911,...
        'displayName', '' );
end

set( handles.beliefUpdateAgent, 'String', currAgent.beliefUpdateRate );
set( handles.beliefDecayAgent, 'String', currAgent.beliefDecayRate );

handles.windowAgent = currAgent; % Save in handles for use in other functions

% Choose default command line output for agent_gui_fictitious_agent_da
handles.output = hObject;

allBeliefs = get( handles.beliefsPopup, 'String' ); % Get beliefs
currBeliefs = currAgent.strategy; % Get current agent's strategy
% Find value of current belief
whereIs = find( strcmp( allBeliefs, currBeliefs ) );
if isempty( whereIs )
    set(handles.beliefsPopup, 'Value', 1 )
else
    set(handles.beliefsPopup, 'Value', find( strcmp( allBeliefs, currBeliefs ) ) );
end

% Update handles structure
guidata(hObject, handles);

% Make the GUI modal
set( hObject, 'WindowStyle', 'modal' );

% UIWAIT makes agent_gui_fictitious_agent_da wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = agent_gui_fictitious_agent_da_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% The figure can be deleted now
delete(handles.figure1);

% --- Executes during object creation, after setting all properties.
function nameAgent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nameAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function nameAgent_Callback(hObject, eventdata, handles)
% hObject    handle to nameAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nameAgent as text
%        str2double(get(hObject,'String')) returns contents of nameAgent as a double


% --- Executes during object creation, after setting all properties.
function beliefsPopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to beliefsPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function beliefsPopup_Callback(hObject, eventdata, handles)
% hObject    handle to beliefsPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of beliefsPopup as text
%        str2double(get(hObject,'String')) returns contents of beliefsPopup as a double


% --- Executes on button press in createPushButton.
function createPushButton_Callback(hObject, eventdata, handles)
% hObject    handle to createPushButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

currAgent = handles.windowAgent;

chosenBeliefs = get( handles.beliefsPopup, 'Value' );
allBeliefs = get( handles.beliefsPopup, 'String' );

selBelief = allBeliefs{chosenBeliefs};

% Update the currAgent structure's fields
currAgent.strategy = selBelief;
currAgent.beliefUpdateRate = str2num( get( handles.beliefUpdateAgent, 'String' ) );
currAgent.beliefDecayRate = str2num( get( handles.beliefDecayAgent, 'String' ) );

% Set the output to the modified agent
handles.output = currAgent;

% Update handles structure
guidata(hObject, handles);

% Use UIRESUME instead of delete because the OutputFcn needs
% to get the updated handles structure.
uiresume(handles.figure1);



function beliefUpdateAgent_Callback(hObject, eventdata, handles)
% hObject    handle to beliefUpdateAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of beliefUpdateAgent as text
%        str2double(get(hObject,'String')) returns contents of beliefUpdateAgent as a double


% --- Executes during object creation, after setting all properties.
function beliefUpdateAgent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to beliefUpdateAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function beliefDecayAgent_Callback(hObject, eventdata, handles)
% hObject    handle to beliefDecayAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of beliefDecayAgent as text
%        str2double(get(hObject,'String')) returns contents of beliefDecayAgent as a double


% --- Executes during object creation, after setting all properties.
function beliefDecayAgent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to beliefDecayAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


