function varargout = agent_gui_minimax_idr_agent(varargin)

% Name: agent_gui_minimax_idr_agent.m
% Location: MALT/agentClasses/@minimax_agent/agent_gui_minimax_idr_agent.m
% Purpose:  Pops up a GUI for the agent that is to be created/edited
%           and returns the updated agent (in this case, a determined
%           agent)
% Input Parameters:  1 Parameter - agent object
% Output Parameters: updated agent object
%
% GUIDE COMMENTS LISTED BELOW
% ---------------------------
% AGENT_GUI_MINIMAX_IDR_AGENT M-file for agent_gui_minimax_idr_agent.fig
%      AGENT_GUI_MINIMAX_IDR_AGENT, by itself, creates a new AGENT_GUI_MINIMAX_IDR_AGENT or raises the existing
%      singleton*.
%
%      H = AGENT_GUI_MINIMAX_IDR_AGENT returns the handle to a new AGENT_GUI_MINIMAX_IDR_AGENT or the handle to
%      the existing singleton*.
%
%      AGENT_GUI_MINIMAX_IDR_AGENT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in AGENT_GUI_MINIMAX_IDR_AGENT.M with the given input arguments.
%
%      AGENT_GUI_MINIMAX_IDR_AGENT('Property','Value',...) creates a new AGENT_GUI_MINIMAX_IDR_AGENT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before agent_gui_minimax_idr_agent_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to agent_gui_minimax_idr_agent_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help agent_gui_minimax_idr_agent

% Last Modified by GUIDE v2.5 22-Nov-2004 18:32:20

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @agent_gui_minimax_idr_agent_OpeningFcn, ...
                   'gui_OutputFcn',  @agent_gui_minimax_idr_agent_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before agent_gui_minimax_idr_agent is made visible.
function agent_gui_minimax_idr_agent_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to agent_gui_minimax_idr_agent (see VARARGIN)

currAgent = varargin{1};
if isempty( currAgent ) % ie. we are adding an agent
	% Create a default currAgent structure if it is empty
	% ie. it has not been created previously
   currAgent = struct( 'date', date, 'algorithm', get(handles.nameAgent, 'String' ),...
   	'number', 1, 'actions', [], 'strategy', '', 'explore', 0.2,...
      'exploreDecay', 0.999913, 'alpha', 0.9, 'alphaDecay', 0.999913,...
      'gamma', 0.9, 'Q', [], 'V', 1, 'displayName', '' );
end

set( handles.exploreAgent, 'String', currAgent.explore );
set( handles.exploreDecayAgent, 'String', currAgent.exploreDecay );
set( handles.alphaAgent, 'String', currAgent.alpha );
set( handles.alphaDecayAgent, 'String', currAgent.alphaDecay );
set( handles.gammaAgent, 'String', currAgent.gamma );

handles.windowAgent = currAgent; % Save in handles for use in other functions

allBeliefs = get( handles.beliefsPopup, 'String' ); % Get beliefs
currBeliefs = currAgent.strategy; % Get current agent's strategy
% Find value of current belief
whereIs = find( strcmp( allBeliefs, currBeliefs ) );
if isempty( whereIs )
    set(handles.beliefsPopup, 'Value', 1 )
else
    set(handles.beliefsPopup, 'Value', find( strcmp( allBeliefs, currBeliefs ) ) );
end

% Choose default command line output for agent_gui_minimax_idr_agent
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);
% Make the GUI modal
set( hObject, 'WindowStyle', 'modal' );
% UIWAIT makes agent_gui_minimax_idr_agent wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = agent_gui_minimax_idr_agent_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% The figure can be deleted now
delete(handles.figure1);

% --- Executes during object creation, after setting all properties.
function nameAgent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nameAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function nameAgent_Callback(hObject, eventdata, handles)
% hObject    handle to nameAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nameAgent as text
%        str2double(get(hObject,'String')) returns contents of nameAgent as a double


% --- Executes during object creation, after setting all properties.
function beliefsPopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to beliefsPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function beliefsPopup_Callback(hObject, eventdata, handles)
% hObject    handle to beliefsPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of beliefsPopup as text
%        str2double(get(hObject,'String')) returns contents of beliefsPopup as a double


% --- Executes on button press in confirmButton.
function confirmButton_Callback(hObject, eventdata, handles)
% hObject    handle to confirmButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

currAgent = handles.windowAgent;

chosenBeliefs = get( handles.beliefsPopup, 'Value' );
allBeliefs = get( handles.beliefsPopup, 'String' );

selBelief = allBeliefs{chosenBeliefs};

% Update the fields in the currAgent object
currAgent.strategy = selBelief;
currAgent.explore = str2num( get( handles.exploreAgent, 'String' ) );
currAgent.exploreDecay = str2num( get( handles.exploreDecayAgent, 'String' ) );
currAgent.alpha = str2num( get( handles.alphaAgent, 'String' ) );
currAgent.alphaDecay = str2num( get( handles.alphaDecayAgent, 'String' ) );
currAgent.gamma = str2num( get( handles.gammaAgent, 'String' ) );

% Set the output to the modified agent
handles.output = currAgent;

% Update handles structure
guidata(hObject, handles);
    
% Use UIRESUME instead of delete because the OutputFcn needs
% to get the updated handles structure.
uiresume(handles.figure1);

% --- Executes during object creation, after setting all properties.
function exploreAgent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to exploreAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function exploreAgent_Callback(hObject, eventdata, handles)
% hObject    handle to exploreAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of exploreAgent as text
%        str2double(get(hObject,'String')) returns contents of exploreAgent as a double


% --- Executes during object creation, after setting all properties.
function exploreDecayAgent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to exploreDecayAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function exploreDecayAgent_Callback(hObject, eventdata, handles)
% hObject    handle to exploreDecayAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of exploreDecayAgent as text
%        str2double(get(hObject,'String')) returns contents of exploreDecayAgent as a double


% --- Executes during object creation, after setting all properties.
function alphaAgent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to alphaAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function alphaAgent_Callback(hObject, eventdata, handles)
% hObject    handle to alphaAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of alphaAgent as text
%        str2double(get(hObject,'String')) returns contents of alphaAgent as a double


% --- Executes during object creation, after setting all properties.
function alphaDecayAgent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to alphaDecayAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function alphaDecayAgent_Callback(hObject, eventdata, handles)
% hObject    handle to alphaDecayAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of alphaDecayAgent as text
%        str2double(get(hObject,'String')) returns contents of alphaDecayAgent as a double


% --- Executes during object creation, after setting all properties.
function gammaAgent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gammaAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function gammaAgent_Callback(hObject, eventdata, handles)
% hObject    handle to gammaAgent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gammaAgent as text
%        str2double(get(hObject,'String')) returns contents of gammaAgent
%        as a double
