function varargout = agentsControl(varargin)
% AGENTSCONTROL M-file for agentsControl.fig
%      AGENTSCONTROL, by itself, creates a new AGENTSCONTROL or raises the existing
%      singleton*.
%
%      H = AGENTSCONTROL returns the handle to a new AGENTSCONTROL or the handle to
%      the existing singleton*.
%
%      AGENTSCONTROL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in AGENTSCONTROL.M with the given input arguments.
%
%      AGENTSCONTROL('Property','Value',...) creates a new AGENTSCONTROL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before agentsControl_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to agentsControl_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help agentsControl

% Last Modified by GUIDE v2.5 20-Jan-2005 16:37:57

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @agentsControl_OpeningFcn, ...
                   'gui_OutputFcn',  @agentsControl_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before agentsControl is made visible.
function agentsControl_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to agentsControl (see VARARGIN)

% Saves original values
origAgents = varargin{1};
handles.origAgents = origAgents;
currSelected = varargin{2};
handles.origSelected = currSelected;

% Update list of what agents are selected, what are unselected
avail = {};
for cAgnt = 1:length( origAgents )
    actAgent = origAgents{cAgnt};
    if ( sum( strcmp( actAgent, currSelected ) ) == 0 )
        avail = {avail{1:end} actAgent};
    end
end

handles.origAvailable = avail;

% Sets the available agent's listbox
if isempty( avail )
    set( handles.agentsAvailableListbox, 'String', {} );
else
    set( handles.agentsAvailableListbox, 'String', avail );
end
handles.agentAvailableValue = [];

% Sets the currently selected agent's listbox
if isempty( currSelected )
    set( handles.agentsSelectedListbox, 'String', {} );
else
    set( handles.agentsSelectedListbox, 'String', currSelected );
end
handles.agentSelectedValue = [];

% Choose default command line output for agentsControl
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes agentsControl wait for user response (see UIRESUME)
 uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = agentsControl_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
% Close the figure
delete( handles.figure1 );

% --- Executes on selection change in agentsAvailableListbox.
function agentsAvailableListbox_Callback(hObject, eventdata, handles)
% hObject    handle to agentsAvailableListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns agentsAvailableListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from agentsAvailableListbox

handles.agentAvailableValue = get( hObject, 'Value' );

% Update data
guidata( hObject, handles );

% --- Executes during object creation, after setting all properties.
function agentsAvailableListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to agentsAvailableListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in agentsSelectedListbox.
function agentsSelectedListbox_Callback(hObject, eventdata, handles)
% hObject    handle to agentsSelectedListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns agentsSelectedListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from agentsSelectedListbox

handles.agentSelectedValue = get( hObject, 'Value' );

% Update data
guidata( hObject, handles );

% --- Executes during object creation, after setting all properties.
function agentsSelectedListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to agentsSelectedListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in addAgentButton.
function addAgentButton_Callback(hObject, eventdata, handles)
% hObject    handle to addAgentButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% First check that a value has been chosen
numbChosen = handles.agentAvailableValue;
if ( numbChosen == 0 )
    error_gui( 'Title', 'Error detected', 'Please select an agent from the "Available" listbox' );
elseif isempty( numbChosen )
    error_gui( 'Title', 'Error detected', 'Trying to add an agent that does not exist' );
else
    % Get the list of agents available
    agentsStillAvail = get( handles.agentsAvailableListbox, 'String' );
    agentChosen = agentsStillAvail{ numbChosen};
    
    % Get the list of agents currently selected
    agentsSelected = get( handles.agentsSelectedListbox, 'String' );
    % Update the list, resave it
    agentsSelected = {agentsSelected{1:end} agentChosen};
    lengthSelected = length( agentsSelected );
    set( handles.agentsSelectedListbox, 'Value', lengthSelected );
    if ( lengthSelected == 0 )
        set( handles.agentsSelectedListbox, 'String', {} );
    else
        set( handles.agentsSelectedListbox, 'String', agentsSelected );
    end
    
    % Remove from the available list and resave it
    agentsStillAvail = { agentsStillAvail{1:numbChosen-1} agentsStillAvail{numbChosen+1:end} };
    newLength = length( agentsStillAvail );
    set( handles.agentsAvailableListbox, 'Value', newLength );
    if ( newLength == 0 )
        set( handles.agentsAvailableListbox, 'String', {} );
    else
        set( handles.agentsAvailableListbox, 'String', agentsStillAvail );
    end
end

% Reset the values indicating which agents are selected in the box
handles.agentAvailableValue = 0;
handles.agentSelectedValue = 0;

% Save the GUI data
guidata( hObject, handles );
    
% --- Executes on button press in removeAgentButton.
function removeAgentButton_Callback(hObject, eventdata, handles)
% hObject    handle to removeAgentButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% First check that a value has been chosen
numbChosen = handles.agentSelectedValue;
if ( numbChosen == 0 )
    error_gui( 'Title', 'Error detected', 'Please select an agent from the "Selected" listbox' );
elseif isempty( numbChosen ) 
    error_gui( 'Title', 'Error detected', 'Trying to remove agent that does not exist' );
else
    % Get the list of agents currently selected
    agentsSelected = get( handles.agentsSelectedListbox, 'String' );       
    agentChosen = agentsSelected{ numbChosen };

    % Get the list of agents available
    agentsStillAvail = get( handles.agentsAvailableListbox, 'String' );
    % Update the list, resave it
    agentsStillAvail = {agentsStillAvail{1:end} agentChosen};
    availLength = length( agentsStillAvail );
    set( handles.agentsAvailableListbox, 'Value', availLength );
    if ( availLength == 0)
        set( handles.agentsAvailableListbox, 'String', {} );
    else
        set( handles.agentsAvailableListbox, 'String', agentsStillAvail );
    end
        
    % Remove from the selected list and resave it
    agentsSelected = { agentsSelected{1:numbChosen-1} agentsSelected{numbChosen+1:end} };
    newLength = length( agentsSelected );
    set( handles.agentsSelectedListbox, 'Value', newLength );
    if ( newLength == 0 )
        set( handles.agentsSelectedListbox, 'String', {} );
    else
        set( handles.agentsSelectedListbox, 'String', agentsSelected );
    end
end

% Reset the values
handles.agentAvailableValue = 0;
handles.agentSelectedValue = 0;

% Save the GUI data
guidata( hObject, handles );    

% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = clear_confirm( 'Title', 'Confirm reset' ); % Popup confirmation window
switch user_response
case {'Yes'}
    % Reset the two listboxes to their original state
    set( handles.agentsAvailableListbox, 'String', handles.origAvailable );
    set( handles.agentsAvailableListbox, 'Value', length( handles.origAvailable ) );
    set( handles.agentsSelectedListbox, 'String', handles.origSelected );
    set( handles.agentsSelectedListbox, 'Value', length( handles.origSelected ) );
case {'No'}
    % Do not do anything, no reset wanted
end

% Save the GUI data
guidata( hObject, handles );


% --- Executes on button press in acceptButton.
function acceptButton_Callback(hObject, eventdata, handles)
% hObject    handle to acceptButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isempty( get( handles.agentsSelectedListbox, 'String' ) )
    error_gui( 'Title', 'Unable to continue', 'Require at least one agent to be selected' );
else
    handles.output = get( handles.agentsSelectedListbox, 'String' ); % Set output
    guidata( hObject, handles); % Save data 

    uiresume( handles.figure1 );
end
