function varargout = aggControl(varargin)
% AGGCONTROL M-file for aggControl.fig
%      AGGCONTROL, by itself, creates a new AGGCONTROL or raises the existing
%      singleton*.
%
%      H = AGGCONTROL returns the handle to a new AGGCONTROL or the handle to
%      the existing singleton*.
%
%      AGGCONTROL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in AGGCONTROL.M with the given input arguments.
%
%      AGGCONTROL('Property','Value',...) creates a new AGGCONTROL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before aggControl_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to aggControl_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help aggControl

% Last Modified by GUIDE v2.5 25-Jan-2005 00:52:05

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @aggControl_OpeningFcn, ...
                   'gui_OutputFcn',  @aggControl_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before aggControl is made visible.
function aggControl_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to aggControl (see VARARGIN)

aggAllOrig = varargin{1};
aggCurrOrig = varargin{2};
errorbarsWanted = varargin{3};

handles.aggAllOrig = aggAllOrig;
handles.aggCurrOrig = aggCurrOrig;
handles.errorbarsWanted = errorbarsWanted;

if ( errorbarsWanted )
    % Errorbars are wanted, use the left hand itersAssignedFrame
    set( handles.itersAssignedText, 'Visible', 'on' );
    set( handles.itersNotAssignedText, 'Visible', 'off' );
    set( handles.itersAssignedFrame, 'Visible', 'on' );
    set( handles.itersNotAssignedFrame, 'Visible', 'off' );
    set( handles.tickedText, 'Visible', 'on' );
    set( handles.untickedText, 'Visible', 'off' );
    set( handles.tickedPopup, 'Visible', 'on' );
    set( handles.untickedPopup, 'Visible', 'off' );
    
    newVal = find( strcmp( aggAllOrig, aggCurrOrig ) );
    if isempty( newVal )
        newVal = 1;
    end
    set( handles.tickedPopup, 'String', aggAllOrig );
    set( handles.tickedPopup, 'Value', newVal );
else
    % Errorbars are not assigned, use the right hand itersNotAssignedFram
    set( handles.itersAssignedText, 'Visible', 'off' );
    set( handles.itersNotAssignedText, 'Visible', 'on' );
    set( handles.itersAssignedFrame, 'Visible', 'off' );
    set( handles.itersNotAssignedFrame, 'Visible', 'on' );
    set( handles.tickedText, 'Visible', 'off' );
    set( handles.untickedText, 'Visible', 'on' );
    set( handles.tickedPopup, 'Visible', 'off' );
    set( handles.untickedPopup, 'Visible', 'on' );
    
    newVal = find( strcmp( aggAllOrig, aggCurrOrig ) );
    if isempty( newVal )
        newVal = 1;
    end
    set( handles.untickedPopup, 'String', aggAllOrig );
    set( handles.untickedPopup, 'Value', newVal );
end
handles.valueOrig = newVal;

% Choose default command line output for aggControl
handles.output = hObject;

% Update handles structure
guidata( hObject, handles );

% UIWAIT makes aggControl wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = aggControl_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% Close the figure
delete( handles.figure1 );

% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = clear_confirm('Title', 'Confirm reset'); % Pops up the clear all confirmation window
switch user_response
case {'Yes'} % Want to clear all entries
    if ( handles.errorbarsWanted )        
        % Use the left hand frame
        set( handles.tickedPopup , 'String', handles.aggAllOrig );
        set( handles.tickedPopup , 'Value', handles.valueOrig );
    else
        % Use the right hand frame
        set( handles.untickedPopup , 'String', handles.aggAllOrig );
        set( handles.untickedPopup , 'Value', handles.valueOrig );
    end
case {'No'} % Do not want to clear entries
    % Do nothing
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in proceedButton.
function proceedButton_Callback(hObject, eventdata, handles)
% hObject    handle to proceedButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Do the checks, then proceed
if ( handles.errorbarsWanted )
    whichAgg = get( handles.tickedPopup, 'Value' );
    allAggs = get( handles.tickedPopup, 'String' );
else
    whichAgg = get( handles.untickedPopup, 'Value' );
    allAggs = get( handles.untickedPopup, 'String' );
end
handles.output = allAggs{whichAgg};
% Save the gui and handles data    
guidata( hObject, handles );

% Resume window control so that it can be closed and the value returned
uiresume( handles.figure1 );

% --- Executes on selection change in tickedPopup.
function tickedPopup_Callback(hObject, eventdata, handles)
% hObject    handle to tickedPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns tickedPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from tickedPopup


% --- Executes during object creation, after setting all properties.
function tickedPopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tickedPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in untickedPopup.
function untickedPopup_Callback(hObject, eventdata, handles)
% hObject    handle to untickedPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns untickedPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from untickedPopup


% --- Executes during object creation, after setting all properties.
function untickedPopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to untickedPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


