function varargout = depVarsControl(varargin)
% DEPVARSCONTROL M-file for depVarsControl.fig
%      DEPVARSCONTROL, by itself, creates a new DEPVARSCONTROL or raises the existing
%      singleton*.
%
%      H = DEPVARSCONTROL returns the handle to a new DEPVARSCONTROL or the handle to
%      the existing singleton*.
%
%      DEPVARSCONTROL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DEPVARSCONTROL.M with the given input arguments.
%
%      DEPVARSCONTROL('Property','Value',...) creates a new DEPVARSCONTROL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before depVarsControl_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to depVarsControl_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help depVarsControl

% Last Modified by GUIDE v2.5 21-Jan-2005 18:09:18

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @depVarsControl_OpeningFcn, ...
                   'gui_OutputFcn',  @depVarsControl_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before depVarsControl is made visible.
function depVarsControl_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to depVarsControl (see VARARGIN)

depVarsAllOrig = varargin{1};
currSelected = varargin{2};

currAvail = {};
for cAvail = 1:length( depVarsAllOrig )
    selectAvail = depVarsAllOrig{ cAvail };

    valueOfSeen = sum( strcmp( selectAvail, currSelected ) );
    if ( ~valueOfSeen )
        % This is the currently selected dependent variable
        currAvail = {currAvail{1:end} selectAvail};
    end
end

handles.depVarsAllOrig = depVarsAllOrig; % Original list of dependent variables available
handles.currSelectedOrig = currSelected; % Current list of dependent variables selected
handles.currAvailOrig = currAvail; % Current list of dependent variables available

% Set these to the listboxes
set( handles.depAvailableListbox, 'String', currAvail );
set( handles.depSelectedListbox, 'String', currSelected );
% Initialise the values used in the listboxes
handles.depAvailValue = 0;
handles.depSelectedValue = 0;

% Choose default command line output for depVarsControl
handles.output = hObject;

% Update handles structure
guidata( hObject, handles );

% UIWAIT makes depVarsControl wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = depVarsControl_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% Close the figure
delete( handles.figure1 );

% --- Executes on selection change in depAvailableListbox.
function depAvailableListbox_Callback(hObject, eventdata, handles)
% hObject    handle to depAvailableListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns depAvailableListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from depAvailableListbox

handles.depAvailValue = get( hObject, 'Value' );

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function depAvailableListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to depAvailableListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in depSelectedListbox.
function depSelectedListbox_Callback(hObject, eventdata, handles)
% hObject    handle to depSelectedListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns depSelectedListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from depSelectedListbox

handles.depSelectedValue = get( hObject, 'Value' );

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function depSelectedListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to depSelectedListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in addDepButton.
function addDepButton_Callback(hObject, eventdata, handles)
% hObject    handle to addDepButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

valueToAdd = handles.depAvailValue;
if ( valueToAdd == 0 )
    error_gui( 'Title', 'Error: Selection required', 'Need to choose an available dependent variable to add' );
elseif isempty( valueToAdd )
    error_gui( 'Title', 'Error detected', 'Trying to add a dependent variable that does not exist' );
elseif ( length( get( handles.depSelectedListbox, 'String' ) ) == 1 )
    error_gui( 'Title', 'Error: Unable to continue', 'Can have a maximum of one dependent variable selected' );
else
    % Remove from the dependent variables available listbox

    % Get the currently available dependent variables and the one that the user
    % selected and update the available
    currAvail = get( handles.depAvailableListbox, 'String' );
    depToAdd = currAvail{ valueToAdd };
    currAvail = {currAvail{1:valueToAdd-1} currAvail{valueToAdd+1:end}};
    % Get the currently selected dependent variables and update it
    currSelected = get( handles.depSelectedListbox, 'String' );
    currSelected = {currSelected{1:end} depToAdd};

    % Update the currently available dependent variables listbox
    set( handles.depAvailableListbox, 'String', currAvail );
    set( handles.depAvailableListbox, 'Value', length( currAvail ) );
    % Update the currently selected listbox
    set( handles.depSelectedListbox, 'String', currSelected );
    set( handles.depSelectedListbox, 'Value', length( currSelected ) );
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in removeDepButton.
function removeDepButton_Callback(hObject, eventdata, handles)
% hObject    handle to removeDepButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

valueToRemove = handles.depSelectedValue;
if ( valueToRemove == 0 )
    error_gui( 'Title', 'Error: Selection required', 'Need to choose a selected dependent variable to remove' );
elseif isempty( valueToRemove )
    error_gui( 'Title', 'Error detected', 'Trying to remove a selected dependent variable that does not exist' );
else
    % Get the dependent variable currently selected
    depSelected = get( handles.depSelectedListbox, 'String' );
    depToRemove = depSelected{ valueToRemove };
    % Remove the dependent variable
    depSelected = {depSelected{1:valueToRemove-1} depSelected{valueToRemove+1:end}};
    
    % Get the list of dependent variables currently available
    % and add to it
    currAvail = get( handles.depAvailableListbox, 'String' );
    currAvail = {currAvail{1:end} depToRemove};
    set( handles.depAvailableListbox, 'String', currAvail );
    set( handles.depAvailableListbox, 'Value', length( currAvail ) );
       
    newVal = length( depSelected );
    set( handles.depSelectedListbox, 'Value', newVal );
    if ( newVal == 0 )
        set( handles.depSelectedListbox, 'String', {} );
    else
        set( handles.depSelectedListbox, 'String', depSelected );
    end
end

% Reset the dependent listbox values
handles.depSelectedValue = 0;
handles.depAvailValue = 0;

% Update handles structure
guidata( hObject, handles );

% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = clear_confirm('Title', 'Confirm reset'); % Pops up the clear all confirmation window
switch user_response
    case {'Yes'} % Want to clear all entries
        % Set up the displayed values in the two listboxes
        set( handles.depAvailableListbox, 'String', handles.currAvailOrig );
        set( handles.depSelectedListbox, 'String', handles.currSelectedOrig );
        
        % Initialise the values used in the listboxes
        handles.depAvailValue = 0;
        handles.depSelectedValue = 0;
    case {'No'} % Do not want to clear entries
        % Do nothing
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in proceedButton.
function proceedButton_Callback(hObject, eventdata, handles)
% hObject    handle to proceedButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Do the checks, then proceed
if ( length( get( handles.depSelectedListbox, 'String' ) ) < 1 )
    % No dependent variables selected
    error_gui( 'Title', 'Unable to proceed', 'Need to select at least one dependent variable' );
else
    handles.output = get( handles.depSelectedListbox, 'String' );
    guidata( hObject, handles );
    
    uiresume( handles.figure1 );
end
