function varargout = freeVarsControl(varargin)
% FREEVARSCONTROL M-file for freeVarsControl.fig
%      FREEVARSCONTROL, by itself, creates a new FREEVARSCONTROL or raises the existing
%      singleton*.
%
%      H = FREEVARSCONTROL returns the handle to a new FREEVARSCONTROL or the handle to
%      the existing singleton*.
%
%      FREEVARSCONTROL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FREEVARSCONTROL.M with the given input arguments.
%
%      FREEVARSCONTROL('Property','Value',...) creates a new FREEVARSCONTROL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before freeVarsControl_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to freeVarsControl_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help freeVarsControl

% Last Modified by GUIDE v2.5 16-Jan-2005 11:22:27

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @freeVarsControl_OpeningFcn, ...
                   'gui_OutputFcn',  @freeVarsControl_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before freeVarsControl is made visible.
function freeVarsControl_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to freeVarsControl (see VARARGIN)

freeVarsAllOrig = varargin{1};
currAvail = varargin{2};
currSelected = varargin{3};

% Check that the free variable that was selected is still available after any updates
listUnavailable = {};
for cSelect = 1:length( currSelected )
    selectIndiv = currSelected{cSelect};
    if ( sum( strcmp( selectIndiv, currAvail ) ) ~= 1 )
        % free variable that was previously selected is no longer
        % available
        error_gui( 'Title', 'Warning: Previously selected free variable unavailable',...
                    ['Free variable ' selectIndiv ' is no longer available due to a configuration change that you have made' ] );
        listUnavailable = {listUnavailable{1:end} selectIndiv};
    end
end

% Update the currently selected list, removing any free variables that are no longer available 
for remFree = 1:length( listUnavailable )
    whereFound = find( strcmp( currSelected, listUnavailable{remFree} ) );
    currSelected = {currSelected{1:whereFound(1)-1} currSelected{whereFound(1)+1:end}};
end

% Update the list of variables that are still available
stillAvail = {};
for cAvail = 1:length( currAvail )
    selectAvail = currAvail{ cAvail };
    valueOfSeen = sum( strcmp( selectAvail, currSelected ) );
    if (  valueOfSeen < 1 )
        % ie. this variable is not currently selected/chosen
        stillAvail = {stillAvail{1:end} selectAvail};
    elseif isequal( selectAvail, 'Agent' ) 
        % We have this currently selected and it is an agent
        if ( valueOfSeen == 1 )
            % Agent is selected only once
            stillAvail = {stillAvail{1:end} selectAvail};
        else
            % Agent is selected twice, don't do anything.
            % We could actually leave out this else case,
            % but I'm just being explicit about it.
        end
    end
end

handles.stillAvailOrig = stillAvail; % Original list of free variables still available
handles.currSelectedOrig = currSelected; % Original list of free variables selected

% Set these to the listboxes
set( handles.freeAvailableListbox, 'String', stillAvail );
set( handles.freeSelectedListbox, 'String', currSelected );
% Initialise the values used in the listboxes
handles.freeAvailValue = 0;
handles.freeSelectedValue = 0;

% Choose default command line output for freeVarsControl
handles.output = hObject;

% Update handles structure
guidata( hObject, handles );

% UIWAIT makes freeVarsControl wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = freeVarsControl_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% Close the figure
delete( handles.figure1 );

% --- Executes on selection change in freeAvailableListbox.
function freeAvailableListbox_Callback(hObject, eventdata, handles)
% hObject    handle to freeAvailableListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns freeAvailableListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from freeAvailableListbox

handles.freeAvailValue = get( hObject, 'Value' );

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function freeAvailableListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to freeAvailableListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in freeSelectedListbox.
function freeSelectedListbox_Callback(hObject, eventdata, handles)
% hObject    handle to freeSelectedListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns freeSelectedListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from freeSelectedListbox

handles.freeSelectedValue = get( hObject, 'Value' );

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function freeSelectedListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to freeSelectedListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in addFreeButton.
function addFreeButton_Callback(hObject, eventdata, handles)
% hObject    handle to addFreeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Check that a free variable has been selected from the listbox
valueToAdd = handles.freeAvailValue;
if ( valueToAdd == 0 )
    error_gui( 'Title', 'Error: Selection required', 'Need to choose an available free variable to add' );
elseif isempty( valueToAdd )
    error_gui( 'Title', 'Error detected', 'Trying to add a free variable that does not exist' );
elseif ( length( get( handles.freeSelectedListbox, 'String' ) ) == 2 )
    error_gui( 'Title', 'Error: Unable to continue', 'Can only have a maximum of two free variables selected' );
else
    % Remove from the free variables available listbox

    % Get the currently available free variables and the one that the user
    % selected
    currAvail = get( handles.freeAvailableListbox, 'String' );
    freeToAdd = currAvail{ valueToAdd }; % User selected
    % Get the currently selected free variables
    currSelected = get( handles.freeSelectedListbox, 'String' );
    
    if ( isequal( freeToAdd, 'Agent' ) )
        if ( sum( strcmp( freeToAdd, currSelected ) ) == 1 )
            % If we have already added one agent
            % Need to remove it from the list
            currAvail = {currAvail{1:valueToAdd-1} currAvail{valueToAdd+1:end}};
        else
            % Have not added one before, do not add it
            % This is because we can have agent twice as a free variable
        end
    else
        % It is not an agent - remove it
        currAvail = {currAvail{1:valueToAdd-1} currAvail{valueToAdd+1:end}};
    end
    
    % Update the currently free list
    set( handles.freeAvailableListbox, 'String', currAvail );
    set( handles.freeAvailableListbox, 'Value', length( currAvail ) );
    % Add it to the currently selected list and update it
    currSelected = {currSelected{1:end} freeToAdd};
    set( handles.freeSelectedListbox, 'String', currSelected );
    set( handles.freeSelectedListbox, 'Value', length( currSelected ) );
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in removeFreeButton.
function removeFreeButton_Callback(hObject, eventdata, handles)
% hObject    handle to removeFreeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% First check that a value is selected in the listbox
valueToRemove = handles.freeSelectedValue;
if ( valueToRemove == 0 )
    error_gui( 'Title', 'Error: Selection required', 'Need to choose a selected free variable to remove' );
elseif isempty( valueToRemove )
    error_gui( 'Title', 'Error detected', 'Trying to remove a selected free variable that does not exist' );
else
    % Get the list of free variables currently selected
    freeSelected = get( handles.freeSelectedListbox, 'String' );
    freeToRemove = freeSelected{ valueToRemove }; % User selected
    % Get the list of free variables currently available
    currAvail = get( handles.freeAvailableListbox, 'String' );
    
    if ( isequal( freeToRemove, 'Agent' ) )
        if ( sum( strcmp( freeToRemove, freeSelected ) ) == 1 )
            % If we have only added one agent, then still is listed in the 
            % available listbox and thus we don't need to remove it
        else
            % Two agents are listed, removing one means we need to add 
            % to the available listbox
            currAvail = {currAvail{1:end} freeToRemove };
            set( handles.freeAvailableListbox, 'String', currAvail );
            set( handles.freeAvailableListbox, 'Value', length( currAvail ) );
          end
    else
        % It is not an agent - add to the available listbox
        currAvail = {currAvail{1:end} freeToRemove };        
        set( handles.freeAvailableListbox, 'String', currAvail );
        set( handles.freeAvailableListbox, 'Value', length( currAvail ) );
      end    
    
    % Remove the selected free variable from the selected listbox and
    % update the listbox
    freeSelected = {freeSelected{1:valueToRemove-1} freeSelected{valueToRemove+1:end} };
    newVal = length( freeSelected );
    set( handles.freeSelectedListbox, 'Value', newVal );
    if ( newVal == 0 )
        set( handles.freeSelectedListbox, 'String', {} );
    else
        set( handles.freeSelectedListbox, 'String', freeSelected );
    end
end

% Reset the dependent listbox values
handles.freeSelectedValue = 0;
handles.freeAvailValue = 0;

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = clear_confirm('Title', 'Confirm reset'); % Pops up the clear all confirmation window
switch user_response
    case {'Yes'} % Want to clear all entries
        % Set up the displayed values in the two 'selected' variables listboxes
        set( handles.freeAvailableListbox, 'String', handles.stillAvailOrig );
        set( handles.freeSelectedListbox, 'String', handles.currSelectedOrig );
        
        % Initialise the values used in the listboxes
        handles.freeAvailValue = 0;
        handles.freeSelectedValue = 0;
    case {'No'} % Do not want to clear entries
        % Do nothing
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in proceedButton.
function proceedButton_Callback(hObject, eventdata, handles)
% hObject    handle to proceedButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Do the checks, then proceed
if ( length( get( handles.freeSelectedListbox, 'String' ) ) < 1 )
    % No free variables selected
    error_gui( 'Title', 'Unable to proceed', 'Need to select at least one free variable' );
else
    handles.output = get( handles.freeSelectedListbox, 'String' );
    guidata( hObject, handles );
    
    uiresume( handles.figure1 );
end
