function varargout = game_popup(varargin)
% GAME_POPUP M-file for game_popup.fig
%      GAME_POPUP, by itself, creates a new GAME_POPUP or raises the existing
%      singleton*.
%
%      H = GAME_POPUP returns the handle to a new GAME_POPUP or the handle to
%      the existing singleton*.
%
%      GAME_POPUP('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GAME_POPUP.M with the given input arguments.
%
%      GAME_POPUP('Property','Value',...) creates a new GAME_POPUP or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before game_popup_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to game_popup_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help game_popup

% Last Modified by GUIDE v2.5 08-Nov-2004 20:18:03

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @game_popup_OpeningFcn, ...
                   'gui_OutputFcn',  @game_popup_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before game_popup is made visible.
function game_popup_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to game_popup (see VARARGIN)

% Save the global parameters for future use
global MALT_HOME;
handles.globalMALT_HOME = MALT_HOME;

global STORAGE_DIRECTORY;
handles.globalSTORAGE_DIRECTORY = STORAGE_DIRECTORY;

currGame = varargin{1}; % Structure of the game that is passed in
handles.gameName = currGame.name;
handles.nActions = currGame.totalActions(1);

% Get the descriptions of the game
[paraString, descString, funcString, minGmActions, maxGmActions] = game_default( currGame.name );
initialText = '';

if ~isempty( currGame.gamutCommand )
   % This is an existing game, take the existing parameters
   paraString = currGame.gamutCommand;
end

findActions = findstr( paraString, '-actions' ); % Find the string '-actions'
if ( ~isequal( findActions, [] ) )
   % Number of actions is required for this game
   % Now if this is the first time we are creating this, then we can just
   % replace '-actions B' with '-actions handles.nActions'
   if isequal( paraString( findActions+9:findActions+9 ), 'B' )
       % Then do the swop
       paraString = [paraString(1:findActions+8) num2str( handles.nActions ) paraString(findActions+10:end)];
       % If the game is an old creation, then we don't do anything
   end
end

findPlayers = findstr( paraString, '-players' ); % Find the string '-players'
if ( ~isequal( findPlayers, [] ) )
    % Number of players is required for this games
    if isequal( paraString( findPlayers+9:findPlayers+9 ), 'A' ) 
        % Then do a swop
        paraString = [paraString(1:findPlayers+8) '2' paraString(findPlayers+10:end)];
        % If the game is an old creation, then we don't do anything
    end
end
    
handles.origParameters = paraString;
% Set the strings of the textbox and listbox
set( handles.parametersGame, 'String', paraString );
set( handles.descriptionListBox, 'String', descString );

% If there are no descriptions, then make the boxes invisible
if isempty( paraString ) 
    set( handles.parametersGame, 'Visible', 'off' );
end
if isempty( funcString )
    set( handles.functionListBox, 'Visible', 'off' );
end
set( handles.functionListBox, 'String', funcString );

handles.windowGame = currGame; % Save in handles for use in other functions

% Choose default command line output for agent_gui
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);
% Make the GUI modal
set( hObject, 'WindowStyle', 'modal' );

% UIWAIT makes agent_gui wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = game_popup_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% The figure can be deleted now
delete(handles.figure1);


% --- Executes during object creation, after setting all properties.
function parametersGame_CreateFcn(hObject, eventdata, handles)
% hObject    handle to parametersGame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function parametersGame_Callback(hObject, eventdata, handles)
% hObject    handle to parametersGame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of parametersGame as text
%        str2double(get(hObject,'String')) returns contents of parametersGame as a double


% --- Executes during object creation, after setting all properties.
function descriptionListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to descriptionListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in descriptionListBox.
function descriptionListBox_Callback(hObject, eventdata, handles)
% hObject    handle to descriptionListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns descriptionListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from descriptionListBox


% --- Executes during object creation, after setting all properties.
function functionListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to functionListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in functionListBox.
function functionListBox_Callback(hObject, eventdata, handles)
% hObject    handle to functionListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns functionListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from functionListBox


% --- Executes on button press in acceptButton.
function acceptButton_Callback(hObject, eventdata, handles)
% hObject    handle to acceptButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

currGame = handles.windowGame;
paraString = get( handles.parametersGame, 'String' );
currGame.gamutCommand = paraString;

% Parse the gamutCommand, to ensure that it is valid
% Run Gamut to confirm the results
javaRun = [handles.globalMALT_HOME 'extProgs/gamut.jar'];
fLocation = [handles.globalMALT_HOME handles.globalSTORAGE_DIRECTORY '/temp/checkedGame.tmp'];
[s, w] = system( ['java -jar ' javaRun ' -g ' currGame.name ' -f ' fLocation ' ' currGame.gamutCommand] );
if (s == 0)
    % The parameters for Gamut are correct, so save the game parameters and
    % return it all

	% See if the actions are in here - we need to update them!
	findActions = findstr( paraString, '-actions' ); % Find the string '-actions'
	if ( ~isequal( findActions, [] ) )
	   % Number of actions is required for this game
		% We want to update the totalActions
		findDashAll = findstr( paraString( findActions+9:end ), '-' ); % This finds all the dashes
		if isequal( findDashAll, [] )
			% -actions is the last parameter
			newActs = str2num( paraString( findActions+9:end ) );
		else
			findDash = findDashAll(1); % This just takes the first dash
			newActs = str2num( paraString( findActions+9:findActions+findDash+6 ) );
		end
		currGame.totalActions = repmat( newActs, 1, 2 );
	end

    % Set the output to the modified agent
    handles.output = currGame;
    % Update handles structure
    guidata(hObject, handles);
    % Use UIRESUME instead of delete because the OutputFcn needs
    % to get the updated handles structure.
    uiresume(handles.figure1);
else
    % Gamut parameters isn't correct - need to return the error messages
%    error_gamut('Title', 'Incorrect Gamut parameters', w);
    error_gamut('Title', 'Incorrect Gamut parameters', w);
end 

% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = clear_confirm('Title', 'Confirm reset'); % Pops up the clear all confirmation window

switch user_response
    case {'Yes'} % Want to clear all entries
        set( handles.parametersGame, 'String', handles.origParameters );
        if isempty( handles.origParameters )
            set( handles.parametersGame, 'Visible', 'off' );
        end
        guidata(hObject, handles);

    case {'No'} % Don't want to clear entries
end

