function varargout = gamesControl(varargin)
% GAMESCONTROL M-file for gamesControl.fig
%      GAMESCONTROL, by itself, creates a new GAMESCONTROL or raises the existing
%      singleton*.
%
%      H = GAMESCONTROL returns the handle to a new GAMESCONTROL or the handle to
%      the existing singleton*.
%
%      GAMESCONTROL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GAMESCONTROL.M with the given input arguments.
%
%      GAMESCONTROL('Property','Value',...) creates a new GAMESCONTROL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gamesControl_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gamesControl_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help gamesControl

% Last Modified by GUIDE v2.5 21-Jan-2005 19:03:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gamesControl_OpeningFcn, ...
                   'gui_OutputFcn',  @gamesControl_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gamesControl is made visible.
function gamesControl_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gamesControl (see VARARGIN)

% Save original values of the listboxes when first read in
origGames = varargin{1};
handles.origGames = origGames;
currSelected = varargin{2};
handles.origSelected = currSelected;

avail = {};
for cGm = 1:length( origGames )
    actGame = origGames{cGm};
    if ( sum( strcmp( actGame, currSelected ) ) == 0 )
        avail = {avail{1:end} actGame};
    end
end

handles.origAvailable = avail;

% Sets the available game's listbox
if isempty( avail )
    set( handles.gamesAvailableListbox, 'String', {} );
else
    set( handles.gamesAvailableListbox, 'String', avail );
end
handles.gameAvailableValue = [];

% Sets the currently selected game's listbox
if isempty( currSelected )
    set( handles.gamesSelectedListbox, 'String', {} );
else
    set( handles.gamesSelectedListbox, 'String', currSelected );
end
handles.gameSelectedValue = [];

% Choose default command line output for gamesControl
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gamesControl wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gamesControl_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
% Close the figure
delete( handles.figure1 );

% --- Executes on selection change in gamesAvailableListbox.
function gamesAvailableListbox_Callback(hObject, eventdata, handles)
% hObject    handle to gamesAvailableListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns gamesAvailableListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from gamesAvailableListbox

handles.gameAvailableValue = get( hObject, 'Value' );

% Update data
guidata( hObject, handles );

% --- Executes during object creation, after setting all properties.
function gamesAvailableListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gamesAvailableListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in gamesSelectedListbox.
function gamesSelectedListbox_Callback(hObject, eventdata, handles)
% hObject    handle to gamesSelectedListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns gamesSelectedListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from gamesSelectedListbox

handles.gameSelectedValue = get( hObject, 'Value' );

% Update data
guidata( hObject, handles );

% --- Executes during object creation, after setting all properties.
function gamesSelectedListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gamesSelectedListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in addGameButton.
function addGameButton_Callback(hObject, eventdata, handles)
% hObject    handle to addGameButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% First check that a value has been chosen
numbChosen = handles.gameAvailableValue;
if ( numbChosen == 0 )
    error_gui( 'Title', 'Error detected', 'Please select a game from the "Available" listbox' );
elseif isempty( numbChosen )
    error_gui( 'Title', 'Error detected', 'Trying to add a game that does not exist' );
else
    % Get the list of games available
    gamesStillAvail = get( handles.gamesAvailableListbox, 'String' );
    gameChosen = gamesStillAvail{ numbChosen};
    
    % Get the list of games currently selected
    gamesSelected = get( handles.gamesSelectedListbox, 'String' );
    % Update the list, resave it
    gamesSelected = {gamesSelected{1:end} gameChosen};
    lengthSelected = length( gamesSelected );
    set( handles.gamesSelectedListbox, 'Value', lengthSelected );
    if ( lengthSelected == 0 )
        set( handles.gamesSelectedListbox, 'String', {} );
    else
        set( handles.gamesSelectedListbox, 'String', gamesSelected );
    end
    
    % Remove from the available list and resave it
    gamesStillAvail = { gamesStillAvail{1:numbChosen-1} gamesStillAvail{numbChosen+1:end} };
    newLength = length( gamesStillAvail );
    set( handles.gamesAvailableListbox, 'Value', newLength );
    if ( newLength == 0 )
        set( handles.gamesAvailableListbox, 'String', {} );
    else
        set( handles.gamesAvailableListbox, 'String', gamesStillAvail );
    end
end

% Reset the values
handles.gameAvailableValue = 0;
handles.gameSelectedValue = 0;

% Save the GUI data
guidata( hObject, handles );
    
% --- Executes on button press in removeGameButton.
function removeGameButton_Callback(hObject, eventdata, handles)
% hObject    handle to removeGameButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% First check that a value has been chosen
numbChosen = handles.gameSelectedValue;
if ( numbChosen == 0 )
    error_gui( 'Title', 'Error detected', 'Please select a game from the "Selected" listbox' );
elseif isempty( numbChosen ) 
    error_gui( 'Title', 'Error detected', 'Trying to remove game that does not exist' );
else
    % Get the list of games currently selected
    gamesSelected = get( handles.gamesSelectedListbox, 'String' );       
    gameChosen = gamesSelected{ numbChosen };

    % Get the list of games available
    gamesStillAvail = get( handles.gamesAvailableListbox, 'String' );
    % Update the list, resave it
    gamesStillAvail = {gamesStillAvail{1:end} gameChosen};
    availLength = length( gamesStillAvail );
    set( handles.gamesAvailableListbox, 'Value', availLength );
    if ( availLength == 0)
        set( handles.gamesAvailableListbox, 'String', {} );
    else
        set( handles.gamesAvailableListbox, 'String', gamesStillAvail );
    end
        
    % Remove from the selected list and resave it
    gamesSelected = { gamesSelected{1:numbChosen-1} gamesSelected{numbChosen+1:end} };
    newLength = length( gamesSelected );
    set( handles.gamesSelectedListbox, 'Value', newLength );
    if ( newLength == 0 )
        set( handles.gamesSelectedListbox, 'String', {} );
    else
        set( handles.gamesSelectedListbox, 'String', gamesSelected );
    end
end

% Reset the values
handles.gameAvailableValue = 0;
handles.gameSelectedValue = 0;

% Save the GUI data
guidata( hObject, handles );    

% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = clear_confirm( 'Title', 'Confirm reset' ); % Popup confirmation window
switch user_response
case {'Yes'}
    % Reset the two listboxes to their original state
    set( handles.gamesAvailableListbox, 'String', handles.origAvailable );
    set( handles.gamesAvailableListbox, 'Value', length( handles.origAvailable ) );
    set( handles.gamesSelectedListbox, 'Value', length( handles.origSelected ) );
    if isempty( handles.origSelected )
            set( handles.gamesSelectedListbox, 'String', {} );
    else
            set( handles.gamesSelectedListbox, 'String', handles.origSelected );
    end
case {'No'}
    % Do not do anything, no reset wanted
end

% Save the GUI data
guidata( hObject, handles );


% --- Executes on button press in acceptButton.
function acceptButton_Callback(hObject, eventdata, handles)
% hObject    handle to acceptButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isempty( get( handles.gamesSelectedListbox, 'String' ) )
    error_gui( 'Title', 'Unable to continue', 'Require at least one game to be selected' );
else
    handles.output = get( handles.gamesSelectedListbox, 'String' ); % Set output
    guidata( hObject, handles); % Save data 

    uiresume( handles.figure1 );
end