function allData = getDataPortion( allData, freeDimension, whichOne )

% Name: getDataPortion.m
% Location: MALT/GUI/getDataPortion.m
% Purpose:  Gets a specific set of data from a 4d matrix
%           This is specifically used in the agg_visual_final files
%                of visualisation objects
% Input Parameters:  the 4d matrix
%                    dimension of the 4d matrix that the variable corresponds to
%                    which element of that free variable
% Output Parameters: the specific data elements corresponding to those variables

switch freeDimension
case 1
	allData = allData( whichOne, :, :, : );
case 2
	allData = allData( :, whichOne, :, : );
case 3
	allData = allData( :, :, whichOne, : );
case 4
	allData = allData( :, :, :, whichOne );
end

