function varargout = iterationsControl(varargin)
% ITERATIONSCONTROL M-file for iterationsControl.fig
%      ITERATIONSCONTROL, by itself, creates a new ITERATIONSCONTROL or raises the existing
%      singleton*.
%
%      H = ITERATIONSCONTROL returns the handle to a new ITERATIONSCONTROL or the handle to
%      the existing singleton*.
%
%      ITERATIONSCONTROL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ITERATIONSCONTROL.M with the given input arguments.
%
%      ITERATIONSCONTROL('Property','Value',...) creates a new ITERATIONSCONTROL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before iterationsControl_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to iterationsControl_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help iterationsControl

% Last Modified by GUIDE v2.5 21-Jan-2005 12:52:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @iterationsControl_OpeningFcn, ...
                   'gui_OutputFcn',  @iterationsControl_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before iterationsControl is made visible.
function iterationsControl_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to iterationsControl (see VARARGIN)

% Save original values of the listboxes when first read in
origIterations = varargin{1};
handles.origIterationsFrom = origIterations(1);
handles.origIterationsTo = origIterations(2);
currIterations = varargin{2};
% Check if values have been included before or not
if isempty( currIterations )
	 % Values are empty
    handles.currIterationsFrom = num2str( handles.origIterationsFrom );
    handles.currIterationsTo = num2str( handles.origIterationsTo );
    handles.endIterationsFrom = 1;
    handles.endIterationsTo = 1;
else
	 % Values have been changed before
	 handles.currIterationsFrom = currIterations(1);
    handles.currIterationsTo = currIterations(2);
    handles.endIterationsFrom = 1;
    handles.endIterationsTo = 1;
end    
    
% Set the various edit boxes and maximum iteration info box
set( handles.iterationsFrom, 'String', handles.currIterationsFrom );
set( handles.iterationsTo, 'String', handles.currIterationsTo );
set( handles.iterationsStoredEdit, 'String', ['Total iterations stored is ' num2str( origIterations(2) )] );

% Choose default command line output for iterationsControl
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes iterationsControl wait for user response (see UIRESUME)
 uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = iterationsControl_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
% Close the figure
delete( handles.figure1 );

% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = clear_confirm( 'Title', 'Confirm reset' ); % Popup confirmation window
switch user_response
case {'Yes'}
    % Reset the two edit boxes to their original state
    set( handles.iterationsFrom, 'String', num2str( handles.currIterationsFrom ) );
    set( handles.iterationsTo, 'String', num2str( handles.currIterationsTo ) );
    handles.endIterationsFrom = 1;
    handles.endIterationsTo = 1;
    handles.validAnswers = 1;
case {'No'}
    % Do not do anything, no reset wanted
end

% Save the GUI data
guidata( hObject, handles );


% --- Executes on button press in acceptButton.
function acceptButton_Callback(hObject, eventdata, handles)
% hObject    handle to acceptButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Check that the from and the to values have both been set
 if ( ( handles.endIterationsFrom ) && ( handles.endIterationsTo ) )
     outPt = [str2num( get( handles.iterationsFrom, 'String' ) ) str2num( get( handles.iterationsTo, 'String' ) )]; % Set output
    handles.output = outPt;
    guidata( hObject, handles); % Save data 

    uiresume( handles.figure1 );
end    

function iterationsFrom_Callback(hObject, eventdata, handles)
% hObject    handle to iterationsFrom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iterationsFrom as text
%        str2double(get(hObject,'String')) returns contents of iterationsFrom as a double

editFrom = get( hObject, 'String' );
editFromNum = str2num( editFrom );

% This is a bit of a hack
handles.endIterationsFrom = 0;
guidata( hObject, handles )

% Check if from bound has been set
if isempty( editFromNum )
	 handles.endIterationsFrom = 0;
    error_gui( 'Title', 'Error detected', 'From iteration number must be an integer' );
    set( hObject, 'String', num2str( handles.currIterationsFrom ) );
	 % Check that from bound is in the range [1 max]
elseif ( ( editFromNum < 1 ) || (editFromNum > str2num( get( handles.iterationsTo, 'String' ) ) ) )
handles.endIterationsFrom = 0;
    error_gui( 'Title', 'Error detected', ['From iteration number must be in the range [1, ' get( handles.iterationsTo, 'String' ) ']'] );
    set( hObject, 'String', num2str( handles.currIterationsFrom ) );
elseif ( mod( editFromNum, 1 ) ~= 0 ) % Check from bound is an integer
handles.endIterationsFrom = 0;
    error_gui( 'Title', 'Error detected', 'From iteration number must be an integer' );
    set( hObject, 'String', num2str( handles.currIterationsFrom ) );
else
	 handles.endIterationsFrom = 1;
end

% Save the data
guidata( hObject, handles );


% --- Executes during object creation, after setting all properties.
function iterationsFrom_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iterationsFrom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function iterationsTo_Callback(hObject, eventdata, handles)
% hObject    handle to iterationsTo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iterationsTo as text
%        str2double(get(hObject,'String')) returns contents of iterationsTo as a double

% Get the To bound
editTo = get( hObject, 'String' );
editToNum = str2num( editTo );

if isempty( editToNum ) % Check To bound is not empty
    error_gui( 'Title', 'Error detected', 'To iteration number must be an integer' );
 	 handles.endIterationsTo = 0;
    set( hObject, 'String', num2str( handles.currIterationsTo ) );
	 % Check whether To bound is in range [FromBound toBoundMax]
elseif ( ( editToNum > handles.origIterationsTo ) || ( editToNum < str2num( get( handles.iterationsFrom, 'String' ) ) ) )
	 handles.endIterationsTo = 0;
    error_gui( 'Title', 'Error detected', ['To iteration number must be in the range of [From Iteration,' num2str( handles.origIterationsTo ) ']' ] );
    set( hObject, 'String', num2str( handles.currIterationsTo ) );    
elseif ( mod( editToNum, 1 ) ~= 0 ) % Check To bound is an integer
	 handles.endIterationsTo = 0;
    error_gui( 'Title', 'Error detected', 'To iteration number must be an integer' );
    set( hObject, 'String', num2str( handles.currIterationsTo ) );    
else
	 handles.endIterationsTo = 1;
end

% Save the data
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function iterationsTo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iterationsTo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


