function varargout = malt_gui(varargin)
% MALT_GUI M-file for malt_gui.fig
%      MALT_GUI, by itself, creates a new MALT_GUI or raises the existing
%      singleton*.
%
%      H = MALT_GUI returns the handle to a new MALT_GUI or the handle to
%      the existing singleton*.
%
%      MALT_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MALT_GUI.M with the given input arguments.
%
%      MALT_GUI('Property','Value',...) creates a new MALT_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before malt_gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to malt_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help malt_gui

% Last Modified by GUIDE v2.5 14-Dec-2004 15:15:57

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @malt_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @malt_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before malt_gui is made visible.
function malt_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to malt_gui (see VARARGIN)
clc
handles.agentList = {};
handles.gameList = {};
handles.metricList = {};
handles.freqArray = [];
handles.parameter = {};
handles.dataItems = {};
handles.sessionType = '';

% Future update may be to automatically read in a list of
% possible agents, games and metrics

% Initialise the agent, game, metric that is selected
allAgents = get( handles.agentPopup, 'String' );
allGames = get( handles.gamePopup, 'String' );
handles.currentAgent = allAgents{1};
handles.currentGame = allGames{1};
handles.currentMetric = '';
handles.metricSelected = 0;
% Initialise counter values for the listbox
handles.agentSelectedInListBox = 0;
handles.gameSelectedInListBox = 0;
handles.metricSelectedInListBox = 0;

% Choose default command line output for malt_gui
handles.output = hObject;

% Make global variables visibles
global MALT_HOME; % Global variable for home directory of MALT
handles.malt_home = MALT_HOME;

global STORAGE_DIRECTORY;
handles.globalSTORAGE_DIRECTORY = STORAGE_DIRECTORY;

% Create a temporary parameter structure
tParamStruct = struct( 'runs', [], 'totalIterations', [], 'settleIterations', [] );
handles.paramStruct = tParamStruct;

% Update handles structure
guidata(hObject, handles);

% Note: this GUI is not modal

% --- Outputs from this function are returned to the command line.
function varargout = malt_gui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function agentPopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to agentPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in agentPopup.
function agentPopup_Callback(hObject, eventdata, handles)
% hObject    handle to agentPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns agentPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from agentPopup

% Get the name of the agent that is selected, from the popup
allAgents = get( hObject, 'String' );
handles.currentAgent = allAgents{get( hObject, 'Value' )};

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function agentListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to agentListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in agentListBox.
function agentListBox_Callback(hObject, eventdata, handles)
% hObject    handle to agentListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns agentListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from agentListBox

% Need to get the value of the agent in the listbox - store it
handles.agentSelectedInListBox = get( hObject, 'Value' );

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in agentAddButton.
function agentAddButton_Callback(hObject, eventdata, handles)
% hObject    handle to agentAddButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% handles.currentAgent is the currently selected agent in the popup
tempAgnt = struct( [] ); % Create an empty agent structure for now

% We then send it to an agent_gui method - of which there is one per agent
% Since agents are objects, the relevant gui is called
% We create the function handle and then run/call it
agentGuiString = ['agent_gui_' handles.currentAgent];
fHandle = str2func(agentGuiString);
newAgent = feval(fHandle, tempAgnt );

% Then want to add the agent structure to the handles cell list of agent object
handles.agentList = {handles.agentList{1:end} newAgent};

% Add the newly created agent to the listbox
currAgentList = get( handles.agentListBox, 'String' );
if isa( currAgentList, 'char' ) % ie. no agents added yet
    if strcmp(currAgentList, 'Selected agents')
        % This is the first agent being added, remove the placeholder
		  % It needs to be added as a string
        set( handles.agentListBox, 'String', handles.currentAgent );
    else
        % There is one agent already in the list and it is a string,
		  % rather than a cell array
        set( handles.agentListBox, 'String', {currAgentList, handles.currentAgent} );
    end
else
    % Other agents added previously
	 % Can just add the new agent to the cell array
    newAgentList = { currAgentList{1:end} handles.currentAgent };
    set( handles.agentListBox, 'String', newAgentList );
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in agentModifyButton.
function agentModifyButton_Callback(hObject, eventdata, handles)
% hObject    handle to agentModifyButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

agentSet = handles.agentSelectedInListBox; % Get the number of the selected agent in the listbox
if (agentSet == 0)
    % No agent selected
    error_gui('Title', 'Error detected', 'Please select an agent to modify');
elseif ( agentSet > length( handles.agentList ) )
    % Trying to select an agent that doesn't exist
    error_gui('Title', 'Error detected', 'Attempt to select a non-existent agent');
else
    allAgents = handles.agentList; % All agents currently stored
    agentToModify = allAgents{agentSet}; % Get that number from the cell list

    agentGuiString = ['agent_gui_' agentToModify.algorithm]; % Determine the name of the GUI
    fHandle = str2func(agentGuiString); % Create a handle to the correct GUI
    modifiedAgent = feval(fHandle, agentToModify ); % Use the handle to run the correct GUI

    allAgents( agentSet ) = {modifiedAgent}; % Return to the all agent list
    handles.agentList = allAgents; % Resave the updated agent list in the handles structure
    
    % Update handles structure
    guidata(hObject, handles);
end

% --- Executes on button press in agentDeleteButton.
function agentDeleteButton_Callback(hObject, eventdata, handles)
% hObject    handle to agentDeleteButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = delete_confirm( 'Title', 'Confirm agent delete', 'agent' ); % Pops up the delete confirmation window

switch user_response
    case {'Yes'} % Want to delete the agent
        handles.agentSelectedInListBox = get( handles.agentListBox, 'value' ); % Get the number of the selected agent in the listbox
        agentSet = handles.agentSelectedInListBox;
        currAgentList = get( handles.agentListBox, 'String' ); % Get listbox of agents
        if (agentSet == 0)
            % Agent has not been selected in the listbox
            error_gui('Title', 'Error detected', 'Please select an agent to delete');
        elseif ( agentSet > length( handles.agentList ) )
            % Agent has not been re-selected, agentSet is out of the bounds
            error_gui('Title', 'Error detected', 'Please re-select an agent to delete');
        else
            allAgents = handles.agentList; % All agents currently stored
            
            allAgents = {allAgents{1:agentSet-1} allAgents{agentSet+1:end}}; % Removes agents from cell list
            handles.agentList = allAgents; % Return updated agent cell list to handles
            if ( isa( currAgentList, 'char' ) )
                % If deleted all agents, then replace agentListBox with default
                set( handles.agentListBox, 'String', 'Selected agents' );
            else
                newList = { currAgentList{1:agentSet-1} currAgentList{agentSet+1:end} };
                if ( length(newList) == 1 )
                    % If there is 1 agent list, agentListBox must be a string
                    set( handles.agentListBox, 'String', newList{1} );
                else
                    % If there is more than 1 agent, then just use the cell of
                    % strings
                    set( handles.agentListBox, 'String', newList );
                end
            end
            % Reset the value of the item selected in the listbox to 0
            set( handles.agentListBox, 'Value', 1 );
        end
    case {'No'} % Don't want to clear entries
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function gamePopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gamePopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in gamePopup.
function gamePopup_Callback(hObject, eventdata, handles)
% hObject    handle to gamePopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns gamePopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from gamePopup

% Get the name of the game that is selected
% Save that value to the handles list for later use
allGames = get( hObject, 'String' );
handles.currentGame = allGames{get( hObject, 'Value' )};

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in gameAddButton.
function gameAddButton_Callback(hObject, eventdata, handles)
% hObject    handle to gameAddButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get the number of actions from the inputted textbox
nActs = str2num( get( handles.nActions, 'String' ) );

if ( isempty( nActs ) | isequal( nActs, '0' ) )
    % Number of actions is blank or equal to 0
    error_gui('Title', 'Error detected', 'Please input a number of actions > 0');
else
    % Check which game has been selected, this is given in handles.currentGame
    % Create a temporary game structure out of it
    % handles.currentGame is the currently selected game in the game popup
    tempGame = struct( 'name', handles.currentGame, 'nAgents', 2,...
        'totalActions', repmat( nActs, 1, 2 ), 'gamutCommand', '',...
        'minActions', 0, 'maxActions', 0, 'fileName', '' );
 
    valid = checkGameValid( tempGame );
    
    if ( valid )
        % If the game and actions are valid, then we go through the process
        % of adding the game. If they are invalid, then we don't do
        % anything

        newGame = game_popup( tempGame );
        % Then want to add the game object to the handles cell list of game
        % objects
        handles.gameList = {handles.gameList{1:end} newGame};
    
        % Add the newly created game to the listbox
        currGameList = get( handles.gameListBox, 'String' );
        if isa( currGameList, 'char' ) % ie. no games added yet
            if strcmp(currGameList, 'Selected games')
                % This is the first game being added, remove the placeholder
                set( handles.gameListBox, 'String', handles.currentGame );
            else
                % There is one game already in the list
                set( handles.gameListBox, 'String', {currGameList, handles.currentGame} );
            end
        else
            % Other games added previously
            newGameList = { currGameList{1:end} handles.currentGame };
            set( handles.gameListBox, 'String', newGameList );
        end
    end

    % Update handles structure
    guidata(hObject, handles);
end


% --- Executes during object creation, after setting all properties.
function gameListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gameListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in gameListBox.
function gameListBox_Callback(hObject, eventdata, handles)
% hObject    handle to gameListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns gameListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from gameListBox

% Need to get the value of the agent in the listbox - store it
handles.gameSelectedInListBox = get( hObject, 'Value' );

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in gameModifyButton.
function gameModifyButton_Callback(hObject, eventdata, handles)
% hObject    handle to gameModifyButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

gameSet = handles.gameSelectedInListBox; % Get the number of the selected game in the listbox
if (gameSet == 0)
    % No agent selected
    error_gui('Title', 'Error detected', 'Please select a game to modify');
elseif ( gameSet > length( handles.gameList ) )
    % Trying to select an game that doesn't exist
    error_gui('Title', 'Error detected', 'Attempt to select a non-existent game');
else
    allGames = handles.gameList; % All games currently stored
    gameToModify = allGames{gameSet}; % Get that number from the cell list

    modifiedGame = game_popup( gameToModify ); % Run the GUI for games
    allGames( gameSet ) = {modifiedGame}; % Return to the all game list
    handles.gameList = allGames; % Resave the updated agent list in the handles structure
    
    % Update handles structure
    guidata(hObject, handles);
end


% --- Executes on button press in gameDelete.
function gameDelete_Callback(hObject, eventdata, handles)
% hObject    handle to gameDelete (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = delete_confirm( 'Title', 'Confirm game delete', 'game' ); % Pops up the delete confirmation window

switch user_response
    case {'Yes'} % Want to delete the game
        handles.gameSelectedInListBox = get( handles.gameListBox, 'value' ); % Get the number of the selected agent in the listbox
        gameSet = handles.gameSelectedInListBox;
        currGameList = get( handles.gameListBox, 'String' ); % Get listbox of agents
        if (gameSet == 0)
            % Agent has not been selected in the listbox
            error_gui('Title', 'Error detected', 'Please select a game to delete');
        elseif ( gameSet > length( handles.gameList ) )
            % Game has not been re-selected, gameSet is out of the bounds
            error_gui('Title', 'Error detected', 'Please re-select a game to delete');
        else
            allGames = handles.gameList; % All games currently stored
            
            allGames = {allGames{1:gameSet-1} allGames{gameSet+1:end}}; % Removes game from cell list
            handles.gameList = allGames; % Return updated game cell list to handles
            if ( isa( currGameList, 'char' ) )
                % If deleted all games, then replace gameListBox with default
                set( handles.gameListBox, 'String', 'Selected games' );
            else
                newList = { currGameList{1:gameSet-1} currGameList{gameSet+1:end} };
                if ( length(newList) == 1 )
                    % If there is 1 game in the list, gameListBox must be a string
                    set( handles.gameListBox, 'String', newList{1} );
                else
                    % If there is more than 1 game, then just use the cell of
                    % strings
                    set( handles.gameListBox, 'String', newList );
                end
            end
            % Reset the value of the item selected in the listbox to 0
            set( handles.gameListBox, 'Value', 1 );
        end
    case {'No'} % Don't want to clear entries
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function metricPopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to metricPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on selection change in metricPopup.
function metricPopup_Callback(hObject, eventdata, handles)
% hObject    handle to metricPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns metricPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from metricPopup

allMetrics = get( hObject, 'String' );
if ~isequal( allMetrics, 'Available metrics' )
    % ie. something to select
    handles.metricSelected = get( handles.metricPopup, 'Value' );
    handles.currentMetric = allMetrics{handles.metricSelected};

    % Update handles structure
    guidata(hObject, handles);
end
    
% --- Executes during object creation, after setting all properties.
function metricListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to metricListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in metricListBox.
function metricListBox_Callback(hObject, eventdata, handles)
% hObject    handle to metricListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns metricListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from metricListBox

% Need to get the value of the agent in the listbox - store it
handles.metricSelectedInListBox = get( hObject, 'Value' );

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in metricAddButton.
function metricAddButton_Callback(hObject, eventdata, handles)
% hObject    handle to metricAddButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% When we add metrics to the list, we add both the type of metric and the
% name of the actual metric

% First check that a metric has been selected and it was not reset by
% choosing a new type of metric
if ( handles.metricSelected == 0 )
    % Metric not selected properly. Use the error_gui to produce message
    error_gui( 'Title', 'Information not specified', 'Please select a metric to add' );
else
    % Metric correctly selected
    % Then check that the frequency is valid, ie. > 0
    if ( str2num( get( handles.metricFrequency, 'String' ) ) < 1 )
        error_gui( 'Title', 'Information not specified', 'Please use a valid frequency > 0' );
    else
        % Now have valid metric selected, valid frequency
        metricNumber = handles.metricSelected;
        allMetricNames = get( handles.metricPopup, 'String' );
        allMetricHandles = handles.metricHandles;
		  % Create a temporary metric structure with the details
        tempMetric = struct( 'name', allMetricNames{metricNumber},...
            'functionHandle', allMetricHandles{metricNumber},...
            'frequency',  str2num( get( handles.metricFrequency, 'String' ) ) );
        % Pass the structure to the metric popup GUI for updating
        newMetric = metric_popup( tempMetric );
        % Want to add the metric structure to the handles cell list of
        % metric strucutres. Also want to update the frequency list
        handles.metricList = {handles.metricList{1:end} newMetric};
        handles.freqArray = [handles.freqArray newMetric.frequency];

        % Add the newly create metric to the listbox
        currMetricList = get( handles.metricListBox, 'String' );
		  % But need to run through the possible cases for adding
        if isa( currMetricList, 'char' ) % ie no metrics added yet
            if strcmp(currMetricList, 'Selected metrics')
                % This is the first metric being added, remove the placeholder
                set( handles.metricListBox, 'String', [handles.typeMetric ':' handles.currentMetric] );
            else
                % There is one game already in the list
                newMetricList = {currMetricList [handles.typeMetric ':' handles.currentMetric]};
                set( handles.metricListBox, 'String', newMetricList );
            end
        else
            % Other metrics added previously
            newMetricList = {currMetricList{1:end} [handles.typeMetric ':' handles.currentMetric]};
            set( handles.metricListBox, 'String', newMetricList );
        end        
    end
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in metricModifyButton.
function metricModifyButton_Callback(hObject, eventdata, handles)
% hObject    handle to metricModifyButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

metricSet = handles.metricSelectedInListBox; % Get the number of the selected metric in the listbox
if ( metricSet == 0 )
    % No metric selected
    error_gui('Title', 'Error detected', 'Please select a metric to modify');
elseif ( metricSet > length( handles.metricList ) )
    % Trying to select a metric that doesn't exist
    error_gui('Title', 'Error detected', 'Attempt to select a non-existent metric');
else
	 % Valid selection made for a metric to edit
    allMetrics = handles.metricList; % All metrics currently stored
    metricToModify = allMetrics{metricSet}; % Get that number from the cell list

    modifiedMetric = metric_popup( metricToModify ); % Run the GUI for metrics
    allMetrics( metricSet ) = {modifiedMetric}; % Return to the all metric list
    allFrequencies = handles.freqArray; % Get all the frequencies that were stored
    allFrequencies( metricSet ) = modifiedMetric.frequency;
    handles.freqArray = allFrequencies; % Resave the updated frequency array in the handles structure
    handles.metricList = allMetrics; % Resave the updated metric list in the handles structure
    
    % Update handles structure
    guidata(hObject, handles);
end


% --- Executes on button press in metricDeleteButton.
function metricDeleteButton_Callback(hObject, eventdata, handles)
% hObject    handle to metricDeleteButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = delete_confirm( 'Title', 'Confirm metric delete', 'metric' ); % Pops up the delete confirmation window

switch user_response
    case {'Yes'} % Want to delete the metric
        handles.metricSelectedInListBox = get( handles.metricListBox, 'value' ); % Get the number of the selected metric in the listbox
        metricSet = handles.metricSelectedInListBox;
        currMetricList = get( handles.metricListBox, 'String' ); % Get listbox of metrics
        if ( metricSet == 0 )
            % Metric has not been selected in the listbox
            error_gui('Title', 'Error detected', 'Please select a metric to delete');
        elseif ( metricSet > length( handles.metricList ) )
            % Metric has not been re-selected, metricSet is out of the bounds
            error_gui('Title', 'Error detected', 'Please re-select a metric to delete');
        else
			  	% Valid metric selected from the list
            allMetrics = handles.metricList; % All metrics currently stored
            allMetrics = {allMetrics{1:metricSet-1} allMetrics{metricSet+1:end}}; % Removes metricss from cell list
            allFreqs = handles.freqArray;
            handles.freqArray = [allFreqs( 1:metricSet-1 ) allFreqs( metricSet+1:end )];
            handles.metricList = allMetrics; % Return updated metric cell list to handles
				% Need to run through the possible cases for deleting a metric
            if ( isa( currMetricList, 'char' ) )
                % If deleted all metrics, then replace metricListBox with default
                set( handles.metricListBox, 'String', 'Selected metrics' );
            else
                newList = { currMetricList{1:metricSet-1} currMetricList{metricSet+1:end} };
                if ( length(newList) == 1 )
                    % If there is 1 metric in the list, metricListBox must be a string
                    set( handles.metricListBox, 'String', newList{1} );
                else
                    % If there is more than 1 metric, then just use the cell of
                    % strings
                    set( handles.metricListBox, 'String', newList );
                end
            end
            % Reset the value of the item selected in the listbox to 0
            set( handles.metricListBox, 'Value', 1 );
        end
    case {'No'} % Don't want to clear entries
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function parameterRuns_CreateFcn(hObject, eventdata, handles)
% hObject    handle to parameterRuns (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function parameterRuns_Callback(hObject, eventdata, handles)
% hObject    handle to parameterRuns (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of parameterRuns as text
%        str2double(get(hObject,'String')) returns contents of parameterRuns as a double

tParam = handles.paramStruct;

currRuns = get( hObject, 'String' );
if isequal( str2num( currRuns ), [] ) % Check if input is valid
    error_gui('Title', 'Incorrect input', {[currRuns ' is not a valid integer'] ['Number of runs requires an integer']}) % Produce error GUI
else
    tParam.runs = str2num( currRuns ); % Save valid input
end
handles.paramStruct = tParam;

% Update handles structure
guidata(hObject, handles);
    
% --- Executes during object creation, after setting all properties.
function parameterIterations_CreateFcn(hObject, eventdata, handles)
% hObject    handle to parameterIterations (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function parameterIterations_Callback(hObject, eventdata, handles)
% hObject    handle to parameterIterations (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of parameterIterations as text
%        str2double(get(hObject,'String')) returns contents of parameterIterations as a double

tParam = handles.paramStruct;

currIterations = get( hObject, 'String' );
if isequal( str2num( currIterations ), [] ) % Check iterations is an integer
    error_gui('Title', 'Incorrect input', {[currIterations ' is not a valid integer'] ['Number of iterations requires an integer']}) % Produce error GUI
else
    tParam.totalIterations = str2num( currIterations ); % Save valid value
end
handles.paramStruct = tParam;

% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function parameterSettlingIn_CreateFcn(hObject, eventdata, handles)
% hObject    handle to parameterSettlingIn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function parameterSettlingIn_Callback(hObject, eventdata, handles)
% hObject    handle to parameterSettlingIn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of parameterSettlingIn as text
%        str2double(get(hObject,'String')) returns contents of parameterSettlingIn as a double

tParam = handles.paramStruct;

currSettle = get( hObject, 'String' );
if isequal( str2num( currSettle ), [] ) % Check settle value is valid
    error_gui('Title', 'Incorrect input', {[currSettle ' is not a valid integer'] ['Settling in Iterations requires an integer']}) % Produce error GUI
else
    tParam.settleIterations = str2num( currSettle ); % Save valid settle value
end
handles.paramStruct = tParam;

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function sessionPopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sessionPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in sessionPopup.
function sessionPopup_Callback(hObject, eventdata, handles)
% hObject    handle to sessionPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns sessionPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from sessionPopup

allSessionTypes = get( hObject, 'String' ); % Get the list of session types
chosenSession = allSessionTypes{ get( hObject, 'Value' ) };

handles.sessionType = chosenSession;

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
user_response = clear_confirm('Title', 'Confirm reset'); % Pops up the clear all confirmation window
switch user_response
    case {'Yes'} % Want to clear all entries
        % First reset the data in the listboxes and parameter info
        set( handles.agentListBox, 'String', 'Selected agents' );
        set( handles.agentListBox, 'Value', 1 );
        set( handles.gameListBox, 'String', 'Selected games' );
        set( handles.gameListBox, 'Value', 1 );
        set( handles.metricListBox, 'String', 'Selected metrics' );
        set( handles.metricListBox, 'Value', 1 );
        set( handles.parameterRuns, 'String', '' );
        set( handles.parameterIterations, 'String', '' );
        set( handles.parameterSettlingIn, 'String', '' );
        set( handles.nActions, 'String', '2' );
        % Second, reset all the GUI object lists
        handles.agentList = {};
        handles.gameList = {};
        handles.metricList = {};
        handles.parameter = {};
        handles.dataItems = {};
%        handles.howOften = {};
        handles.freqArray = [];
    case {'No'} % Don't want to clear entries
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in startButton.
function startButton_Callback(hObject, eventdata, handles)
% hObject    handle to startButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Make global variable visible
global SESSION_NAME

validityBit = checkGUIValid( handles );

if validityBit
    % Everything set correctly, can run the tests

    % Don't setup the agents to objects, as this is(will be) done in
    % tournament.m. This is to allow the agent to be instantiated with the
    % correct number of actions for that game
    % Don't setup the games to objects either, as this will be done in the
    % tournament.m method. This is to allow easy calling of Gambit and to
    % avoid file conflicts.

    % Ask the user for a session name
    % First popup the save window
	[fileName, pathName] = uiputfile( {'*.mat', 'MAT-files (*.mat)'}, 'Save a session file', [handles.malt_home handles.globalSTORAGE_DIRECTORY '/' date '_'] );

	if ~isequal( fileName, 0 )
	% ie. if the user DID NOT push cancel and set a valid file name

   	% Set the global variable
	   findSuffix = findstr( fileName, '.mat' ); % Find the .mat suffix
		if isempty( findSuffix )
	 		% User didn't use a .mat extension
			SESSION_NAME = fileName;
	 	else
	 		% User did use a .mat extension
	   	SESSION_NAME = fileName( 1:findSuffix-1 ); % remove the .mat suffix
	 	end

	   % Setup the displayname list of each agent
	   % Pass cell list of agent structures to a method that will add the
	   % correct display name -- done as a method to cleanup this part of the
	   % code
    	handles.agentList = createAgentDisplayNames( handles.agentList );

    	% Setup the parameter object
    	paramObj = createParamObj( handles );

    	% Create the directory
    	sessName = [pathName fileName];
    	[success, message, messageID] = mkdir([pathName SESSION_NAME]);
	 	printOut( sprintf( 'Attempt to create %s\nParameters:\nsuccess = %d\nmessage = %s\nmessageID = %s', [pathName SESSION_NAME], success, message, messageID ) );
	 	if isequal( messageID, 'MATLAB:MKDIR:DirectoryExists' )
	 		% Directory already exists
			% We want to clear it
			printOut( sprintf( 'Directory %s already exists and we need to delete its contents', SESSION_NAME ) );
			delete( [pathName SESSION_NAME '/*.*'] );
      end
	 
      % Clear out the extProgs directory of gambit and Gamut generated
      % game files
      delete( [handles.malt_home 'extProgs/*.gambit'] )
      delete( [handles.malt_home 'extProgs/*.simple'] )
      delete( [handles.malt_home 'extProgs/*.eqm'] )
      delete( [handles.malt_home 'extProgs/*.idr'] )
        
    	% Save the parameter object as the file
		% Ensure we save in Matlab version 6 compatibility
    	if ( str2num( version('-release') ) > 13 )
            save( sessName, 'paramObj', '-V6' );
    	else
        	save( sessName, 'paramObj' );
    	end

    	% Setup the metrics - need to instantiate the objects
    	% Want to create list with what is stored - this should only contain
    	% unique elements
    	[metricsObjCell, whatToSave] = createMetricsObjs( handles );

      % First make sure that the game file names can handle multiple
      % versions of the same generator
      handles.gameList = createGameFileNames( handles.gameList );

      % Since we are now going to be creating seperate run files for this, 
      % we pre-create all of the game objects into a #runs x #games cell
      nGames = length( handles.gameList );
      nRuns = get( paramObj, 'runs' );
      gameObjList = cell( nRuns, nGames );
      for cGame = 1:nGames
          for cRun = 1:nRuns
              gameStruct = handles.gameList{cGame}; % Get the current game structure
              % Update the fileName to be correct
              gameStruct.fileName = [gameStruct.fileName '_' num2str( cRun )];
              % Obtain a game object from the game structure
              gameObj = nfg_game_idr( gameStruct );

              gameObjList( cRun, cGame ) = {gameObj};
                
          end % cRun
      end % cGame

     	sessType = handles.sessionType; % Get the session type
      % Note: This is called using the gameObjList, rather than the
      % gameList.
      % We send through the game objects when we are going to run this
      % code on a cluster
   	switch sessType
      	case 'All vs All'
	         session( handles.agentList, gameObjList, metricsObjCell, paramObj, whatToSave, handles.freqArray  )
			case 'One vs All'
	        	agent_session( handles.agentList, gameObjList, metricsObjCell, paramObj, whatToSave, handles.freqArray )
		end
        
%% BEGIN: speedup measure
% Get all games to call their guaranteed value script
% and also call their equilibrium script
		global SessionObject
		allGamesOrig = get( SessionObject, 'gameList' );
		[nRuns, nGames] = size( allGamesOrig );
		for cRun = 1:nRuns
			% Get the current run's games
			SessionObject = set( SessionObject, 'gameList', allGamesOrig( cRun, : ) );
			for cGame = 1:nGames
				
				% Get the guaranteed values put into the game
				[dum1, dum2] = return_guaranteed( cGame, 1 );

				% Get the equilibrium saved into the game
				[dum1] = return_equilibria( cGame, 0 );
			end
			% Now return the updated games to the original games list 
			allGamesOrig( cRun, : ) = get( SessionObject, 'gameList' );
		end
		% update the SessionObject
		SessionObject = set( SessionObject, 'gameList', allGamesOrig );
%% END: speedup measure
   
   	% Update handles structure
    	guidata(hObject, handles);

      % Run the tournament
    	tournament

      % We do not need to recombine the files,
      % as they are saved in the correct manner
        
	end % if: ~isequal( fileName, 0 )
else
    % Don't do anything, user needs to fix things up
end

% --- Executes during object creation, after setting all properties.
function nActions_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nActions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function nActions_Callback(hObject, eventdata, handles)
% hObject    handle to nActions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nActions as text
%        str2double(get(hObject,'String')) returns contents of nActions as
%        a double


% --- Executes during object creation, after setting all properties.
function typeMetricPopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to typeMetricPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in typeMetricPopup.
function typeMetricPopup_Callback(hObject, eventdata, handles)
% hObject    handle to typeMetricPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns typeMetricPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from typeMetricPopup

allMetricTypes = get( handles.typeMetricPopup, 'String' );
selectedType = allMetricTypes{ get( handles.typeMetricPopup, 'Value' ) };
[metsAvail, metsFuncHand] = metric_selection( selectedType );
set( handles.metricPopup, 'Value', 1 );
set( handles.metricPopup, 'String', metsAvail ); % Update what metrics are available
                                                 % of that type
handles.metricHandles = metsFuncHand;
handles.typeMetric = selectedType;
handles.metricSelected = 0;

% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function metricFrequency_CreateFcn(hObject, eventdata, handles)
% hObject    handle to metricFrequency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function metricFrequency_Callback(hObject, eventdata, handles)
% hObject    handle to metricFrequency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of metricFrequency as text
%        str2double(get(hObject,'String')) returns contents of
%        metricFrequency as a double


% --- Executes on button press in loadConfigButton.
function loadConfigButton_Callback(hObject, eventdata, handles)
% hObject    handle to loadConfigButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% First popup the load window
[fileName, pathName] = uigetfile( {'*.mat', 'MAT-files (*.mat)'}, 'Select config file to load', [handles.malt_home handles.globalSTORAGE_DIRECTORY '/ConfigFiles/'] );

% Next load the file
if ( isequal( fileName, 0 ) | isequal( pathName, 0) )
    % File was cancelled, don't do anything
else
    % File was not cancelled - load it up!
    fullPath = [pathName fileName]; % Create path
    savedStruct = load( fullPath );

    % Then load all the data and change the values in the GUI
    handles.agentList = savedStruct.agentsSaved;
    handles.gameList = savedStruct.gamesSaved;
    handles.metricList = savedStruct.metricsSaved;
    handles.freqArray = savedStruct.freqSaved;
    handles.sessionType = savedStruct.sessionSaved;
    
    set( handles.agentListBox, 'String', savedStruct.agentListBoxSaved );
    set( handles.gameListBox, 'String', savedStruct.gameListBoxSaved );
    set( handles.metricListBox, 'String', savedStruct.metricListBoxSaved );
    set( handles.parameterRuns, 'String', savedStruct.parameterRunsSaved);
    set( handles.parameterIterations, 'String', savedStruct.parameterItersSaved);
    set( handles.parameterSettlingIn, 'String', savedStruct.parameterSettleSaved);
    
    handles.paramStruct = struct( 'runs', str2num( get( handles.parameterRuns, 'String' ) ),...
        'totalIterations', str2num( get( handles.parameterIterations, 'String' ) ),...
        'settleIterations', str2num( get( handles.parameterSettlingIn, 'String' ) ) );

    % Set the values in the listboxes
    set( handles.agentListBox, 'Value', 1 );
    set( handles.gameListBox, 'Value', 1 );
    set( handles.metricListBox, 'Value', 1 );
    set( handles.nActions, 'String', '2' );

    % Setup the popups to initial values
    set( handles.agentPopup, 'Value', 1 );
    set( handles.gamePopup, 'Value', 1 );
    set( handles.typeMetricPopup, 'Value', 1 );
    allMetricTypes = get( handles.typeMetricPopup, 'String' );
    selectedType = allMetricTypes{1};
    [metsAvail, metsFuncHand] = metric_selection( selectedType );
    set( handles.metricPopup, 'Value', 1 );
    set( handles.metricPopup, 'String', metsAvail );
    % Set the sessionPopup to the correct value
    allSessions = get( handles.sessionPopup, 'String' );
    % Find the session in the list
    whereIs = find( strcmp( allSessions, handles.sessionType ) );
    if isempty( whereIs )
        set( handles.sessionPopup, 'Value', 1 );
    else
        set( handles.sessionPopup, 'Value', whereIs );
    end
end

% Update handles structure
guidata(hObject, handles)

% --- Executes on button press in saveConfigButton.
function saveConfigButton_Callback(hObject, eventdata, handles)
% hObject    handle to saveConfigButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% First popup the save window
[fileName, pathName] = uiputfile( {'*.mat', 'MAT-files (*.mat)'}, 'Save to a config file', [handles.malt_home handles.globalSTORAGE_DIRECTORY '/ConfigFiles/' date '_malt_config_file.mat'] );

if ( isequal( fileName, 0 ) | isequal( pathName, 0 ) )
    % User cancelled, do nothing
else
    % User chose a file
    fullPath = [pathName fileName]; % Create a path
  
    % First set all of the values that need to be saved
    agentsSaved = handles.agentList;
    gamesSaved = handles.gameList;
    metricsSaved = handles.metricList;
    freqSaved = handles.freqArray;
    sessionSaved = handles.sessionType;
	 % Change the contents of the listboxes
    agentListBoxSaved = get( handles.agentListBox, 'String' );
    gameListBoxSaved = get( handles.gameListBox, 'String' );
    metricListBoxSaved = get( handles.metricListBox, 'String' );
    parameterRunsSaved = get( handles.parameterRuns, 'String' );
    parameterItersSaved = get( handles.parameterIterations, 'String' );
    parameterSettleSaved = get( handles.parameterSettlingIn, 'String' );

    % Now save everything to the chosen path and file name
	 % Save to Matlab version 6 compatibility
    if ( str2num( version('-release') ) > 13 )
        save( fullPath, 'agentsSaved', 'gamesSaved', 'metricsSaved', 'freqSaved', 'sessionSaved',...
            'agentListBoxSaved', 'gameListBoxSaved', 'metricListBoxSaved', 'parameterRunsSaved',...
            'parameterItersSaved', 'parameterSettleSaved','-V6');
    else
        save( fullPath, 'agentsSaved', 'gamesSaved', 'metricsSaved', 'freqSaved', 'sessionSaved',...
            'agentListBoxSaved', 'gameListBoxSaved', 'metricListBoxSaved', 'parameterRunsSaved',...
            'parameterItersSaved', 'parameterSettleSaved');
    end

end


% --- Executes on button press in clusterButton.
function clusterButton_Callback(hObject, eventdata, handles)
% hObject    handle to clusterButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Make global variables visible
global SESSION_NAME
global SessionObject

validityBit = checkGUIValid( handles );

if validityBit
    % Everything set correctly, can run the tests

    % Don't setup the agents to objects, as this is(will be) done in
    % tournament.m. This is to allow the agent to be instantiated with the
    % correct number of actions for that game
    % Don't setup the games to objects either, as this will be done in the
    % tournament.m method. This is to allow easy calling of Gambit and to
    % avoid file conflicts.

    % Ask the user for a session name
    % First popup the save window
	[fileName, pathName] = uiputfile( {'*.mat', 'MAT-files (*.mat)'}, 'Save a session file', [handles.malt_home handles.globalSTORAGE_DIRECTORY '/' date '_'] );

	if ~isequal( fileName, 0 )
	% ie. if the user DID NOT push cancel

   	% Set the global variable
	   findSuffix = findstr( fileName, '.mat' ); % Find the .mat suffix
		if isempty( findSuffix )
	 		% User didn't use a .mat extension
			SESSION_NAME = fileName;
	 	else
	 		% User did use a .mat extension
	   	SESSION_NAME = fileName( 1:findSuffix-1 ); % remove the .mat suffix
	 	end

	   % Setup the displayname list of each agent
	   % Pass cell list of agent structures to a method that will add the
	   % correct display name -- done as a method to cleanup this part of the
	   % code
    	handles.agentList = createAgentDisplayNames( handles.agentList );

    	% Setup the parameter object
    	paramObj = createParamObj( handles );

    	% Create the directory
    	sessName = [pathName fileName];
    	[success, message, messageID] = mkdir([pathName SESSION_NAME]);
	 	printOut( sprintf( 'Attempt to create %s\nParameters:\nsuccess = %d\nmessage = %s\nmessageID = %s', [pathName SESSION_NAME], success, message, messageID ) );
	 	if isequal( messageID, 'MATLAB:MKDIR:DirectoryExists' )
	 		% Directory already exists
			% We want to clear it
			printOut( sprintf( 'Directory %s already exists and we need to delete its contents', SESSION_NAME ) );
			delete( [pathName SESSION_NAME '/*.*'] );
	 	end
	 
    	% Save the parameter object as the file
		% Save to Matlab version 6 compatibility
    	if ( str2num( version('-release') ) > 13 )
      	    save( sessName, 'paramObj', '-V6' );
    	else
        	save( sessName, 'paramObj' );
    	end

    	% Setup the metrics - need to instantiate the objects
    	% Want to create list with what is stored - this should only contain
    	% unique elements
    	[metricsObjCell, whatToSave] = createMetricsObjs( handles );

      % Clear out the extProgs directory of gambit and Gamut generated
      % game files
      delete( [handles.malt_home 'extProgs/*.gambit'] )
      delete( [handles.malt_home 'extProgs/*.simple'] )
      delete( [handles.malt_home 'extProgs/*.eqm'] )
      delete( [handles.malt_home 'extProgs/*.idr'] )

      % First make sure that the game file names can handle multiple
      % versions of the same generator
      handles.gameList = createGameFileNames( handles.gameList );
        
      % Since we are now going to be creating files for the cluster, 
      % we pre-create all of the game objects into a #runs x #games cell
      nGames = length( handles.gameList );
      nRuns = get( paramObj, 'runs' );
      gameObjList = cell( nRuns, nGames );
      for cGame = 1:nGames
          for cRun = 1:nRuns
              gameStruct = handles.gameList{cGame}; % Get the current game structure
              % Update the fileName to be correct
              gameStruct.fileName = [gameStruct.fileName '_' num2str( cRun )];
              % Obtain a game object from the game structure
              gameObj = nfg_game_idr( gameStruct );
              gameObjList( cRun, cGame ) = {gameObj};
                
          end % cRun
      end % cGame
        
    	sessType = handles.sessionType; % Get the session type
      % Note: This is called using the gameObjList, rather than the
      % gameList.
      % We sent through the game objects when we are going to run this
      % code on a cluster
    	switch sessType
     	case 'All vs All'
            session( handles.agentList, gameObjList, metricsObjCell, paramObj, whatToSave, handles.freqArray  )
      case 'One vs All'
         	agent_session( handles.agentList, gameObjList, metricsObjCell, paramObj, whatToSave, handles.freqArray )
      end

%% BEGIN: speedup measure
% Get all games to call their guaranteed value script
% and also call their equilibrium script
		global SessionObject
		allGamesOrig = get( SessionObject, 'gameList' );
		[nRuns, nGames] = size( allGamesOrig );
		for cRun = 1:nRuns
			% Get the current run's games
			SessionObject = set( SessionObject, 'gameList', allGamesOrig( cRun, : ) );
			for cGame = 1:nGames
			
				% Get the guaranteed values put into the game
				[dum1, dum2] = return_guaranteed( cGame, 1 );

				% Get the equilibrium saved into the game
				[dum1] = return_equilibria( cGame, 0 );
			end
			% Now return the updated games to the original games list 
			allGamesOrig( cRun, : ) = get( SessionObject, 'gameList' );
		end
		% update the SessionObject
		SessionObject = set( SessionObject, 'gameList', allGamesOrig );
%% END: speedup measure

		% Create the file name for the SessionObject and save it
      fNameSession = create_file_name( '', '', '', 'session' );
      save( fNameSession, 'SessionObject' );
        
    	% Update handles structure
    	guidata(hObject, handles);

		% Create all of the cluster files
		% The format for those files can be set in create_cluster_file.m
      clusterFile = create_cluster_file;
        
	end % if: ~isequal( fileName, 0 )
else
    % Don't do anything, user needs to fix things up
end
