function varargout = metric_popup(varargin)
% METRIC_POPUP M-file for metric_popup.fig
%      METRIC_POPUP, by itself, creates a new METRIC_POPUP or raises the existing
%      singleton*.
%
%      H = METRIC_POPUP returns the handle to a new METRIC_POPUP or the handle to
%      the existing singleton*.
%
%      METRIC_POPUP('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in METRIC_POPUP.M with the given input arguments.
%
%      METRIC_POPUP('Property','Value',...) creates a new METRIC_POPUP or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before metric_popup_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to metric_popup_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help metric_popup

% Last Modified by GUIDE v2.5 16-Nov-2004 13:37:07

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @metric_popup_OpeningFcn, ...
                   'gui_OutputFcn',  @metric_popup_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before metric_popup is made visible.
function metric_popup_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to metric_popup (see VARARGIN)

% Choose default command line output for metric_popup
handles.output = hObject;

% Take the input = metric structure
currMetric = varargin{1};
% Set values for use in other functions of this GUI
handles.windowMetric = currMetric;
handles.origFrequency = currMetric.frequency;
% Set values for display in textboxes
set( handles.metricName, 'String', currMetric.name );
set( handles.frequencyValue, 'String', currMetric.frequency );

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes metric_popup wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = metric_popup_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% The figure can be deleted now
delete(handles.figure1);

% --------------------------------------------------------------------
function metricName_Callback(hObject, eventdata, handles)
% hObject    handle to metricName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function frequencyValue_CreateFcn(hObject, eventdata, handles)
% hObject    handle to frequencyValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function frequencyValue_Callback(hObject, eventdata, handles)
% hObject    handle to frequencyValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of frequencyValue as text
%        str2double(get(hObject,'String')) returns contents of frequencyValue as a double


% --- Executes on button press in confirmButton.
function confirmButton_Callback(hObject, eventdata, handles)
% hObject    handle to confirmButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get the metric in the window and update the metric structure frequency
currMetric = handles.windowMetric;
updatedFreq = str2num( get( handles.frequencyValue, 'String' ) );
currMetric.frequency = updatedFreq;

% Set the output to the modified metric
handles.output = currMetric;

% Update handles structure
guidata(hObject, handles);

% Use UIRESUME instead of delete because the OutputFcn needs
% to get the updated handles structure.
uiresume(handles.figure1);


% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = clear_confirm( 'Title', 'Confirm reset' ); % Pops up the clear all confirmation window
switch user_response
    case {'Yes'} % Want to clear all entries
        set( handles.frequencyValue, 'String', handles.origFrequency );
        % Update handles structure
        guidata(hObject, handles);
    case {'No'} % Don't want to clear entries
end
