function [foundInCell, cellList] = remove_string( cellList, toFind )

% Name: remove_string.m
% Location: MALT/GUI/remove_string.m
% Purpose:  Checks if a string is in a cell list and removes it from the list
% Input Parameters:  Cell list of strings
%                    string that is being searched for
% Output Parameters: bit specifying whether found or not
%                    original or changed cell list, 
%                    depending on whether found or not

% First check whether toFind is in the cell list
foundValue = find( strcmp( cellList, toFind ) == 1 );

% If in, remove it, else return original
if isempty( foundValue )
	% string `toFind' wasn't found
	foundInCell = 0;
else
	% string was found, remove from cell list
	foundInCell = 1;
	cellList = {cellList{1:foundValue-1} cellList{foundValue+1:end}};
end
