function varargout = runsControl(varargin)
% RUNSCONTROL M-file for runsControl.fig
%      RUNSCONTROL, by itself, creates a new RUNSCONTROL or raises the existing
%      singleton*.
%
%      H = RUNSCONTROL returns the handle to a new RUNSCONTROL or the handle to
%      the existing singleton*.
%
%      RUNSCONTROL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RUNSCONTROL.M with the given input arguments.
%
%      RUNSCONTROL('Property','Value',...) creates a new RUNSCONTROL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before runsControl_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to runsControl_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help runsControl

% Last Modified by GUIDE v2.5 21-Jan-2005 00:05:18

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @runsControl_OpeningFcn, ...
                   'gui_OutputFcn',  @runsControl_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before runsControl is made visible.
function runsControl_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to runsControl (see VARARGIN)

%handles.validAnswers = 1;

% Save original values of the listboxes when first read in
origRuns = varargin{1};
handles.origRunsFrom = origRuns(1);
handles.origRunsTo = origRuns(2);
currRuns = varargin{2};
if isempty( currRuns )
    handles.currRunsFrom = num2str( handles.origRunsFrom );
    handles.currRunsTo = num2str( handles.origRunsTo );
    handles.endRunsFrom = 1;
    handles.endRunsTo = 1;
else
    handles.currRunsFrom = currRuns(1);
    handles.currRunsTo = currRuns(2);
    handles.endRunsFrom = 1;
    handles.endRunsTo = 1;
end    
    
% Set the various edit boxes and maximum run info box
set( handles.runsFrom, 'String', handles.currRunsFrom );
set( handles.runsTo, 'String', handles.currRunsTo );
set( handles.runsStoredEdit, 'String', ['Total runs stored is ' num2str( origRuns(2) )] );

% Choose default command line output for runsControl
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes runsControl wait for user response (see UIRESUME)
 uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = runsControl_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
% Close the figure
delete( handles.figure1 );

% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = clear_confirm( 'Title', 'Confirm reset' ); % Popup confirmation window
switch user_response
case {'Yes'}
    % Reset the two edit boxes to their original state
    set( handles.runsFrom, 'String', num2str( handles.currRunsFrom ) );
    set( handles.runsTo, 'String', num2str( handles.currRunsTo ) );
    handles.endRunsFrom = 1;
    handles.endRunsTo = 1;
    handles.validAnswers = 1;
case {'No'}
    % Do not do anything, no reset wanted
end

% Save the GUI data
guidata( hObject, handles );


% --- Executes on button press in acceptButton.
function acceptButton_Callback(hObject, eventdata, handles)
% hObject    handle to acceptButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ( ( handles.endRunsFrom ) && ( handles.endRunsTo ) )
	 outPt = [str2num( get( handles.runsFrom, 'String' ) ) str2num( get( handles.runsTo, 'String' ) )]; % Set output
    handles.output = outPt;
    guidata( hObject, handles); % Save data 

    uiresume( handles.figure1 ); % Since modal, need to resume
end    

function runsFrom_Callback(hObject, eventdata, handles)
% hObject    handle to runsFrom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of runsFrom as text
%        str2double(get(hObject,'String')) returns contents of runsFrom as a double

editFrom = get( hObject, 'String' );
editFromNum = str2num( editFrom );

% This is a bit of a hack
handles.endRunsFrom = 0;
guidata( hObject, handles )

if isempty( editFromNum ) % Check whether number
	 handles.endRunsFrom = 0;
    error_gui( 'Title', 'Error detected', 'From run number must be an integer' );
    set( hObject, 'String', num2str( handles.currRunsFrom ) );
elseif ( ( editFromNum < 1 ) || (editFromNum > str2num( get( handles.runsTo, 'String' ) ) ) ) % Check within valid bounds
	 handles.endRunsFrom = 0;
    error_gui( 'Title', 'Error detected', ['From run number must be in the range [1, ' get( handles.runsTo, 'String' ) ']'] );
    set( hObject, 'String', num2str( handles.currRunsFrom ) );
elseif ( mod( editFromNum, 1 ) ~= 0 ) % Check whether integer
	 handles.endRunsFrom = 0;    
    error_gui( 'Title', 'Error detected', 'From run number must be an integer' );
    set( hObject, 'String', num2str( handles.currRunsFrom ) );
else
	 handles.endRunsFrom = 1;
end

% Save the data
guidata( hObject, handles );


% --- Executes during object creation, after setting all properties.
function runsFrom_CreateFcn(hObject, eventdata, handles)
% hObject    handle to runsFrom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function runsTo_Callback(hObject, eventdata, handles)
% hObject    handle to runsTo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of runsTo as text
%        str2double(get(hObject,'String')) returns contents of runsTo as a double

editTo = get( hObject, 'String' );
editToNum = str2num( editTo );

if isempty( editToNum ) % Check whether number
    error_gui( 'Title', 'Error detected', 'To run number must be an integer' );
	 handles.endRunsTo = 0;
    set( hObject, 'String', num2str( handles.currRunsTo ) );
elseif ( ( editToNum > handles.origRunsTo ) || ( editToNum < str2num( get( handles.runsFrom, 'String' ) ) ) ) % Check whether within valid bounds
	 handles.endRunsTo = 0;
    error_gui( 'Title', 'Error detected', ['To run number must be in the range of [From Run,' num2str( handles.origRunsTo ) ']' ] );
    set( hObject, 'String', num2str( handles.currRunsTo ) );    
elseif ( mod( editToNum, 1 ) ~= 0 ) % Check whether integer
	 handles.endRunsTo = 0;
    error_gui( 'Title', 'Error detected', 'To run number must be an integer' );
    set( hObject, 'String', num2str( handles.currRunsTo ) );    
else
	 handles.endRunsTo = 1;
end

% Save the data
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function runsTo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to runsTo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
