function varargout = sessionControl(varargin)
% SESSIONCONTROL M-file for sessionControl.fig
%      SESSIONCONTROL, by itself, creates a new SESSIONCONTROL or raises the existing
%      singleton*.
%
%      H = SESSIONCONTROL returns the handle to a new SESSIONCONTROL or the handle to
%      the existing singleton*.
%
%      SESSIONCONTROL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SESSIONCONTROL.M with the given input arguments.
%
%      SESSIONCONTROL('Property','Value',...) creates a new SESSIONCONTROL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before sessionControl_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to sessionControl_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help sessionControl

% Last Modified by GUIDE v2.5 25-Nov-2004 14:29:01

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @sessionControl_OpeningFcn, ...
                   'gui_OutputFcn',  @sessionControl_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before sessionControl is made visible.
function sessionControl_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to sessionControl (see VARARGIN)

% Make global variables visible
global MALT_HOME;
handles.malt_home = MALT_HOME; % Get and set the global for later use
global STORAGE_DIRECTORY;
handles.globalSTORAGE_DIRECTORY = STORAGE_DIRECTORY;

handles.sessionSelected = 0;
handles.sessionSelectedName = '';

% Choose default command line output for sessionControl
handles.output = hObject;

% Get struct of all the files
allParamFilesStruct = dir( [handles.malt_home STORAGE_DIRECTORY '/*.mat'] );
allParamFiles = {};
for cPr = 1:length( allParamFilesStruct )
    allParamFiles = {allParamFiles{1:end} allParamFilesStruct(cPr,1).name};
end

set( handles.sessionListBox, 'String', allParamFiles );

% GUI is not modal

% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = sessionControl_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in sessionListBox.
function sessionListBox_Callback(hObject, eventdata, handles)
% hObject    handle to sessionListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns sessionListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from sessionListBox

% Sets the value of the item selected in the session listbox
handles.sessionSelected = get( hObject, 'Value' );
allStrings = get( hObject, 'String' );
handles.sessionSelectedName = allStrings{ handles.sessionSelected };

set( handles.sessionContentsListBox, 'String', '' );

% Update handles structure
guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function sessionListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sessionListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on button press in viewSessionButton.
function viewSessionButton_Callback(hObject, eventdata, handles)
% hObject    handle to viewSessionButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Check what has been selected so far
if ( handles.sessionSelected == 0 )
    % Haven't selected a session
    error_gui('Title', 'Error detected', 'Please select a session to view');
else
    % We use the parameter file that was saved to generate the contents of
    % the session
    
    % Load the file - this comes in a structure
    fileToLoad = load( [handles.malt_home handles.globalSTORAGE_DIRECTORY '/' handles.sessionSelectedName] ); % Load the parameter file
    % Get the actual object we want from the structure
    paramRequested = fileToLoad.paramObj;
    
    % Setup the display for the session contents
    allGames = get( paramRequested, 'gamutCommand' );
    [arb, nGames] = size( allGames ); % Get the number of games
    gameDisp = {'GAMES:'};
    for cG = 1:nGames
        gameDisp = {gameDisp{1:end} allGames{cG}};
    end

	 % Get the algorithms
    allAlgs = get( paramRequested, 'algmList' );
    nAlgs = length( allAlgs );
    algDisp = {'ALGORITHMS:'};
    for cA = 1:nAlgs
        algDisp = {algDisp{1:end} allAlgs{cA}};
    end

	 % Get the values of the run and iterations parameters
    runDisp = {['RUNS: ' num2str( get( paramRequested, 'runs' ) )] ['SETTLING ITERATIONS: ' num2str( paramRequested.settle )] ['TOTAL ITERATIONS: ' num2str( get( paramRequested, 'totalIterations' ) )]};

	 % Get the type of session
    sesDisp = {['SESSION TYPE: ' get( paramRequested, 'sessionType' )]};

	 % Get the list of metric names
    allMets = get( paramRequested, 'metricNames' );
    nMets = length( allMets );
    metDisp = {'METRICS:'};
    for cM = 1:nMets
        metDisp = {metDisp{1:end} allMets{cM}};
    end

	 % Now display all of this
	 set( handles.sessionContentsListBox, 'String', {gameDisp{1:end} '' algDisp{1:end} '' runDisp{1:end} '' sesDisp{1:end} '' metDisp{1:end}} );
end

	 % Update handles structure
	 guidata(hObject, handles);

% --- Executes on button press in selectSessionButton.
function selectSessionButton_Callback(hObject, eventdata, handles)
% hObject    handle to selectSessionButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Create a dummy, empty session object
global SessionObject
session;

% Check what has been previously selected
if ( handles.sessionSelected == 0 )
	% Haven't selected a session
	error_gui('Title', 'Error detected', 'Please select a session to view');
else
	% Load the file - this is the session file. We just remove the '.mat'
	% suffix to get the directory name
	sessionFileName = [handles.malt_home handles.globalSTORAGE_DIRECTORY '/' handles.sessionSelectedName(1:end-4) '/session.mat'];
	fileStruct = load( sessionFileName ); % Load the session file - it loads as a structure, thus...
   SessionObject = fileStruct.SessionObject; % Get the SessionObject from the structure

	% Store the session name to the global variable for later use
	global SESSION_NAME
	SESSION_NAME = handles.sessionSelectedName(1:end-4);
	
	% The figure can be deleted now
	delete(handles.figure1);
	
	% Run the conditioning control GUI
%%	conditionControl
    visualControl

end


% --- Executes on button press in deleteSessionButton.
function deleteSessionButton_Callback(hObject, eventdata, handles)
% hObject    handle to deleteSessionButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% DO THE DELETION HERE
% This is not implemented yet (August 2005)

handles.sessionSelected = 0;
handles.sessionSelectedName = '';

% Update handles structure
guidata(hObject, handles);

% --- Executes on selection change in sessionContentsListBox.
function sessionContentsListBox_Callback(hObject, eventdata, handles)
% hObject    handle to sessionContentsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns sessionContentsListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from sessionContentsListBox


% --- Executes during object creation, after setting all properties.
function sessionContentsListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sessionContentsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
