function varargout = visualControl(varargin)
% VISUALCONTROL M-file for visualControl.fig
%      VISUALCONTROL, by itself, creates a new VISUALCONTROL or raises the existing
%      singleton*.
%
%      H = VISUALCONTROL returns the handle to a new VISUALCONTROL or the handle to
%      the existing singleton*.
%
%      VISUALCONTROL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in VISUALCONTROL.M with the given input arguments.
%
%      VISUALCONTROL('Property','Value',...) creates a new VISUALCONTROL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before visualControl_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to visualControl_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help visualControl

% Last Modified by GUIDE v2.5 29-Jan-2005 21:00:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @visualControl_OpeningFcn, ...
                   'gui_OutputFcn',  @visualControl_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before visualControl is made visible.
function visualControl_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to visualControl (see VARARGIN)

% GET THE INFO FROM sessionControl
% We know that SessionObject is global
% Since this conditionControl GUI is called by sessionControl,
% which has previously loaded the relevant SessionObject
global SessionObject
param = get( SessionObject, 'Parameter' );

% Load everything up into it's respective spots!!!
% First do the agents
allAgents = get( SessionObject, 'agentList' );
nAgents = length( allAgents );
agentsOrig = cell(1, nAgents );

for agnt = 1:nAgents
    cAgnt = allAgents{agnt};
    agentsOrig(1, agnt) = { cAgnt.displayName };
end
handles.agentsOrig = agentsOrig;

% Second, set up the games
allGames = get( SessionObject, 'gameList' );
[nRuns, nGames] = size( allGames );
gamesAvailOrig = cell( 1, nGames );
for cGm = 1:nGames
    actGm = allGames{ 1, cGm };
    gamesAvailOrig(1, cGm ) = { get( actGm, 'fileName' ) };
end
handles.gamesOrig = gamesAvailOrig;

% Third the runs and iterations
param = get( SessionObject, 'Parameter' );
settleIters = get( param, 'Settle' );
totalIters = get( param, 'totalIterations' );

handles.runsFromOrig = 1;
handles.runsToOrig = nRuns;
handles.iterationsFromOrig = 1;
handles.iterationsToOrig = totalIters - settleIters;

% Setup the radio buttons & grey out the respective agent selection boxes
set( handles.agentRadio, 'Value', 1 );
set( handles.rowColAgentRadio, 'Value', 0 );
set( handles.colAgentListbox, 'Visible', 'off' );
set( handles.agent2Title, 'Visible', 'off' )
handles.radio = 1;

% Also set the strings displayed to be blank for now
set( handles.agent1Listbox, 'String', {} );
set( handles.colAgentListbox, 'String', {} );

% Setup the metrics (dependent variables) stuff and the independent
% variables
listMetrics = get( SessionObject, 'metricList' );
nMets = length( listMetrics );
metNames = cell( 1, nMets );
for cMet = 1:nMets
    tmpMet = listMetrics{ cMet };
    metNames( 1, cMet ) = { get( tmpMet, 'displayName' ) };
end
set( handles.freeVarsListbox, 'String', {} );
set( handles.depVarsListbox, 'String', {} );
handles.freeVarsOrigAll = get_lists( 'free variables' );
handles.depVarsOrigAll = metNames;

% Setup the visual objects list
handles.visualsOrig = get_lists( 'visualisations' );

% Make those sections invisible - prevents people from viewing it
set( handles.freeVarsListbox, 'Visible', 'off' );
set( handles.depVarsListbox, 'Visible', 'off' );
set( handles.graphsListbox, 'Visible', 'off' );
set( handles.aggregationListbox, 'Visible', 'off' );
set( handles.clickFreeVarsButton, 'Visible', 'off' );
set( handles.clickDepVarsButton, 'Visible', 'off' );
set( handles.clickPredefinedGraphButton, 'Visible', 'off' );
set( handles.clickNewGraphButton, 'Visible', 'off' );
set( handles.clickAggregationButton, 'Visible', 'off' );

% Next set of variables is for ensuring consistency after things have been
% changed again
handles.agentsConfirmed = 0;
handles.runConfirmed = 0;
handles.iterationsconfirmed = 0;
handles.gamesConfirmed = 0;
handles.freeVarsConfirmed = 0;
handles.depVarsConfirmed = 0;
handles.graphsConfirmed = 0;
handles.aggConfirmed = 0;

% Choose default command line output for visualControl
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes visualControl wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = visualControl_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in rowColAgentRadio.
function rowColAgentRadio_Callback(hObject, eventdata, handles)
% hObject    handle to rowColAgentRadio (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of rowColAgentRadio

% Was unselected, is now clicked
    set( handles.rowColAgentRadio, 'Value', 1 );
    set( handles.colAgentListbox, 'Visible', 'on' );
    set( handles.agent2Title, 'Visible', 'on' );
    % Deselect the agent box for both row and column
    set( handles.agentRadio, 'Value', 0 );
    set( handles.agent1Title, 'String', 'Agents acting as row player' )
    handles.radio = 0;

    % Update handles structure
    guidata(hObject, handles);    

% --- Executes on button press in agentRadio.
function agentRadio_Callback(hObject, eventdata, handles)
% hObject    handle to agentRadio (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of agentRadio

% Was unselected, is now clicked
    set( handles.agentRadio, 'Value', 1 );
    set( handles.agent1Listbox, 'Visible', 'on' );
    set( handles.agent1Title, 'String', 'Agents' );
    
    % Deselect the agent box for both row and column
    set( handles.rowColAgentRadio, 'Value', 0 );
    set( handles.agent2Title, 'Visible', 'off' );
    set( handles.colAgentListbox, 'Visible', 'off' );
    handles.radio = 1;

    % Update handles structure
    guidata(hObject, handles);    

% --- Executes on selection change in agent1Listbox.
function agent1Listbox_Callback(hObject, eventdata, handles)
% hObject    handle to agent1Listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns agent1Listbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from agent1Listbox


% --- Executes during object creation, after setting all properties.
function agent1Listbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to agent1Listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in colAgentListbox.
function colAgentListbox_Callback(hObject, eventdata, handles)
% hObject    handle to colAgentListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns colAgentListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from colAgentListbox


% --- Executes during object creation, after setting all properties.
function colAgentListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to colAgentListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in gameListbox.
function gameListbox_Callback(hObject, eventdata, handles)
% hObject    handle to gameListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns gameListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from gameListbox


% --- Executes during object creation, after setting all properties.
function gameListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gameListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in clickGamesButton.
function clickGamesButton_Callback(hObject, eventdata, handles)
% hObject    handle to clickGamesButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Take the new game list after running the GUI
newGameList = gamesControl( handles.gamesOrig, get( handles.gameListbox, 'String' ) );
set( handles.gameListbox, 'String', newGameList );
if ( length( newGameList) ~= 0 )
    set( handles.gameListbox, 'Value', 1 );
else
    set( handles.gameListbox, 'Value', 0 );
end

% Update the confirmed button
handles.gamesConfirmed = 1;
handles.freeVarsConfirmed = 0;
handles.depVarsConfirmed = 0;
handles.graphsConfirmed = 0;
handles.aggConfirmed = 0;

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in clickRunsButton.
function clickRunsButton_Callback(hObject, eventdata, handles)
% hObject    handle to clickRunsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Popup the runs GUI and update it after user selection
newRuns = runsControl( [handles.runsFromOrig handles.runsToOrig],...
                       [str2num( get( handles.runsFrom, 'String' ) ) str2num( get( handles.runsTo, 'String' ) )] );

set( handles.runsFrom, 'String', num2str( newRuns(1) ) );
set( handles.runsTo, 'String', num2str( newRuns(2) ) );

% Update the confirmed button
handles.runConfirmed = 1;
handles.freeVarsConfirmed = 0;
handles.depVarsConfirmed = 0;
handles.graphsConfirmed = 0;
handles.aggConfirmed = 0;

% Update handles structure
guidata(hObject, handles);

% --- Executes on selection change in depVarsListbox.
function depVarsListbox_Callback(hObject, eventdata, handles)
% hObject    handle to depVarsListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns depVarsListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from depVarsListbox


% --- Executes during object creation, after setting all properties.
function depVarsListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to depVarsListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in clickDepVarsButton.
function clickDepVarsButton_Callback(hObject, eventdata, handles)
% hObject    handle to clickDepVarsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Call the procedure with ( list of possible dependent variables,...
%                           currently selected dependent variable )

% Popup the dependent variables GUI and get the update list
newDeps = depVarsControl( handles.depVarsOrigAll,...
                          get( handles.depVarsListbox, 'String' ) );
set( handles.depVarsListbox, 'String', newDeps );
if ( length( newDeps ) ~= 0 )
    set( handles.depVarsListbox, 'Value', 1 );
else
    set( handles.depVarsListbox, 'Value', 0 );
end

% Set step 5 (graphs) to visible
set( handles.graphsListbox, 'Visible', 'on' );
set( handles.clickPredefinedGraphButton, 'Visible', 'on' );
set( handles.clickNewGraphButton, 'Visible', 'on' );

% Update the confirmed button
handles.depVarsConfirmed = 1;
handles.graphsConfirmed = 0;
handles.aggConfirmed = 0;

% Update handles structure
guidata(hObject, handles);

% --- Executes on selection change in freeVarsListbox.
function freeVarsListbox_Callback(hObject, eventdata, handles)
% hObject    handle to freeVarsListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns freeVarsListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from freeVarsListbox


% --- Executes during object creation, after setting all properties.
function freeVarsListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to freeVarsListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in clickFreeVarsButton.
function clickFreeVarsButton_Callback(hObject, eventdata, handles)
% hObject    handle to clickFreeVarsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Check which free variables should be available
% Updates each time we want to run it
allFrees = handles.freeVarsOrigAll;
if ( get( handles.agentRadio, 'Value' ) == 1 )
    % Allow agents
    whereRow = find( strcmp( allFrees, 'Row agent' ) );
    allFrees = {allFrees{1:whereRow-1} allFrees{whereRow+1:end}};
    whereCol = find( strcmp( allFrees, 'Column agent' ) );
    allFrees = {allFrees{1:whereCol-1} allFrees{whereCol+1:end}};
else
    % Allow row and column agents
    whereAgnt = find( strcmp( allFrees, 'Agent' ) );
    allFrees = {allFrees{1:whereAgnt-1} allFrees{whereAgnt+1:end}};
end

% Call the procedure with ( Full list of free variables,...
%                          current list possible (agents||row/Col),...
%                          actual current list )
% This returns the new list of free variables
newFrees = freeVarsControl( handles.freeVarsOrigAll, allFrees, get( handles.freeVarsListbox, 'String' ) );
set( handles.freeVarsListbox, 'String', newFrees );
if ( length( newFrees ) == 0 )
    set( handles.freeVarsListbox, 'Value', 0 );
else
    set( handles.freeVarsListbox, 'Value', 1 );
end

% Update the confirmed button
handles.freeVarsConfirmed = 1;
handles.depVarsConfirmed = 0;
handles.graphsConfirmed = 0;
handles.aggConfirmed = 0;

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in clickIterationsButton.
function clickIterationsButton_Callback(hObject, eventdata, handles)
% hObject    handle to clickIterationsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Popup iterations GUI and obtain the new values
newIterations = iterationsControl( [handles.iterationsFromOrig handles.iterationsToOrig],...
                       [str2num( get( handles.iterationsFrom, 'String' ) ) str2num( get( handles.iterationsTo, 'String' ) )] );

set( handles.iterationsFrom, 'String', num2str( newIterations(1) ) );
set( handles.iterationsTo, 'String', num2str( newIterations(2) ) );

% Update the confirmed button
handles.iterationsconfirmed = 1;
handles.freeVarsConfirmed = 0;
handles.depVarsConfirmed = 0;
handles.graphsConfirmed = 0;
handles.aggConfirmed = 0;

% Update handles structure
guidata( hObject, handles );

% --- Executes on button press in clickPredefinedGraphButton.
function clickPredefinedGraphButton_Callback(hObject, eventdata, handles)
% hObject    handle to clickPredefinedGraphButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Since this is sets a predefined graph, do we want to allow changes to
% aggregation, or just show the aggregation that is set?
% Make step 6 visible
set( handles.aggregationListbox, 'Visible', 'on' );
set( handles.clickAggregationButton, 'Visible', 'on' );

% Update the confirmed button
handles.graphsConfirmed = 1;
handles.aggConfirmed = 0;

% Update handles structure
guidata( hObject, handles );

% --- Executes on selection change in graphsListbox.
function graphsListbox_Callback(hObject, eventdata, handles)
% hObject    handle to graphsListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns graphsListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from graphsListbox


% --- Executes during object creation, after setting all properties.
function graphsListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to graphsListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in clickNewGraphButton.
function clickNewGraphButton_Callback(hObject, eventdata, handles)
% hObject    handle to clickNewGraphButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

allVisualsObj = handles.visualsOrig;
currentFreeVars = get( handles.freeVarsListbox, 'String' );

% Now just provide a list of the graphs that are allowed
availVis = {};
availVisObj = {};
for cVis = 1:length( allVisualsObj )
    tmpVis = allVisualsObj{cVis};
    disAllowedVars = get( tmpVis, 'freeVarsDisallowed' );
    foundVar = 0;
    for chkVar = 1:length( disAllowedVars )
        if ( find( strcmp( disAllowedVars{chkVar}, currentFreeVars ) ) );
            foundVar = 1;
        end
    end
    % If no conflicting free variables have been found, 
    % then we add this visualisation method to the available list
    if ( ~foundVar )
        availVis = {availVis{1:end} get( tmpVis, 'name' )};
        availVisObj = {availVisObj{1:end} allVisualsObj{cVis}};
    end
end

% Popup the window to let the user select the visualisation method
visStruct = visualisationControl( availVisObj, availVis, get( handles.graphsListbox, 'String' ), currentFreeVars );
currVisObj = visStruct.visualObj; % Get visualisation object
handles.currVisObj = currVisObj;
handles.aggOrig = get( currVisObj, 'aggregationAllowed' ); % Sets the aggregation methods allowed
handles.errorbarsWanted = visStruct.errorbarsWanted; % Whether errorbars allowed or not
set( handles.graphsListbox, 'String', visStruct.name ); % Name of the visualisation method
if ( length( visStruct ) ~= 0 )
    set( handles.graphsListbox, 'Value', 1 );
else
    set( handles.graphsListbox, 'Value', 0 );
end
    
% Make step 6 visible
set( handles.aggregationListbox, 'Visible', 'on' );
set( handles.clickAggregationButton, 'Visible', 'on' );

% Update the confirmed button
handles.graphsConfirmed = 1;
handles.aggConfirmed = 0;

% Save data
guidata( hObject, handles );

% --- Executes on selection change in aggregationListbox.
function aggregationListbox_Callback(hObject, eventdata, handles)
% hObject    handle to aggregationListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns aggregationListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from aggregationListbox


% --- Executes during object creation, after setting all properties.
function aggregationListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to aggregationListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in clickAggregationButton.
function clickAggregationButton_Callback(hObject, eventdata, handles)
% hObject    handle to clickAggregationButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Call the procedure with ( list of original aggregation methods,...
%                           currently chosen aggregation method )

% Popup aggregation GUI and get the new aggregation method
newAgg = aggControl( handles.aggOrig, get( handles.aggregationListbox, 'String' ),...
                     handles.errorbarsWanted );

set( handles.aggregationListbox, 'String', newAgg );
% Note: if the newAgg is 'none' or the handles.errorbarsWanted == 1, 
% then we should automatically sum the iterations (and average them)

if ( length( newAgg ) ~= 0 )
    set( handles.aggregationListbox, 'Value', 1 );
else
    set( handles.aggregationListbox, 'Value', 0 );
end

% Update the confirmed variables
handles.aggConfirmed = 1;

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Not implemented yet

% --- Executes on button press in runButton.
function runButton_Callback(hObject, eventdata, handles)
% hObject    handle to runButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Make global variable visible
global SessionObject

% Now we want to check that everything has been set and checked
if ( ~handles.agentsConfirmed )
    error_gui( 'Title', 'Error: Unable to continue', 'Still need to check agent selection' );
elseif ( ~handles.runConfirmed )
    error_gui( 'Title', 'Error: Unable to continue', 'Still need to check run selection' );
elseif ( ~handles.iterationsconfirmed )
    error_gui( 'Title', 'Error: Unable to continue', 'Still need to check iteration selection' );
elseif ( ~handles.gamesConfirmed )
    error_gui( 'Title', 'Error: Unable to continue', 'Still need to check game selection' );
elseif ( ~handles.freeVarsConfirmed )
    error_gui( 'Title', 'Error: Unable to continue', 'Still need to check free variables selection' );
elseif ( ~handles.depVarsConfirmed )
    error_gui( 'Title', 'Error: Unable to continue', 'Still need to check dependent variables selection' );
elseif ( ~handles.graphsConfirmed )
    error_gui( 'Title', 'Error: Unable to continue', 'Still need to check graph selection' );
elseif ( ~handles.aggConfirmed )
    error_gui( 'Title', 'Error: Unable to continue', 'Still need to check aggregation selection' );
else
    % Everything is okay, can run it all
    % First run all of the metrics on all of the files
    % Now need to get all the conditioned variables
    % First the agents
    if ( get( handles.agentRadio, 'Value' ) == 1 )
        % using the agent
        condAgents1 = get( handles.agent1Listbox, 'String' );
        condAgents2 = get( handles.agent1Listbox, 'String' );
        whichAgents = 1;
    else
        condAgents1 = get( handles.agent1Listbox, 'String' );
        condAgents2 = get( handles.colAgentListbox, 'String' );
        % Then just in case only one of row or column agents has been set
        if isempty( condAgents1 )
            condAgents1 = handles.agentsOrig;
        end
        if isempty( condAgents2 )
            condAgents2 = handles.agentsOrig;
        end
        whichAgents = 0;
    end
    % Get iterations and runs
    condRuns = [str2num( get( handles.runsFrom, 'String' ) ) str2num( get( handles.runsTo, 'String' ) )];
    condIterations = [str2num( get( handles.iterationsFrom, 'String' ) ) str2num( get( handles.iterationsTo, 'String' ) )];
    % Get games
    condGames = get( handles.gameListbox, 'String' );
    % Get selected free variables
    condFree = get( handles.freeVarsListbox, 'String' );
    % Get selected dependent variable/metric
    condDep = get( handles.depVarsListbox, 'String' );
    origDep = handles.depVarsOrigAll; % Original list of metrics
    whereIsMet = find( strcmp( condDep, origDep ) ); % Find where the display name occurs
    metList = get( SessionObject, 'metricList' );
    condDepObj = metList{ whereIsMet }; % This gives us the metric object
    % Get the type of graph
	 visualObj = handles.currVisObj;
    % Get the type of aggregation
    condAgg = get( handles.aggregationListbox, 'String' );
	 % Create the 3d matrix of agents and games
    file_3dList = get_3dFilelist( whichAgents, handles.agentsOrig, condAgents1, condAgents2, condGames );
    % condRuns, condIterations, condFree, condDepObj )
    % Now put the data into an aggregated form
    [dataFile, visualObj] = createAggData( whichAgents, condAgents1, condAgents2, condGames, condRuns, condIterations, condFree, condDepObj, visualObj, condAgg, file_3dList, handles.errorbarsWanted );

	 % Run the visualisation method
	 run_visual( visualObj, dataFile );

% If we need to determine which metric to use, based on their displayName
% we can look at handles.depVarsOrigAll for the original order that,
% is the order that is used in the SessionObject.metricList
end


% --- Executes on button press in clickAgentsButton.
function clickAgentsButton_Callback(hObject, eventdata, handles)
% hObject    handle to clickAgentsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


if ( handles.radio == 1 )
    % Selecting the agents
    newAgentList = agentsControl( handles.agentsOrig, get( handles.agent1Listbox, 'String' ) );
    set( handles.agent1Listbox, 'String', newAgentList );
    if (length( newAgentList ) == 0 )
        set( handles.agent1Listbox, 'Value', 0 );
    else
        set( handles.agent1Listbox, 'Value', 1 );
    end
else
	 % Popup the row and column agent control GUI
    newAgentList = rowColControl( handles.agentsOrig,...
                                 get( handles.agent1Listbox, 'String' ),...
                                 get( handles.colAgentListbox, 'String' ) );
    newRowAgentList = newAgentList{1};
    newColAgentList = newAgentList{2};
    set( handles.agent1Listbox, 'String', newRowAgentList );
	 % Run through the options - no row agent selected
    if ( length( newRowAgentList ) ~= 0 )
        set( handles.agent1Listbox, 'Value', 1 );
    else
        set( handles.agent1Listbox, 'Value', 0 );
    end
    set( handles.colAgentListbox, 'String', newColAgentList );
	 % Run through the options - no column agent selected
    if ( length( newColAgentList ) ~= 0 )
        set( handles.colAgentListbox, 'Value', 1 );
    else
        set( handles.colAgentListbox, 'Value', 0 );
    end
end

% We should actually update the free and dependent variables here, 
% but instead we do a check when the "click free/dep" variables buttons.
% We also check when we want to run the visualisation

% Set the visibility to seen
if ( isequal( get( handles.freeVarsListbox, 'Visible' ), 'off' ) )
    set( handles.freeVarsListbox, 'Visible', 'on' );
    set( handles.depVarsListbox, 'Visible', 'on' );
    set( handles.clickFreeVarsButton, 'Visible', 'on' );
    set( handles.clickDepVarsButton, 'Visible', 'on' );
end

% Update the confirmed button
handles.agentsConfirmed = 1;
handles.freeVarsConfirmed = 0;
handles.depVarsConfirmed = 0;
handles.graphsConfirmed = 0;
handles.aggConfirmed = 0;

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in loadConfigButton.
function loadConfigButton_Callback(hObject, eventdata, handles)
% hObject    handle to loadConfigButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Not implemented yet

% --- Executes on button press in saveConfigButton.
function saveConfigButton_Callback(hObject, eventdata, handles)
% hObject    handle to saveConfigButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Not implemented yet
