function varargout = visualisationControl(varargin)
% VISUALISATIONCONTROL M-file for visualisationControl.fig
%      VISUALISATIONCONTROL, by itself, creates a new VISUALISATIONCONTROL or raises the existing
%      singleton*.
%
%      H = VISUALISATIONCONTROL returns the handle to a new VISUALISATIONCONTROL or the handle to
%      the existing singleton*.
%
%      VISUALISATIONCONTROL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in VISUALISATIONCONTROL.M with the given input arguments.
%
%      VISUALISATIONCONTROL('Property','Value',...) creates a new VISUALISATIONCONTROL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before visualisationControl_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to visualisationControl_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help visualisationControl

% Last Modified by GUIDE v2.5 24-Jan-2005 22:46:09

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @visualisationControl_OpeningFcn, ...
                   'gui_OutputFcn',  @visualisationControl_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before visualisationControl is made visible.
function visualisationControl_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to visualisationControl (see VARARGIN)

% Take all of the input arguments
vslAllObj = varargin{1};
vslAllOrig = varargin{2};
vslCurrSelect = varargin{3};
currentFreeVars = varargin{4};
handles.currFreeVars = currentFreeVars;

currAvail = {};
for cAvail = 1:length( vslAllOrig )
    selectVsl = vslAllOrig{ cAvail };
    valueOfSeen = sum( strcmp( selectVsl, vslCurrSelect ) );
    if ( ~valueOfSeen )
        % This is the currently selected visualisation method
        currAvail = {currAvail{1:end} selectVsl};
    end
end

% Set the errorBarsAllowed value
if ~isempty( vslCurrSelect )
    % The above is a check to ensure whether we are starting with an empty
    % cell or not
    for vObj = 1:length( vslAllObj )
        actObj = vslAllObj{ vObj };
        if isequal( get( actObj, 'name' ), vslCurrSelect{1} )
            handles.currVisObj = actObj;
        end
    end
end
    
handles.vslAllObj = vslAllObj; % List of visualisation objects
handles.vslAllOrig = vslAllOrig; % Original list of visualisation methods available
handles.vslSelected = vslCurrSelect; % Original list of visualisation methods selected

% Set these to the listboxes
set( handles.vslAvailableListbox, 'String', currAvail );
if isempty( vslCurrSelect )
    set( handles.vslSelectedListbox, 'String', {} );
    set( handles.vslSelectedListbox, 'Value', 0 );
else
    set( handles.vslSelectedListbox, 'String', vslCurrSelect );
    set( handles.vslSelectedListbox, 'Value', 1 );
end
% Initialise the values used in the listboxes
handles.vslAvailValue = 0;
handles.vslSelectedValue = 0;

% Choose default command line output for visualisationControl
handles.output = hObject;

% Update handles structure
guidata( hObject, handles );

% UIWAIT makes visualisationControl wait for user response (see UIRESUME)
% ie. modal window
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = visualisationControl_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% Close the figure
delete( handles.figure1 );

% --- Executes on selection change in vslAvailableListbox.
function vslAvailableListbox_Callback(hObject, eventdata, handles)
% hObject    handle to vslAvailableListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns vslAvailableListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from vslAvailableListbox

handles.vslAvailValue = get( hObject, 'Value' );

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function vslAvailableListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to vslAvailableListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in vslSelectedListbox.
function vslSelectedListbox_Callback(hObject, eventdata, handles)
% hObject    handle to vslSelectedListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns vslSelectedListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from vslSelectedListbox

handles.vslSelectedValue = get( hObject, 'Value' );

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function vslSelectedListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to vslSelectedListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in addVslButton.
function addVslButton_Callback(hObject, eventdata, handles)
% hObject    handle to addVslButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

valueToAdd = handles.vslAvailValue;
% Run through the possible options for selecting a visualisation method
if ( valueToAdd == 0 )
    error_gui( 'Title', 'Error: Selection required', 'Need to choose an available visualisation method' );
elseif isempty( valueToAdd )
    error_gui( 'Title', 'Error detected', 'Trying to add a visualisation method that does not exist' );
elseif ( length( get( handles.vslSelectedListbox, 'String' ) ) == 1 )
    error_gui( 'Title', 'Error: Unable to continue', 'Can have a maximum of one visualisation methods selected' );
else
    % Remove from the visualisation methods available listbox

    % Get the currently available visualisation methods and the one that the user
    % selected and update the available
    currAvail = get( handles.vslAvailableListbox, 'String' );
    vslToAdd = currAvail{ valueToAdd };
    currAvail = {currAvail{1:valueToAdd-1} currAvail{valueToAdd+1:end}};
    % Get the currently selected visualisation method and update it
    currSelected = get( handles.vslSelectedListbox, 'String' );
    currSelected = {currSelected{1:end} vslToAdd};

    % Just send through the visual object that we have currently selected
    foundVis = {};
    vslObj = handles.vslAllObj;
    for cVsl = 1:length( vslObj )
        actVsl = vslObj{cVsl};
        if isequal( get( actVsl, 'name' ), vslToAdd )
            foundVis = actVsl;
        end
    end
    
    handles.currVisObj = foundVis;
    
    % Update the currently available visualisation method listbox
    set( handles.vslAvailableListbox, 'String', currAvail );
    set( handles.vslAvailableListbox, 'Value', length( currAvail ) );
    % Update the currently selected listbox
    set( handles.vslSelectedListbox, 'String', currSelected );
    set( handles.vslSelectedListbox, 'Value', length( currSelected ) );
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in removeVslButton.
function removeVslButton_Callback(hObject, eventdata, handles)
% hObject    handle to removeVslButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

valueToRemove = handles.vslSelectedValue;
% Run through the options for a selected visualisation method
if ( valueToRemove == 0 )
    error_gui( 'Title', 'Error: Selection required', 'Need to choose a selected visualisation method to remove' );
elseif isempty( valueToRemove )
    error_gui( 'Title', 'Error detected', 'Trying to remove a selected visualisation method does not exist' );
else
    % Get the visualisation method currently selected
    vslSelected = get( handles.vslSelectedListbox, 'String' );
    vslToRemove = vslSelected{ valueToRemove };
    % Remove the visualisation method
    vslSelected = {vslSelected{1:valueToRemove-1} vslSelected{valueToRemove+1:end}};
    
    % Get the list of visualisation methods currently available
    % and add to it
    currAvail = get( handles.vslAvailableListbox, 'String' );
    currAvail = {currAvail{1:end} vslToRemove};
    set( handles.vslAvailableListbox, 'String', currAvail );
    set( handles.vslAvailableListbox, 'Value', length( currAvail ) );
    
	 % Set the selected visualisation method
    newVal = length( vslSelected );
    set( handles.vslSelectedListbox, 'Value', newVal );
    if ( newVal == 0 )
        set( handles.vslSelectedListbox, 'String', {} );
    else
        set( handles.vslSelectedListbox, 'String', vslSelected );
    end
end

% Reset the visualisation listbox values
handles.vslSelectedValue = 0;
handles.vslAvailValue = 0;

% Update handles structure
guidata( hObject, handles );

% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

user_response = clear_confirm('Title', 'Confirm reset'); % Pops up the clear all confirmation window
switch user_response
    case {'Yes'} % Want to clear all entries
        % Set up the displayed values in the two listboxes
        set( handles.vslAvailableListbox, 'String', handles.vslAllOrig );
        if isempty( handles.vslSelected )
            set( handles.vslSelectedListbox, 'String', {} );
            set( handles.vslSelectedListbox, 'Value', 1 );
        else
            set( handles.vslSelectedListbox, 'String', handles.vslSelected );
            set( handles.vslSelectedListbox, 'Value', 1 );
        end
        % Initialise the values used in the listboxes
        handles.vslAvailValue = 0;
        handles.vslSelectedValue = 0;
    case {'No'} % Do not want to clear entries
        % Do nothing
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in proceedButton.
function proceedButton_Callback(hObject, eventdata, handles)
% hObject    handle to proceedButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Do the validity checks, then proceed
if ( length( get( handles.vslSelectedListbox, 'String' ) ) < 1 )
    % No visualisation methods selected
    error_gui( 'Title', 'Unable to proceed', 'Need to select at least one visualisation method' );
else
    % Check if this method allows error bars and whether iterations is a 
    % selected free variable or not
 	 errorbarsWanted = 0;
    if isempty( find( strcmp( lower( handles.currFreeVars ), 'iterations' ) ) )
        % Iterations is not one of the free variables
        if get( handles.currVisObj, 'errorBarsAllowed' )
            % Error bars are allowed
            errorbarsWanted = errorBarsQuery;
        end
    end
    % If yes, then ask the user whether they want error bars or not
    handles.errorbars = errorbarsWanted;  
    
    handles.output = struct( 'visualObj', handles.currVisObj,...
                            'name', {get( handles.vslSelectedListbox, 'String' )},...
                            'errorbarsWanted', handles.errorbars );
    guidata( hObject, handles );
    
    uiresume( handles.figure1 );
end
