% Asher Lipson
% August 2004
% See README.txt in the MALT home directory for latest information 
% This file is based on the same file from Kevin Murphy's Bayes Net Toolbox

% Name: add_MALT_to_path.m
% Location: MALT/add_MALT_to_path.m
% Purpose:	Adds the directories in which the class and other 
% files for the toolbox can be found in WINDOWS
% Input Parameters: none
% Output Parameters: none

global MALT_HOME
MALT_HOME = 'c:\UBC-code\malt\';
global DEBUG_MODE % Mode for debugging
DEBUG_MODE = 0; % 0 = Do nothing, 1 = print to file and screen, 2 = print to file, 3 = print to screen
global SESSION_NAME % For storing the file name
global STORAGE_DIRECTORY % Directory in which to store all the files
STORAGE_DIRECTORY = 'storedFiles';
global SessionObject % For the session object and access by various methods

% Explicitly list subfolders, but don't list the actual class folders
% i.e. those beginning with an @

folders = {'agentClasses', 'dataClasses', 'gameClasses', 'sessionClasses', 'general', 'parameterClasses', 'extProgs', 'metricClasses', 'statisticsClasses', 'visualClasses', 'Testing', 'sessionClasses/GlobalFiles', 'sessionClasses/GlobalFiles/Normal_Form_Games', 'GUI', 'GUI/agentGUIs'};

%folders = {'malt', 'malt/agentClasses', 'malt/dataClasses', 'malt/gameClasses', 'malt/sessionClasses', 'malt/general', 'malt/parameterClasses', 'malt/extProgs', 'malt/metricClasses', 'malt/statisticsClasses', 'malt/visualClasses', 'malt/Testing', 'malt/sessionClasses/GlobalFiles', 'malt/sessionClasses/GlobalFiles/Normal_Form_Games', 'malt/GUI', 'malt/GUI/agentGUIs'};

addpath( MALT_HOME )

for indiv = 1:length( folders )
	addpath( fullfile( MALT_HOME, folders{indiv} ) )
end


