function agnt = set( agnt, varargin )

% Name: set.m
% Location: MALT/agentClasses/@agent/set.m
% Purpose: Set agent properties in the specified object
% Input Parameters: 	agent object 
%							name of property to change and new value
% Output Parameters: Updated agent object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'date'
		disp( 'Not allowed to set date property' );
	case 'algorithm'
		if ( isa(newValue, 'char') )
			agnt.algorithm = newValue;
		else
			disp( 'Agent algorithm should be a character' )
		end
	case 'idnumber'
		agnt.idNumber = newValue;
	case 'number'
		agnt.number = newValue;
	case 'actions'
		agnt.actions = newValue;
	case 'strategy'
		agnt.strategy = newValue;
	case 'displayname'
		agnt.displayName = newValue;
	otherwise
		error( '@agent/set.m: Agent properties: Algorithm, Number, Actions, Strategy' );
	end
end

