function agnt = subsasgn( agnt, field, value )

% Name: subsasgn.m
% Location: MALT/agentClasses/@agent/subsasgn.m
% Purpose: Define field name assignment for agent objects
% Input Parameters:  agent object 
%							field that is wanted, by name index
%							new value for the field
% Output Parameters: updated agent object

switch field.type
case '()'
	error('@agent/subsasgn.m: Numeric array indexing not supported by agent objects');
case '.'
	switch lower( field.subs )
	case 'date'
		disp('error: @agent/subsasgn.m: Not allowed to change date field');
	case 'algorithm'
		if ( isa(value, 'char') )
			agnt.algorithm = value;
		else
			disp('error: @agent/subsasgn.m: new algorithm must be a string');
			agnt.algorithm = agnt.algorithm;
		end
	case 'idnumber'
		agnt.idNumber = value;
	case 'number'
		agnt.number = value;
	case 'actions'
		agnt.actions = value;
	case 'strategy'
		agnt.strategy = value;
	case 'displayname'
		agnt.displayName = value;
	otherwise
		error('@agent/subsasgn.m: Invalid field name used for indexing - unknown');
	end
case '{}'
	error('@agent/subsasgn.m: Cell array indexing not supported by agent objects');
end
