function value = subsref( agnt, field )

% Name: subsref.m
% Location: MALT/agentClasses/@agent/subsref.m
% Purpose: Define field name indexing for agent objects
% Input Parameters:  agent object 
%							field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error( '@agent/subsref.m: Numeric array indexing not supported by agent objects' );
case '.'
	switch lower( field.subs )
	case 'date'
		value = agnt.date;
	case 'algorithm'
		value = agnt.algorithm;
	case 'idnumber'
		value = agnt.idNumber;
	case 'number'
		value = agnt.number;
	case 'actions'
		value = agnt.actions;
	case 'strategy'
		value = agnt.strategy;
	case 'displayname'
		value = agnt.displayName;
	otherwise
		error( '@agent/subsref.m: Invalid field name used for indexing - unknown' );
	end
case '{}'
	error( '@agent/subsref.m: Cell array indexing not supported by agent objects' );
end
