function determined_agnt = determined_agent( varargin )

% Name: determined_agent.m
% Location: MALT/agentClasses/@determined_agent/determined_agent.m
% Purpose: Constructor for the determined agent class
% Input Parameters:  no Parameters - defaults used
%                    1 Parameter - object to copy || agent structure
% Output Parameters: created determined agent object

switch nargin
case 0 
	% Create default determined agent object
	% It inherits from the base 'agent' class
	determined_agnt.algorithm = 'determined_agent';
	agnt = agent;
	agnt = set(agnt, 'algorithm', 'determined_agent' );
	determined_agnt = class( determined_agnt, 'determined_agent', agnt );
case 1
	if ( isa(varargin{1}, 'determined_agent') )
		determined_agnt = varargin{1};
	elseif ( isa( varargin{1}, 'struct' ) )
		agntStruct = varargin{1};
		% Agent structure instantiation
		determined_agnt.algorithm = 'determined_agent';
		agnt = agent( agntStruct.algorithm, agntStruct.number, agntStruct.actions, agntStruct.strategy, agntStruct.displayName );

		determined_agnt = class( determined_agnt, 'determined_agent', agnt );
	else
		error('determined_agent.m: Input argument is not a determined agent object or an agent structure');
	end
otherwise
	error_disp = sprintf( 'Valid Parameters:\nNo Parameters - defaults used\n1 Parameter - object to copy or agent structure' );
	printOut( error_disp );
	error( 'determined_agent.m: Wrong number of input arguments' );
end
