function fict_agnt = subsasgn( fict_agnt, field, value )

% Name: subsasgn.m
% Location: MALT/agentClasses/@fictitious_agent/subsasgn.m
% Purpose: Define field name assignment for fictitious_agent objects
% Input Parameters:  fictitious_agent object 
%							field that is wanted, by name index
%							new value for the field
% Output Parameters: updated fictitious_agent object

switch field.type
case '()'
	error('@fictitious_agent/subsasgn.m: Numeric array indexing not supported by fictitious_agent objects');
case '.'
	switch lower( field.subs )
	case 'count'
		fict_agnt.count = value;
	otherwise
		fict_agnt.agent = subsasgn( fict_agnt.agent, field, value );
	end
case '{}'
	error('@fictitious_agent/subsasgn.m: Cell array indexing not supported by fictitious_agent objects');
end
