function value = subsref( fict_agnt, field )

% Name: subsref.m
% Location: MALT/agentClasses/@fictitious_agent/subsref.m
% Purpose: Define field name indexing for fictitious_agent objects
% Input Parameters:  fictitious_agent object
%                    field that is wanted by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@fictitious_agent/subsref.m: Numeric array indexing not supported by fictitious_agent objects');
case '.'
	switch lower( field.subs )
	case 'count'
		value = fict_agnt.count;
	otherwise
		value = subsref( fict_agnt.agent, field );
	end
case '{}'
	error('@fictitious_agent/subsref.m: Cell array indexing not supported by fictitious_agent objects');
end
