function fict_agnt = updatebeliefs( fict_agnt, actionsTaken )

% Name: updatebeliefs.m
% Location: MALT/agentClasses/@fictitious_agent/updatebeliefs.m
% Purpose: Updates the fictitious agent's count and beliefs about its opponents
% Input Parameters:	fictitious_agent object
%							action taken vector
% Output Parameters: Updated fictitious_agent object

agntNumb = get( fict_agnt, 'number' );
agntID = get( fict_agnt, 'idNumber' );
agntCount = get( fict_agnt, 'count' );
agntStrat = get( fict_agnt, 'strategy' );

% Loop over the number of agents
for cAgnt = 1:length( actionsTaken )
	if ( cAgnt ~= agntNumb ) % i.e. we don't update the fictitious agent's own beliefs

		% Obtain the opponent's action
		if ( agntID == 1 )
			oppAction = actionsTaken( 2 );
		else
			oppAction = actionsTaken( 1 );
		end

		% Increase the count on the action that the opponent took
		agntCount( cAgnt, oppAction ) = agntCount( cAgnt, oppAction) + 1;
		% Return the count over actions back to the fictitious agent
		fict_agnt = set( fict_agnt, 'count', agntCount );
		% Normalise the count and assign it as the opponent's strategy 
		agntStrat( cAgnt, : ) = agntCount( cAgnt, : )/sum( agntCount( cAgnt, : ) );
		% Return the normalised count over the opponent's actions to the fictitious agent
		fict_agnt = set( fict_agnt, 'strategy', agntStrat );
	end
end
