function fictAgnt = updatestrategy( varargin )

% Name: updatestrategy.m
% Location: MALT/agentClasses/@fictitious_agent/updatestrategy.m
% Purpose:  Updates agent's strategy
% Input Parameters:  agent object
%                    number of game being played
%                    current iteration
%                    cell of actions taken and rewards received
% Output Parameters: agent object

fictAgnt = varargin{1};
allStrat = get( fictAgnt, 'strategy' );
agntNumb = get( fictAgnt, 'number' );
agntActs = get( fictAgnt, 'actions' );
iterInfo = varargin{4};
actions = iterInfo{1};
agntAct = actions( agntNumb );

% Generate a pure strategy based on the action that the fictitious agent
% took in this iteration
allStrat( agntNumb, : ) = generate_pure( agntAct, agntActs );

% Set the fictitious agent's strategy
fictAgnt = set( fictAgnt, 'strategy', allStrat );
