function actionTaken = selectaction( fict_agnt_da, varargin )

% Name: selectaction.m
% Location: MALT/agentClasses/@fictitious_agent_da/selectaction.m
% Purpose: 	Selects the action that is the best response to the opponent's current estimated strategy
% Input Parameters:  fictitious_agent_da object 
%                    Number of the game being played
% Output Parameters: action taken by the fictitious_agent_da this round

global SessionObject;

nGame = varargin{1};

allStrats = get( fict_agnt_da, 'strategy' );
nActions = get( fict_agnt_da, 'actions' );
agNumb = get( fict_agnt_da, 'number' );
tAllStrats = allStrats;

pureStrat = eye( nActions );
valLst = zeros( 1, nActions );

for cAct = 1:nActions
	tAllStrats( agNumb, : ) = pureStrat( cAct, : );
	valLst(1, cAct) = value( nGame, tAllStrats, agNumb );
end

% Find the action that obtains the highest payoff

maxActions = ( valLst == max(valLst) );
maxActions = maxActions/sum( maxActions );
actionTaken = draw_sample( maxActions );
