function value = subsref( fict_agnt_da, field )

% Name: subsref.m
% Location: MALT/agentClasses/@fictitious_agent_da/subsref.m
% Purpose: Define field name indexing for fictitious_agent_da objects
% Input Parameters:  fictitious_agent_da object
%                    field that is wanted by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@fictitious_agent_da/subsref.m: Numeric array indexing not supported by fictitious_agent_da objects');
case '.'
	switch lower( field.subs )
	case 'beliefupdaterate'
		value = fict_agnt_da.beliefUpdateRate;
	case 'beliefdecayrate'
		value = fict_agnt_da.beliefDecayRate;
	otherwise
		value = subsref( fict_agnt_da.fictitious_agent, field );
	end
case '{}'
	error('@fictitious_agent_da/subsref.m: Cell array indexing not supported by fictitious_agent_da objects');
end
