function fict_agnt_da = updatestrategy( varargin )

% Name: updatestrategy.m
% Location: MALT/agentClasses/@fictitious_agent_da/updatestrategy.m
% Purpose:  Updates agent's strategy
%           This acts as an abstract method for the agent
% Input Parameters:  agent object
%                    number of game being played
%                    current iteration
%                    cell of actions taken and rewards received
% Output Parameters: agent object

fict_agnt_da = varargin{1};

allStrat = get( fict_agnt_da, 'strategy' );
agntNumb = get( fict_agnt_da, 'number' );
agntActs = get( fict_agnt_da, 'actions' );
iterInfo = varargin{4};
actions = iterInfo{1};
agntAct = actions( agntNumb );

allStrat( agntNumb, : ) = generate_pure( agntAct, agntActs );

fict_agnt_da = set( fict_agnt_da, 'strategy', allStrat );
