function giga_wolf = subsasgn( giga_wolf, field, value )

% Name: subsasgn.m
% Location: MALT/agentClasses/@giga_wolf_agent/subsasgn.m
% Purpose: Define field name assignment for giga_wolf_agent objects
% Input Parameters:  giga_wolf_agent object 
%							field that is wanted by name index
%							new value for the field
% Output Parameters: updated giga_wolf_agent object

switch field.type
case '()'
	error('@giga_wolf_agent/subsasgn.m: numeric array indexing not supported by giga_wolf_agent objects');
case '.'
	switch lower( field.subs )
	case 'biga'
		giga_wolf.bigA = value;
	case 'z'
		giga_wolf.z = value;
	otherwise
		giga_wolf.gradient_agent = subsasgn( giga_wolf.gradient_agent, field, value );
	end
case '{}'
	error('@giga_wolf_agent/subsasgn.m: Cell array indexing not supported by giga_wolf_agent objects');
end
