function value = subsref( giga_wolf, field )

% Name: subsref.m
% Location: MALT/agentClasses/@giga_wolf_agent/subsref.m
% Purpose: Define field name indexing for giga_wolf_agent objects
% Input Parameters:  giga_wolf_agent object
%                    field that is wanted by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@giga_wolf_agent/subsref.m: numeric array indexing not supported by giga_wolf_agent objects');
case '.'
	switch lower( field.subs )
	case 'biga'
		value = giga_wolf.bigA;
	case 'z'
		value = giga_wolf.z;
	otherwise
		value = subsref( giga_wolf.gradient_agent, field );
	end
case '{}'
	error('@giga_wolf_agent/subsref.m: Cell array indexing not supported by giga_wolf_agent objects');
end
