function gradient_agnt = set( gradient_agnt, varargin )

% Name: set.m
% Location: MALT/agentClasses/@gradient_agent/set.m
% Purpose: Set gradient_agent properties in the specified object
% Input Parameters:  gradient_agent object
%                    name of property to change and new value
% Output Parameters: Updated gradient_agent object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};
	propertyArgIn = propertyArgIn(3:end);

	switch lower( property )
	case 'stepsize'
		gradient_agnt.stepSize = newValue;
	case 'beliefupdaterate'
		gradient_agnt.beliefUpdateRate = newValue;
	case 'beliefdecayrate'
		gradient_agnt.beliefDecayRate = newValue;
	otherwise
		gradient_agnt.agent = set( gradient_agnt.agent, property, newValue );
	end
end


