function gradient_agnt = subsasgn( gradient_agnt, field, value )

% Name: subsasgn.m
% Location: MALT/agentClasses/@gradient_agent/subsasgn.m
% Purpose: Define field name assignment for gradient_agent objects
% Input Parameters:  gradient_agent object 
%							field that is wanted, by name index
%							new value for the field
% Output Parameters: updated gradient_agent object

switch field.type
case '()'
	error( '@gradient_agent/subsasgn.m: Numeric array indexing not supported by gradient_agent objects' );
case '.'
	switch lower( field.subs )
	case 'stepsize'
		gradient_agnt.stepSize = value;
	case 'beliefupdaterate'
		gradient_agnt.beliefUpdateRate = value;
	case 'beliefdecayrate'
		gradient_agnt.beliefDecayRate = value;
	otherwise
		gradient_agnt.agent = subsasgn( gradient_agnt.agent, field, value );
	end
case '{}'
	error( '@gradient_agent/subsasgn.m: Cell array indexing not supported by gradient_agent objects' );
end
