function value = subsref( gradient_agnt, field )

% Name: subsref.m
% Location: MALT/agentClasses/@gradient_agent/subsref.m
% Purpose: Define field name indexing for gradient_agent objects
% Input Parameters:  gradient_agent object
%                    field that is wanted by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error( '@gradient_agent/subsref.m: Numeric array indexing not supported by gradient_agent objects' );
case '.'
	switch lower( field.subs )
	case 'stepsize'
		value = gradient_agnt.stepSize;
	case 'beliefupdaterate'
		value = gradient_agnt.beliefUpdateRate;
	case 'beliefdecayrate'
		value = gradient_agnt.beliefDecayRate;
	otherwise
		value = subsref( gradient_agnt.agent, field );
	end
case '{}'
	error('@gradient_agent/subsref.m: Cell array indexing not supported by gradient_agent objects');
end
