function gradient_agnt_ret = updatestrategy( varargin )

% Name: updatestrategy.m
% Location: MALT/@gradient_agent/updatestrategy.m
% Purpose: Updates gradient agent's strategy
% Input Parameters: gradient_agent object
%                   number of game being played
%                   iteration
% Output Parameters: gradient_agent object with updated strategy

gradient_agnt = varargin{1};
nGame = varargin{2}; % Number of the game being played
iteration = varargin{3};

% Obtain the current gradient using the unbounded forward difference formula
gradient = ufd_approx( gradient_agnt, nGame, iteration );

% Obtain just the agent's strategy
agntStratPre = returnstrategy( gradient_agnt );
% Update the strategy using the gradient and stepsize
agntStratPre = agntStratPre + gradient_agnt.stepSize * gradient;
% Project agent's strategy back into valid probability space
agntStrat = gw_projection( agntStratPre );

agntStratOld = get( gradient_agnt, 'strategy' );
agntNumb = get( gradient_agnt, 'number' );
agntStratOld( agntNumb, : ) = agntStrat;

% Set the strategy in the gradient agent class
gradient_agnt = set( gradient_agnt, 'strategy', agntStratOld );

gradient_agnt_ret = gradient_agnt;
