function gsa_agnt = subsasgn( gsa_agnt, field, value )

% Name: subsasgn.m
% Location: MALT/agentClasses/@gsa_agent/subsasgn.m
% Purpose: Define field name assignment for gsa_agent objects
% Input Parameters:  gsa_agent object
%                    field that is wanted by name index
%                    new value for the field
% Output Parameters: updated gsa_agent object

switch field.type
case '()'
   error('@gsa_agent/subsasgn.m: numeric array indexing not supported by gsa_agent objects');
case '.'
	switch lower( field.subs )
	case 'biga'
		gsa_agnt.bigA = value;
	otherwise
		gsa_agnt.gradient_agent = subsasgn( gsa_agnt.gradient_agent, field, value );
	end
case '{}'
	error('@gsa_agent/subsasgn.m: Cell array indexing not supported by gsa_agent objects');
end
