function value = subsref( gsa_agnt, field )

% Name: subsref.m
% Location: MALT/agentClasses/@gsa_agent/subsref.m
% Purpose: Define field name indexing for gsa_agent objects
% Input Parameters:	gsa_agent object
%							field that is wanted by name index
% Output Parameters: value of the field

switch field.type
case '()'
   error('@gsa_agent/subsref.m: numeric array indexing not supported by gsa_agent objects');
case '.'
   switch lower( field.subs )
   case 'biga'
		value = gsa_agnt.bigA;
	otherwise
		value = subsref( gsa_agnt.gradient_agent, field );
	end
case '{}'
	error('@gsa_agnt/subsref.m: Cell array indexing not supported by gsa_agent objects');
end
