function mm_agnt = subsasgn( mm_agnt, field, value )

% Name: subsasgn.m
% Location: MALT/agentClasses/@minimax_agent/subsasgn.m
% Purpose: Define field name assignment for minimax_agent objects
% Input Parameters:  minimax_agent object
%                    field that is wanted, by name index
%                    new value for the field
% Output Parameters: updated minimax_agent object

switch field.type
case '()'
   error('@minimax_agent/subsasgn.m: Numeric array indexing not supported by minimax_agent objects');
case '.'
	switch lower( field.subs )
	case 'oppactions'
		mm_agnt.oppActions = value;
	otherwise
		mm_agnt.q_agent = subsasgn( mm_agnt.q_agent, field, value );
	end
case '{}'
   error('@minimax_agent/subsasgn.m: Cell array indexing not supported by minimax_agent objects');
end
