function value = subsref( mm_agnt, field )

% Name: subsref.m
% Location: MALT/agentClasses/@mm_agent/subsref.m
% Purpose: Define field name indexing for minimax_agent objects
% Input Parameters:	minimax_agent object
%							field that is wanted by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error( '@minimax_agent/subsref.m: Numeric array indexing not supported by minimax_agent objects' );
case '.'
	switch lower( field.subs )
	case 'oppactions'
		value = mm_agnt.oppActions;
	otherwise
		value = subsref( mm_agnt.q_agent, field );
	end
case '{}'
	error('@minimax_agent/subsref.m: Cell array indexing not supported by minimaxm_agent objects');
end
