function mm_agnt_ret = update_pi( varargin )

% Name: update_pi.m
% Location: MALT/agentClasses/@minimax_agent/update_pi.m
% Purpose: Updates the strateg, pi, for the minimax-Q agent
% Input Parameters:  minimax_q object
%                    number of game being played
% Output Parameters: Updated minimax_q object 
%							and *might* update the global SessionObject as well

global SessionObject;

mm_agnt = varargin{1};
nGame = varargin{2}; % Take the number of the game

nOppActions = get( mm_agnt, 'oppActions' );
agntNumb = get( mm_agnt, 'number' );
agntStrat = get( mm_agnt, 'strategy' );
agntActions = get( mm_agnt, 'actions' );

% Return the guaranteed value of the games
[vValue, highPay] = return_guaranteed( nGame, get( mm_agnt, 'number' ) );

% Create a pure strategy from one of the actions that generates the guaranteed value
agntStrat( agntNumb, : ) = generate_pure( draw_sample( highPay ), agntActions );

% Return the strategy and V function/matrix to the minimax-Q agent
mm_agnt = set( mm_agnt, 'strategy', agntStrat );
mm_agnt = set( mm_agnt, 'V', vValue );
mm_agnt_ret = mm_agnt;
