function mm_idr_agnt = minimax_idr_agent( varargin )

% name: minimax_idr_agent.m
% Location: MALT/agentClasses/@minimax_idr_agent/minimax_idr_agent.m
% Purpose:	Contructore for the minimax-Q-IDR agent class
% Input Parameters: no Parameters - defaults used
%                   1 Parameter - object to copy || agent structure
% Output Parameters: created minimax-Q agent object

switch nargin
case 0 % Create default minimax-Q agent
	mm_idr_agnt.allowedActions = [];
	% minimax_idr_agent inherits from the minimax_agent class (minimax-Q)
	mm_agnt = minimax_agent;
	mm_agnt = set( mm_agnt, 'algorithm', 'minimax_idr_agent' );
	mm_idr_agnt = class( mm_idr_agnt, 'minimax_idr_agent', mm_agnt );

case 1 % Copy object || agent structure
	if ( isa( varargin{1}, 'minimax_idr_agent' ) )
		mm_idr_agnt = varargin{1};
	elseif ( isa( varargin{1}, 'struct' ) )
		agntStruct = varargin{1};
		% Agent structure instantiation
		mm_idr_agnt.allowedActions = [];
		mm_agnt = minimax_agent( agntStruct );
		mm_agnt = set( mm_agnt, 'algorithm', 'minimax_idr_agent' );
		mm_idr_agnt = class( mm_idr_agnt, 'minimax_idr_agent', mm_agnt );
	else
		error('minimax_idr_agent.m: Input argument is not a minimax_idr_agent object')
	end
otherwise
   error_disp = sprintf( 'Valid Parameters:\nNo Parameters - defaults used\n1 Parameter - object to copy or agent structure' );
   printOut( error_disp );
   error( 'minimax_idr_agent.m: Wrong number of input arguments' );
end
