function actionTaken = selectaction( mm_idr_agnt, varargin )

% Name: selectaction.m
% Location: MALT/agentClasses/@minimax_agent/selectaction.m
% Purpose: Selects an action from the minimax-Q-IDR agent's distribution over actions
% Input Parameters: minimax_agent object
% Output Parameters: action taken by the minimax_agent this round

exploreRate = get( mm_idr_agnt, 'explore' );

actionsAllowed = get( mm_idr_agnt, 'allowedActions' ); 

if ( rand < exploreRate )
	% Randomly choose an action that is not dominated
	actionTaken = draw_sample( actionsAllowed );
else
	% Otherwise choose an action from the distribution,
	% which will only have positive probability over the undominated actions
	actionTaken = draw_sample( returnstrategy( mm_idr_agnt ) );
end
