function mm_idr_agnt = subsasgn( mm_idr_agnt, field, value )

% Name: subsasgn.m
% Location: MALT/agentClasses/@minimax_idragent/subsasgn.m
% Purpose: Define field name assignment for minimax_idr_agent objects
% Input Parameters:  minimax_idr_agent object
%                    field that is wanted, by name index
%                    new value for the field
% Output Parameters: updated minimax_idr_agent object

switch field.type
case '()'
   error('@minimax_idr_agent/subsasgn.m: Numeric array indexing not supported by minimax_idr_agent objects');
case '.'
	switch lower( field.subs )
	case 'allowedactions'
		mm_idr_agnt.allowedActions = value;
	otherwise
		mm_idr_agnt.minimax_agent = subsasgn( mm_idr_agnt.minimax_agent, field, value );
	end
case '{}'
   error('@minimax_idr_agent/subsasgn.m: Cell array indexing not supported by minimax_idr_agent objects');
end
