function value = subsref( mm_idr_agnt, field )

% Name: subsref.m
% Location: MALT/agentClasses/@mm_idr_agent/subsref.m
% Purpose: Define field name indexing for minimax_idr_agent objects
% Input Parameters:	minimax_idr_agent object
%							field that is wanted by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error( '@minimax_idr_agent/subsref.m: Numeric array indexing not supported by minimax_idr_agent objects' );
case '.'
	switch lower( field.subs )
	case 'allowedactions'
		value = mm_idr_agnt.allowedActions;
	otherwise
		value = subsref( mm_idr_agnt.minimax_agent, field );
	end
case '{}'
	error('@minimax_idr_agent/subsref.m: Cell array indexing not supported by minimax_idr_agent objects');
end
