function mm_agnt_ret = update_pi( varargin )

% Name: update_pi.m
% Location: MALT/agentClasses/@minimax_idr_agent/update_pi.m
% Purpose: Updates the strateg, pi, for the minimax-Q-IDR agent
% Input Parameters:  minimax_idr object
%                    number of game being played
% Output Parameters: Updated minimax_idr object
%							and *optional* the global SessionObject is updated

global SessionObject

mm_agnt = varargin{1};
nGame = varargin{2};

nOppActions = get( mm_agnt, 'oppActions' );
agntNumb = get( mm_agnt, 'number' );
agntStrat = get( mm_agnt, 'strategy' );
agntActions = get( mm_agnt, 'actions' );

% Determine the guaranteed payoff / minimax value on the undominated actions
[vValue, highPay] = return_guaranteed_idr( nGame, get( mm_agnt, 'number' ) );

% Create a pure strategy from one of the actions that generates the guaranteed value
agntStrat( agntNumb, : ) = generate_pure( draw_sample( highPay ), agntActions );

mm_agnt = set( mm_agnt, 'strategy', agntStrat );
mm_agnt_ret = set( mm_agnt, 'V', vValue );

