function pareto_agnt = pareto_agent( varargin )

% Name: pareto_agent.m
% Location: MALT/agentClasses/@pareto_agent/pareto_agent.m
% Purpose: Constructor for the pareto agent class
% Input Parameters: no Parameters - defaults used
%                   1 Parameter - object to copy || agent structure
% Output Parameters: created pareto agent object

switch nargin
case 0 % Create default gradient agent
	pareto_agnt.algorithm = 'pareto_agent';
	% Pareto agent inherits from the default 'agent' class
	agnt = agent;
	agnt = set(agnt, 'algorithm', 'pareto_agent' );
	pareto_agnt = class( pareto_agnt, 'pareto_agent', agnt );
case 1
	if ( isa(varargin{1}, 'pareto_agent') )
		pareto_agnt = varargin{1};
	elseif ( isa( varargin{1}, 'struct' ) )
		agntStruct = varargin{1};
		% Agent structure instantiation
		pareto_agnt.algorithm = 'pareto_agent';

		agnt = agent( agntStruct.algorithm, agntStruct.number, agntStruct.actions, agntStruct.strategy, agntStruct.displayName );
		
		pareto_agnt = class( pareto_agnt, 'pareto_agent', agnt );
	else
		error('pareto_agent.m: Input argument is not a pareto agent object or an agent structure');
	end

otherwise
	error_disp = sprintf( 'Valid Parameters:\nNo Parameters - defaults used\n1 Parameter - object to copy or agent structure' );
	printOut( error_disp );
	error( 'pareto_agent.m: Wrong number of input arguments' );
end
