function pareto_agnt_ret = updatestrategy( varargin )

% Name: updatestrategy.m
% Location: MALT/agentClasses/@pareto_agent/updatestrategy.m
% Purpose: Updates pareto agent's strategy
% Input Parameters:  pareto_agent object
%                    number of game being played
%                    iteration
% Output Parameters: pareto_agent object with updated strategy

% If it is the first iteration, then we call the 'obtain_pareto_strategy.m' method
% and generate the strategy that corresponds to playing to the highest 
% pareto optimal outcome

pareto_agnt_ret = varargin{1}; % Pareto agent object
nGame = varargin{2}; % Number of game
iteration = varargin{3}; % Iteration number currently being played

% If this is the first iteration, then we need to set the strategy to be the pareto strategy that returns the highest payoff
if ( iteration == 1 )
	pareto_agnt_ret = obtain_pareto_strategy( pareto_agnt_ret, nGame );
end

