function q_agnt = set( q_agnt, varargin )

% Name: set.m
% Location: MALT/agentClasses/@q_agent/set.m
% Purpose: Set q_agent properties in the specified object
% Input Parameters:  q_agent object
%                    name of property to change and new value
% Output Parameters: Updated q_agent object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
   property = propertyArgIn{1};
	newValue = propertyArgIn{2};
	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'explore'
	q_agnt.explore = newValue;
	case 'exploredecay'
	q_agnt.exploreDecay = newValue;
	case 'alpha'
		q_agnt.alpha = newValue;
	case 'alphadecay'
		q_agnt.alphaDecay = newValue;
	case 'gamma'
		q_agnt.gamma = newValue;
	case 'q'
		q_agnt.Q = newValue;
	case {'v', 'value'}
		q_agnt.V = newValue;
	otherwise
		q_agnt.agent = set( q_agnt.agent, property, newValue );
	end
end
