function q_agnt = subsasgn( q_agnt, field, value )

% Name: subsasgn.m
% Location: MALT/agentClasses/@q_agent/subsasgn.m
% Purpose: Define field name assignment for q_agent objects
% Input Parameters:  q_agent object
%                    field that is wanted, by name index
%                    new value for the field
% Output Parameters: updated q_agent object

switch field.type
case '()'
   error('@q_agent/subsasgn.m: Numeric array indexing not supported by q_agent objects');
case '.'
	switch lower( field.subs )
	case 'explore'
		q_agnt.explore = value;
	case 'exploredecay'
		q_agnt.exploreDecay = value;
	case 'alpha'
		q_agnt.alpha = value;
	case 'alphadecay'
		q_agnt.alphaDecay = value;
	case 'gamma'
		q_agnt.gamma = value;
	case 'q'
		q_agnt.Q = value;
	case {'v', 'value'}
		q_agnt.V = value;
	otherwise
		q_agnt.agent = subsasgn( q_agnt.agent, field, value );
	end
case '{}'
   error('@q_agent/subsasgn.m: Cell array indexing not supported by q_agent objects');
end
