function value = subsref( q_agnt, field )

% Name: subsref.m
% Location: MALT/agentClasses/@q_agent/subsref.m
% Purpose: Define field name indexing for q_agent objects
% Input Parameters:	q_agent object
%							field that is wanted by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error( '@q_agent/subsref.m: Numeric array indexing not supported by q_agent objects' );
case '.'
	switch lower( field.subs )
	case 'explore'
		value = q_agnt.explore;
	case 'exploredecay'
		value = q_agnt.exploreDecay;
	case 'alpha'
		value = q_agnt.alpha;
	case 'alphadecay'
		value = q_agnt.alphaDecay;
	case 'gamma'
		value = q_agnt.gamma;
	case 'q'
		value = q_agnt.Q;
	case {'v', 'value'}
		value = q_agnt.V;
	otherwise
		value = subsref( q_agnt.agent, field );
	end
case '{}'
	error('@q_agent/subsref.m: Cell array indexing not supported by q_agent objects');
end
