function q_agnt = update_q( q_agnt, stage_cellList )

% Name: update_q.m
% Location: MALT/agentClasses/@q_agent/update_q.m
% Purpose: Updates Q for the Q-learning agent
% Input Parameters:	q_agent object,
%							cell list from the stage game of {actions rewards}
% Output Parameters: updated q_agent object

agntGamma = get( q_agnt, 'gamma' );
agntAlpha = get( q_agnt, 'alpha' );
agntAlphaD = get( q_agnt, 'alphaDecay' );
agntQ = get( q_agnt, 'Q' );
agntV = get( q_agnt, 'V' );
IDNumber = get( q_agnt, 'idNumber' );

% This is changed to use the permanent 'ID number'
% as opposed to the flip varying 'number'

allActions = stage_cellList{1};
allRew = stage_cellList{2};

% Get the action and reward that the agent received in this iteration
agntAction = allActions( IDNumber );
agntRew = allRew( IDNumber );

% Do an update on the Q function
maxAns = agntAlpha * ( agntRew + agntGamma*agntV );
agntQ(1, agntAction) = ( 1 - agntAlpha ) * agntQ(1, agntAction) + maxAns;

% Return the Q value and a decayed alpha parameter
q_agnt = set( q_agnt, 'Q', agntQ );
q_agnt = set( q_agnt, 'alpha', agntAlpha * agntAlphaD );
