function random_agnt = random_agent( varargin )

% Name: random_agent.m
% Location: MALT/agentClasses/@random_agent/random_agent.m
% Purpose:      Constructor for the random agent class
% Input Parameters: no Parameters - defaults used
%                   1 Parameter - object to copy || agent structure
% Output Parameters: created object

switch nargin
case 0 % Create default random agent
	random_agnt.algorithm = 'random_agent';
	% Random agent inherits from the default 'agent' class
	agnt = agent;
	agnt.algorithm = 'random_agent';
	random_agnt = class( random_agnt, 'random_agent', agnt );
case 1 % Copy object
	if ( isa( varargin{1}, 'random_agent' ) )
		random_agnt = varargin{1};
	elseif ( isa( varargin{1}, 'struct' ) )
		agntStruct = varargin{1};
		% Agent structure instantiation
		random_agnt.algorithm = 'random_agent';
		agnt = agent( agntStruct.algorithm, agntStruct.number, agntStruct.actions, agntStruct.strategy, agntStruct.displayName );
		random_agnt = class( random_agnt, 'random_agent', agnt );
	else
		error('random_agent.m: Input argument is not a random agent object');
	end
otherwise
	error_disp = sprintf( 'Valid Parameters:\nNo Parameters - defaults used\n1 Parameter - object to copy or agent structure' );
	printOut( error_disp );
	error( 'random_agent.m: Wrong number of input arguments' );
end
