function san_agnt = subsasgn( san_agnt, field, value )

% Name: subsasgn.m
% Location: MALT/agentClasses/@san_agent/subsasgn.m
% Purpose: Define field name assignment for san_agent objects
% Input Parameters:  san_agent object
%                    field that is wanted by name index
%                    new value for the field
% Output Parameters: updated san_agent object

switch field.type
case '()'
   error('@san_agent/subsasgn.m: numeric array indexing not supported by san_agent objects');
case '.'
	switch lower( field.subs )
   case 'beliefupdaterate'
	   san_agnt.beliefUpdateRate = value;
   case 'beliefdecayrate'
	   san_agnt.beliefDecayRate = value;					
	case 'budget'
		san_agnt.budget = value;
	otherwise
		san_agnt.agent = subsasgn( san_agnt.agent, field, value );
	end
case '{}'
	error('@san_agent/subsasgn.m: Cell array indexing not supported by san_agent objects');
end
