function value = subsref( san_agnt, field )

% Name: subsref.m
% Location: MALT/agentClasses/@san_agent/subsref.m
% Purpose: Define field name indexing for san_agent objects
% Input Parameters:  san_agent object
%                    field that is wanted by name index
% Output Parameters: value of the field

switch field.type
case '()'
   error('@san_agent/subsref.m: numeric array indexing not supported by san_agent objects');
case '.'
   switch lower( field.subs )
   case 'beliefupdaterate'
      value = san_agnt.beliefUpdateRate;
   case 'beliefdecayrate'
      value = san_agnt.beliefDecayRate;
   case 'budget'
   	value = san_agnt.budget;
   otherwise
      value = subsref( san_agnt.agent, field );
	end
case '{}'
	error('@san_agnt/subsref.m: Cell array indexing not supported by san_agent objects');
end
