function wolf_agnt = set( wolf_agnt, varargin )

% Name: set.m
% Location MALT/agentClasses/@wolf_agent/set.m
% Purpose: Set wolf_agent properties in the specified object
% Input Parameters: wolf_agent object
%						  name of property to change
%						  new value for property
% Output Parameters: Updated wolf_agent object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};
	propertyArgIn = propertyArgIn(3:end);

	switch lower( property )
	case 'slow'
		wolf_agnt.slow = newValue;
	case 'fast'
		wolf_agnt.fast = newValue;
	case 'decay'
		wolf_agnt.decay = newValue;
	otherwise
		wolf_agnt.gradient_agent = set( wolf_agnt.gradient_agent, property, newValue );
	end
end
