function wolf_agnt = subsasgn( wolf_agnt, field, value )

% Name: subsasgn.m
% Location: MALT/agentClasses/@wolf_agent/subsasgn.m
% Purpose: Define field name assignment for wolf_agent objects
% Input Parameters:  wolf_agent object 
%							field that is wanted by name index
%							new value for the field
% Output Parameters: updated wolf_agent object

switch field.type
case '()'
	error('@wolf_agent/subsasgn.m: numeric array indexing not supported by wolf_agent objects');
case '.'
	switch lower( field.subs )
	case 'slow'
		wolf_agnt.slow = value;
	case 'fast'
		wolf_agnt.fast = value;
	case 'decay'
		wolf_agnt.decay = value;
	otherwise
		wolf_agnt.gradient_agent = subsasgn( wolf_agent.gradient_agent, field, value );
	end
case '{}'
	error('@wolf_agent/subsasgn.m: Cell array indexing not supported by wolf_agent objects');
end
