function value = subsref( wolf_agnt, field )

% Name: subsref.m
% Location: MALT/agentClasses/@wolf_agent/subsref.m
% Purpose: Define field name indexing for wolf_agent objects
% Input Parameters:  wolf_agent object
%                    field that is wanted by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@wolf_agent/subsref.m: numeric array indexing not supported by wolf_agent objects');
case '.'
	switch lower( field.subs )
	case 'slow'
		value = wolf_agnt.slow;
	case 'fast'
		value = wolf_agnt.fast;
	case 'decay'
		value = wolf_agnt.decay;
	otherwise
		value = subsref( wolf_agnt.gradient_agent, field );
	end
case '{}'
	error('@wolf_agent/subsref.m: Cell array indexing not supported by wolf_agent objects');
end
