function dt = add_to_data( dt, series_dt, whichFlip )

% Name: add_to_data.m
% Location: MALT/dataClasses/@data/add_to_data.m
% Purpose: Adds a series_data object to the data object
% Input Parameters:  data object to be updated
%                    series_data object to be included
%                    which flip is being run (row or column play)
% Output Parameters: updated data object

% Get the number of the run being looked at
whichRun = get( series_dt, 'runNumber' );

% check which data items are saved and ensure they are the same
whichData = get( series_dt, 'storing' );
origWhichData = get( dt, 'dataList' );

if ( length( whichData) ~= length( origWhichData ) )
	error( '@data/add_to_data.m: Trying to save a different number of data items for the same set of runs' );
else
	for ln = 1:length( whichData )
		if ( whichData{ln} ~= origWhichData{ln} )
			error( '@data/add_to_data.m: Trying to save different data items for the same set of runs' );
		end
	end
end
	
% If everything is okay, then just save the series_data to the correct position in the data object
allRunData = get( dt, 'allData' );
allRunData( whichFlip, whichRun ) = {series_dt};
dt = set( dt, 'allData', allRunData );
