function dt = data( varargin )

% Name: data.m
% Location: MALT/dataClasses/@data/data.m
% Purpose:	Constructor for the data class
%				Holds the data for all runs and iterations of two agents on one game
% Input Parameters:	no Parameters - defaults used
%			1 Parameter - 	object to copy
%			4 Parameters -	Number of runs
%								Char array with the name of the game
%								Cell list of what data items are saved
%								Cell list of the algorithms being run
% Output Parameters:	created data object

switch nargin
case 0 % Create default data object
	dt.allData = cell(0, 0);
	dt.gameName = 'none';
	dt.dataList = cell(0, 0);
	dt.algList = cell(0, 0);
	dt.avgData = cell(0, 0);
	dt = class( dt, 'data' );
	% This is the base class, no inheritance
case 1
	if ( isa( varargin{1}, 'data' ) )
		dt = varargin{1};
	else
		error( 'data.m: Input argument is not a data object' );
	end
case 4
	dt.allData = cell(2, varargin{1});
	dt.gameName = varargin{2};
	if isa( varargin{3}, 'cell' )
		dt.dataList = varargin{3};
	else
		dt.dataList = { varargin{3} };
	end
	dt.algList = varargin{4};
	lnData = length( dt.dataList );
	dt.avgData = cell(1, lnData);
	dt = class( dt, 'data' );
otherwise
	error_disp = sprintf( 'Valid parameters:\nNo Parameters - defaults used\n1 Parameter - object to copy\n4 Parameters - Number of runs, Name of game, Cell list of what data items are saved, Cell list of the algorithms being run' );
	disp( error_disp );
	error( 'data.m: Incorrect number of input arguments' );
end
