function display( dt )

% Name: display.m
% Location: MALT/dataClasses/@data/display.m
% Purpose: Displays a data object
% Input Parameters: data object
% Output Parameters: none

dtData = get( dt, 'dataList' );
alData = get( dt, 'algList' );
[rRow, rCol] = size( dt.allData );
[aRow, aCol] = size( dt.avgData );

dataDisp = sprintf( 'All data: %dx%d\nGame name: %s', rRow, rCol, dt.gameName );

dtDisp = sprintf( '\nData list of items: ' );

for dtIt = 1:length( dtData )
	dtDispT = sprintf( '%s ', dtData{1, dtIt} );
	dtDisp = [dtDisp dtDispT];
end

dtDisp = [dtDisp, sprintf('\nAlgorithm list: ')];
for alIt = 1:length( alData )
	dtDispT = sprintf( '%s ', alData{1, alIt} );
	dtDisp = [dtDisp dtDispT];
end

dtDisp = [dataDisp dtDisp sprintf( '\nAverage data: %dx%d\n', aRow, aCol )];

disp( dtDisp );
