function value = get( dt, property )

% Name: get.m
% Location: MALT/dataClasses/@data/get.m
% Purpose: Get data properties from the specified object
% Input Parameters:	data object 
%			  				name of property that is requested
% Output Parameters: value of the property

switch lower( property )
case 'alldata'
	value = dt.allData;
case 'gamename'
	value = dt.gameName;
case 'datalist'
	value = dt.dataList;
case 'alglist'
	value = dt.algList;
case 'avgdata'
	value = dt.avgData;
otherwise
	error( ['@data/get.m: ', property,' is not a valid data property. Data properties - allData, dataList, algList, avgData'] );
end
