function wantedData = obtain_data( dt, whichRun, whichFlip, whichData )

% Name: obtain_data.m
% Purpose: Obtain the data item for all iterations of a specific run and flip
%          This does not do any averaging, but merely returns the matrix/vector
% Input Parameters:  data object
%                    number of the run being requested
%                    number of the flip that is being requested
%                    name of the data item which is requested
% Output Parameters: array of that data item for all iterations in a specific run

dtList = get( dt, 'dataList' );

% First check if the data item exists in this data
foundData = 0;
for dtItem = 1:length( dtList )
	if isequal( dtList{dtItem}, whichData )
		foundData = dtItem;
	end
end

% If the data is not found, return -1,
% else return the requested item in the data
if ( foundData == 0 )
	wantedData = -1;
else
	tData = get( dt, 'allData' );;
	tSeriesObj = tData{ whichFlip, whichRun };
	wantedData = obtain_property( tSeriesObj,  whichData );
end

