function dt = reset_data( dt, nRuns, gName, dtList, algList )

% Name: blank_data.m
% Location: MALT/dataClasses/@data/blank_data.m
% Purpose:	Resets a data object and sets up the parameters to the correct sizes 
%				(especially after the constructor called with no arguments)
% Input Parameters:	data object to be reset
%							Number of runs
%							Game name
%							Cell list of what data items are saved
%							Cell list of the algorithms being run
% Output Parameters:	created data object

dt.allData = cell(2, nRuns);
dt.gameName = gName;
% Put it into the right format of a cell list
if ( isa( dtList, 'cell' ) )
	dt.dataList = dtList;
else
	dt.dataList = {dtList};
end
% Save the algorithm list correctly as a cell list
if ( isa( algList, 'cell' ) )
	dt.algList = algList;
else
	dt.algList = {algList};
end
dt.avgData = cell(1, length( dtList ) );
