function newName = save_data( dt, whatToSave )

% Name: save_data.m
% Location: MALT/dataClasses/@data/save_data.m
% Purpose: Save the averaged or big cell of data
% Input Parameters: 	data object which has parameters that need to be saved
%			name of property to change - avgData, allData, or both, in a cell
% Output Parameters: the name of the file in which the object is saved

% Create the new data object
newDataObj = data( length(dt.allData), dt.gameName, dt.dataList, dt.algList );
newName = [char( dt.algList{1} ) '_' char( dt.algList{2} ) '_' dt.gameName];

% Copy across which parameters we want
for its = 1:length( whatToSave )
	switch lower( whatToSave{its} )
	case 'avgdata'
		newDataObj.avgData = get( dt, 'avgData' );
		newName = [newName '-avgData'];
	case 'alldata'
		newDataObj.allData = get( dt, 'allData' );
		newName = [newName '-allData'];
	otherwise
		disp( 'error: @data/save_data.m - request to save unknown property' );
	end
end

% Add a '.mat' to the end of the file name. Save the data object
newName = [newName '.mat'];
save( newName, 'newDataObj' );
