function dt = set( dt, varargin )

% Name: set.m
% Location: MALT/dataClasses/@data/set.m
% Purpose: Set data properties in the specified object
% Input Parameters: 	data object 
% 			name of property to change and new value
% Output Parameters: Updated data object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'alldata'
		dt.allData = newValue;
	case 'gamename'
		dt.gameName = newValue;
	case 'datalist'
		dt.dataList = newValue;
	case 'alglist'
		dt.algList = newValue;
	case 'avgdata'
		dt.avgData = newValue;
	otherwise
		error( '@data/set.m: Attempt to set invalid property. Data properties - allData, dataList, algList, avgData' );
	end
end
