function dt = subsasgn( dt, field, value )

% Name: subsasgn.m
% Location: MALT/dataClasses/@data/subsasgn.m
% Purpose: Define field name assignment for data objects
% Input Parameters:	data object 
%						 	field that is wanted, by name index
%							new value for that field
% Output Parameters: updated data object

switch field.type
case '()'
	error('@data/subsasgn.m: Numeric array assignment not supported by data objects');
case '.'
	switch lower( field.subs )
	case 'alldata'
		dt.allData = value;
	case 'gamename'
		dt.gameName = value;
	case 'datalist'
		dt.dataList = value;
	case 'alglist'
		dt.algList = value;
	case 'avgdata'
		dt.avgData = value;
	otherwise
		error('@data/subsref.m: Invalid field name used for assignment - unknown');
	end
case '{}'
	error('@data/subsref.m: Cell array assignment not supported by data objects');
end
