function value = subsref( dt, field )

% Name: subsref.m
% Location: MALT/dataClasses/@data/subsref.m
% Purpose: Define field name indexing for data objects
% Input Parameters:	data object 
%		 					field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@data/subsref.m: Numeric array indexing not supported by data objects');
case '.'
	switch lower( field.subs )
	case 'alldata'
		value = dt.allData;
	case 'gamename'
		value = dt.gameName;
	case 'datalist'
		value = dt.dataList;
	case 'alglist'
		value = dt.algList;
	case 'avgdata'
		value = dt.avgData;
	otherwise
		error('@data/subsref.m: Invalid field name used for indexing - unknown');
	end
case '{}'
	error('@data/subsref.m: Cell array indexing not supported by data objects');
end
