function ev_dt = add_to_series_data( ev_dt, sIter, varargin )

% Name: add_to_series_data.m
% Location: MALT/dataClasses/@expected_value/add_to_series_data.m
% Purpose: Add data items from an iteration to a expected_value_data object
% Input parameters:	expected_value_data object
%			iteration to be updated
%			name of property to change and new value;

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	% We want to first take out the 'expectedValue' field and set it
	% Then we want to add the rest by calling an overloaded function
	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'expectedvalue'
		allExV = get( ev_dt, 'expectedValue' );
		allExV( :, sIter ) = newValue;
		ev_dt = set( ev_dt, 'expectedValue', allExV );
	otherwise
		ev_dt.snapshot_data = add_to_series_data( ev_dt.snapshot_data, sIter, property, newValue );
	end
end
