function agntProp = obtain_property( varargin )

% Name: obtain_property.m
% Location: MALT/dataClasses/@expected_value_data/obtain_property.m
% Purpose: Returns the property of agent agNumber, over all iterations
% Input Parameter: 	expected_value_data object
%			property that is wanted
%			* optional * number of the agent
%			* optional * iteration that is wanted
% Output Parameter:	Property of agent agNumber, either for all or for one specific iteration

ev_dt = varargin{1};
property = varargin{2};

switch nargin
case 2
	switch lower( property )
	case 'expectedvalue' % If expectedValue is a field take it out
		allEV = get( ev_dt, 'expectedValue' );
		agntProp = allEV( :, : );
	otherwise
		% Use the overloaded function to obtain properties through
		% functions controlled by the parent class
		agntProp = obtain_property( ev_dt.snapshot_data, property );
	end
case 3 % Want to get the property for a specific agent
	agNumber = varargin{3};
	switch lower( property )
	case 'expectedvalue'
		allEV = get( ev_dt, 'expectedValue' );
		agntProp = allEV( agNumber, : );
	otherwise
		agntProp = obtain_property( ev_dt.snapshot_data, property, agNumber );
	end
case 4 % Want to get the property for a specific agent and iteration
	agNumber = varargin{3};
	itnWanted = varargin{4};
	switch lower( property )
	case 'expectedvalue'
		allEV = get( ev_dt, 'expectedValue' );
		agntProp = allEV( agNumber, itnWanted );
	otherwise
		agntProp = obtain_property( ev_dt.snapshot_data, property, agNumber, itnWanted );
	end
otherwise
	error( 'expected_value_data.m: Incorrect number of input parameters' );
end
