function ev_dt = set( ev_dt, varargin )

% Name: set.m
% Location: MALT/dataClasses/@expected_value_data/set.m
% Purpose: Set expected_value_data properties in the specified object
% Input Parameters: expected_value_data object 
%			  name of property to change and new value
% Output Parameters: Updated expected_value_data object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'expectedvalue'
		ev_dt.expectedValue = newValue;
	otherwise
		ev_dt.snapshot_data = set( ev_dt.snapshot_data, property, newValue );
	end
end
