function ev_dt = subsasgn( ev_dt, field, value )

% Name: subsasgn.m
% Location: MALT/dataClasses/@expected_value_data/subsasgn.m
% Purpose: Define field name assignment for expected_value_data objects
% Input Parameters:  expected_value_data object 
%			   field that is wanted, by name index
%			   new value for the field
% Output Parameters: updated expected_value_agent object

switch field.type
case '()'
	error('@expected_value_data/subsasgn.m: Numeric array assignment not supported by expected_value_data objects');
case '.'
	switch lower( field.subs )
	case 'expectedvalue'
		ev_dt.expectedValue = value;
	otherwise
		ev_dt.snapshot_data = subsasgn( ev_dt.snapshot_data, field, value );
	end
case '{}'
	error('@expected_value_data/subsasgn.m: Cell array assignment not supported by expected_value_data objects');
end
