function value = subsref( ev_dt, field )

% Name: subsref.m
% Location: MALT/dataClasses/@expected_value_data/subsref.m
% Purpose: Define field name indexing for expected_value_data objects
% Input Parameters:	expected_value_data object 
%			  				field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@expected_value_data/subsref.m: Numeric array indexing not supported by expected_value_data objects');
case '.'
	switch lower( field.subs )
	case 'expectedvalue'
		value = ev_dt.expectedValue;
	otherwise
		value = subsref( ev_dt.snapshot_data, field );
	end
case '{}'
	error('@expected_value_data/subsref.m: Cell array indexing not supported by expected_value_data objects');
end
