function series_dt = add_to_series_data( series_dt, sIter, varargin )

% Name: add_to_series_data
% Location: MALT/dataClasses/@series_data/add_to_series_data.m
% Purpose: Add data items from an iteration to the series data object
% Input parameters:  series_data object
%                    iteration to be updated
%                    name of property to change and new value;
% Output parameters: Updated series_data object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'rewards'
		allRew = get( series_dt, 'rewards' );
		allRew( :, sIter ) = newValue;
		series_dt = set( series_dt, 'rewards', allRew );
	case 'actionsTaken'
		allActs = get( series_dt, 'actionsTaken' );
		allActs( :, sIter ) = newValue;
		series_dt = set( series_dt, 'rewards', allRew );
	case 'strategies'
		allStrats = get( series_dt, 'strategies' );
		allStrats( :, :, sIter ) = newValue;
		series_dt = set( series_dt, 'strategies', allStrats );
	otherwise
		error( ['add_to_series_data.m: Attempt to update unknown property ', property] );
	end
end
