function display( series_dt )

% Name: display.m
% Location: MALT/dataClasses/@series_data/display.m
% Purpose Displays a series_data object
% Input Parameters: series_data object
% Output Parameters: none

tLst = get( series_dt, 'storing' );

seriesDisp = sprintf( 'Run Number: %d\nNumber of agents: %d\nNumber of iterations: %d\n', ...
		series_dt.runNumber, series_dt.nAgents, series_dt.iterations );
seriesDisp = [seriesDisp 'Data items stored: '];
if ( length( tLst ) == 0 )
	seriesDisp = [seriesDisp 'none'];
else
	for stA = 1:length( tLst )
		seriesDisp = [seriesDisp sprintf( '%s ', tLst{stA} )];
	end
end

for svs = 1:length( tLst )
	switch lower( tLst{svs} )
	case 'rewards'
		[rRow rCol] = size( series_dt.rewards );
		seriesDispR = sprintf( '\nRewards: %dx%d', rRow, rCol );
		seriesDisp = [seriesDisp seriesDispR];
	case 'actionstaken'
		[aRow aCol] = size( series_dt.actionsTaken );
		seriesDispA = sprintf( '\nActions Taken: %dx%d', aRow, aCol );
		seriesDisp = [seriesDisp seriesDispA];
	case 'strategies'
		[sRow sCol sZ] = size( series_dt.strategies );
		seriesDispS = sprintf( '\nStrategies: %dx%dx%d', sRow, sCol, sZ );
		seriesDisp = [seriesDisp seriesDispS];
	end
end

disp( seriesDisp ); 
