function value = get( series_dt, property )

% Name: get.m
% Location: MALT/dataClasses/@series_data/get.m
% Purpose: Get series_data properties from the specified object
% Input Parameters: series_data object
%			  name of property
% Output Parameters: Value of the property

switch lower( property )
case 'nagents'
	value = series_dt.nAgents;
case 'iterations'
	value = series_dt.iterations;
case 'rewards'
	value = series_dt.rewards;
case 'actionstaken'
	value = series_dt.actionsTaken;
case 'strategies'
	value = series_dt.strategies;
case 'runnumber'
	value = series_dt.runNumber;
case 'storing'
	value = series_dt.storing;
otherwise
	error( ['@series_data/get.m: ', property,' is not a valid series_data property'] );
end
