function series_dt = set( series_dt, varargin )

% Name: set.m
% Location: MALT/dataClasses/@series_data/set.m
% Purpose: Set series data properties in the specified object
% Input Parameters: series_data object 
%			  name of property to change and new value
% Output Parameters: Updated series_data object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'nagents'
		series_dt.nAgents = newValue;
	case 'iterations'
		series_dt.iterations = newValue;
	case 'rewards'
		series_dt.rewards = newValue;
	case 'actionstaken'
		series_dt.actionsTaken = newValue;
	case 'strategies'
		series_dt.strategies = newValue;
	case 'runnumber'
		series_dt.runNumber = newValue;
	case 'storing'
		if ( isa( newValue, 'cell' ) )
			series_dt.storing = newValue;
		else
			disp( 'Error in ==> @series_data/set.m: attempt to assign non-cell list to property storing' );
		end
	otherwise
		error( '@series_data/set.m: Stage data properties: Number of agents, rewards, actions taken and strategies' );
	end
end
