function series_dt = subsasgn( series_dt, field, value )

% Name: subsasgn.m
% Location: MALT/dataClasses/@series_data/subsasgn.m
% Purpose: Define field name assignment for series_data objects
% Input Parameters:  series_data object 
%			   field that is wanted, by name index
%			   new value for the field
% Output Parameters: updated series_agent object

switch field.type
case '()'
	error('@series_data/subsasgn.m: Numeric array assignment not supported by series_data objects');
case '.'
	switch lower( field.subs )
	case 'nagents'
		series_dt.nAgents = value;
	case 'iterations'
		series_dt.iterations = value;
	case 'rewards'
		series_dt.rewards = value;
	case 'actionstaken'
		series_dt.actionsTaken = value;
	case 'strategies'
		series_dt.strategies = value;
	case 'runnumber'
		series_dt.runNumber = value;
	case 'storing'
   	if ( isa( value, 'cell' ) )
			series_dt.storing = value;
      else
         disp( 'Error in ==> @series_data/subsasgn.m: attempt to assign non-cell list to property storing' );
      end

	otherwise
		error('@series_data/subsasgn.m: Invalid field name used for assignment - unknown');
	end
case '{}'
	error('@series_data/subsasgn.m: Cell array assignment not supported by series_data objects');
end
