function value = subsref( series_dt, field )

% Name: subsref.m
% Location: MALT/dataClasses/@series_data/subsref.m
% Purpose: Define field name indexing for series_data objects
% Input Parameters: series_data object 
%			  field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@series_data/subsref.m: Numeric array indexing not supported by series_data objects');
case '.'
	switch lower( field.subs )
	case 'nagents'
		value = series_dt.nAgents;
	case 'iterations'
		value = series_dt.iterations;
	case 'rewards'
		value = series_dt.rewards;
	case 'actionstaken'
		value = series_dt.actionsTaken;
	case 'strategies'
		value = series_dt.strategies;
	case 'runnumber'
		value = series_dt.runNumber;
	case 'storing'
		value = series_dt.storing;
	otherwise
		error('@series_data/subsref.m: Invalid field name used for indexing - unknown');
	end
case '{}'
	error('@series_data/subsref.m: Cell array indexing not supported by series_data objects');
end
