function sd_data = snapshot_data( varargin )

% Name: snapshot_data.m
% Location: MALT/dataClasses/@snapshot_data/snapshot.m
% Purpose:	Constructor for the snapshot_data class
%				Adds a snapshotFrequency field, specifying how often to store data items
% Input Parameters:	no Parameters - defaults used
%							1 Parameter - object to copy
%							5 Parameters - Number of agents
%												Maximum number of actions over the agents
%												Number of iterations
%												Identification of which run is storing data
%												Cell list of what data items are being saved
% Output Parameters:	created snapshot_data object

switch nargin
case 0 % Create a default snapshot_data object

	sd_data.nAgents = 2;
	% snapshot_data class inherits from the series_data class,
	% but it doesn't add any new fields
	series_dt = series_data;
	sd_data = class( sd_data, 'snapshot_data', series_dt );

case 1
	if ( isa(varargin{1}, 'snapshot_data') )
		sd_data = varargin{1};
	else
		error( 'snapshot_data.m: Input argument is not a snapshot_data object' );
	end

case 5
	tStore = varargin{5};
	sd_data.nAgents = 2;
	series_dt = series_data( varargin{1}, varargin{2}, varargin{3}, varargin{4}, varargin{5} );
   sd_data = class( sd_data, 'snapshot_data', series_dt );
otherwise
	error_disp = sprintf( 'Valid parameters:\nNo Parameters - defaults used\n1 Parameter - object to copy\n5 Parameters - Number of agents, Maximum number of actions over the agents, Number of iterations, Identification of which run this is storing data for, Cell list of what data items are being saved' );
	disp( error_disp );
	error( 'snapshot_data.m: Wrong number of input arguments' );
end
