function sd_dt = subsasgn( sd_dt, field, value )

% Name: subsasgn.m
% Location: MALT/dataClasses/@snapshot_data/subsasgn.m
% Purpose: Define field name assignment for snapshot_data objects
% Input Parameters:  snapshot_data object 
%			   			field that is wanted, by name index
%						   new value for the field
% Output Parameters: updated snapshot_agent object

switch field.type
case '()'
	error('@snapshot_data/subsasgn.m: Numeric array assignment not supported by snapshot_data objects');
case '.'
	switch lower( field.subs )
	otherwise
		sd_dt.series_data = subsasgn( sd_dt.series_data, field, value );
	end
case '{}'
	error('@snapshots_data/subsasgn.m: Cell array assignment not supported by snapshots_data objects');
end
