function value = subsref( sd_dt, field )

% Name: subsref.m
% Location: MALT/dataClasses/@snapshot_data/subsref.m
% Purpose: Define field name indexing for snapshot_data objects
% Input Parameters:	snapshot_data object 
%			  				field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@snapshot_data/subsref.m: Numeric array indexing not supported by snapshot_data objects');
case '.'
	switch lower( field.subs )
%	case 'snapshots'
%		value = sd_dt.snapshots;
	otherwise
		value = subsref( sd_dt.series_data, field );
	end
case '{}'
	error('@snapshot_data/subsref.m: Cell array indexing not supported by snapshot_data objects');
end
