function tb_data = add_to_series_data( tb_data, sIter, varargin )

% Name: add_to_series_data.m
% Location: MALT/dataClasses/@track_belief_data/add_to_series_data.m
% Purpose: Add data items from an iteration to a belief_track_data object
% Input parameters:  track_belief_data object
%                    iteration to be updated
%                    name of property to change and new value
% Output parameters: Updated track_belief_data object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'trackbeliefs'
		allTracking = get( tb_data, 'trackBeliefs' );
		allTracking( :, :, sIter ) = newValue;
		tb_data = set( tb_data, 'trackBeliefs', allTracking );
	case 'actualstrats'
		allActual = get( tb_data, 'actualStrats' );
		allActual( :, :, sIter ) = newValue;
		tb_data = set( tb_data, 'actualStrats', allActual );
	otherwise
		tb_data.expected_value_data = add_to_series_data( tb_data.expected_value_data, sIter, property, newValue );
	end
end
