function agntProp = obtain_property( varargin )

% Name: obtain_property.m
% Location: MALT/dataClasses/@track_belief_data/obtain_property.m
% Purpose: Returns the property of agent agNumber, over all iterations
% Input Parameter:  track_belief_data object
%                   property that is wanted
%                   * optional * number of the agent
%                   * optional * iteration that is wanted
% Output Parameter: Property of the agent agNumber, either for all or for one specific iteration

tb_data = varargin{1};
property = varargin{2};

switch nargin
case 2 % Obtain property for all agents and iterations
	switch lower( property )
	case 'trackbeliefs'
		allTracking = get( tb_data, 'trackBeliefs' );
		agntProp = allTracking;
	case 'actualstrats'
		allActuals = get( tb_data, 'actualStrats' );
		agntProp = allActuals;
   otherwise
      agntProp = obtain_property( tb_data.expected_value_data, property );
	end

case 3 % Obtain property for a specific agent and all iterations
	agNumber = varargin{3};
	switch lower( property )
	case 'trackbeliefs'
		allTracking = get( tb_data, 'trackBeliefs' );
		agntProp = allTracking( agNumber, :, : );
	case 'actualstrats'
		allActual = get( tb_data, 'actualStrats' );
		agntProp = allActual( agNumb, :, : );
    otherwise
      agntProp = obtain_property( tb_data.expected_value_data, property, agNumber );
	end
case 4 % Obtain property for a specific agent and specific iteration
	agNumber = varargin{3};
	itnWanted = varargin{4};
	switch lower( property )
	case 'trackbeliefs'
		allTracking = get( tb_data, 'trackBeliefs' );
		agntProp = allTrack( agNumber, :, itnWanted );
	case 'actualstrats'
		allActual = get( tb_data, 'actualStrats' );
		agntPorp = allActual( agNumber, :, itnWanted );
   otherwise
      agntProp = obtain_property( tb_data.expected_value_data, property, agNumber, itnWanted );
	end
otherwise
	error( 'track_belief_data.m: Incorrect number of input parameters' );
end
