function tb_data = set( tb_data, varargin )

% Name: set.m
% Location: MALT/dataClasses/@track_belief_data/set.m
% Purpose: Set track_belief_data properties in the specified object
% Input Parameters: track_belief_data object 
%			  name of property to change and new value
% Output Parameters: Updated track_belief_data object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'trackbeliefs'
		tb_data.trackBeliefs = newValue;
	case 'actualstrats'
		tb_data.actualStrats = newValue;
	otherwise
		tb_data.expected_value_data = set( tb_data.expected_value_data, property, newValue );
	end
end
