function tb_data = subsasgn( tb_data, field, value )

% Name: subsasgn.m
% Location: MALT/dataClasses/@track_belief_data/subsasgn.m
% Purpose: Define field name assignment for track_belief_data objects
% Input Parameters:  track_belief_data object 
%			   field that is wanted, by name index
%			   new value for the field
% Output Parameters: updated track_belief_agent object

switch field.type
case '()'
	error('@track_belief_data/subsasgn.m: Numeric array assignment not supported by track_belief_data objects');
case '.'
	switch lower( field.subs )
	case 'trackbeliefs'
		tb_data.trackBeliefs = value;
	case 'actualStrats'
		tb_data.actualStrats = value;
	otherwise
			tb_data.expected_value_data = subsasgn( tb_data.expected_value_data, field, value );
	end
case '{}'
	error('@track_belief_data/subsasgn.m: Cell array assignment not supported by track_belief_data objects');
end
