function value = subsref( tb_data, field )

% Name: subsref.m
% Location: MALT/dataClasses/@track_belief_data/subsref.m
% Purpose: Define field name indexing for track_belief_data objects
% Input Parameters: track_belief_data object 
%			  field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@track_belief_data/subsref.m: Numeric array assignment not supported by track_belief_data objects');
case '.'
	switch lower( field.subs )
	case 'trackbeliefs'
		value = tb_data.trackBeliefs;
	case 'actualstrats'
		value = tb_data.actualStrats;
	otherwise
			value = subsref( tb_data.expected_value_data, field );
	end
case '{}'
	error('@track_belief_data/subsref.m: Cell array assignment not supported by track_belief_data objects');
end
