function gm = game( varargin )

% Name: game.m
% Location: MALT/gameClasses/@game/game.m
% Purpose:  Constructor for the base game class
%           Acts much like an abstract class, since there is not enoguh methods 
%           or details to instantiate directly from this class
% Input Parameters:  No parameters - default created
%                    1 Parameter - 	object to copy
%                    3 Parameters - name of the game
%                                   number of agents
%                                   number of actions for each agent (in an array)
%                    4 Parameters -	name of the game
%                                   number of agents
%                                   number of actions for each agent (in an array)
%                                   name of the gamut generated file
% Output Parameters: Created game object

switch nargin
case 0 % Create default game object
	gm.name = '';			% Name of game
	gm.nAgents = 0;		% Number of agents
	gm.totalActions = 0; % Number of actions per agent
	gm.fileName = '';		% Name of the file where the Gamut generated game is
	gm = class( gm, 'game' );
case 1 % Copy game object
	if ( isa(varargin{1}, 'game' ) )
		gm = varargin{1};
	else
		error( 'game.m: Wrong argument type. Game object expected' );
	end
case 3
	gm.name = varargin{1};
	if ( length( varargin{3} ) ~= varargin{2} )
		error( 'game.m: Need to specify the number of actions that each agent has' );
	end
	gm.nAgents = varargin{2};
	gm.totalActions = varargin{3};
	gm.fileName = '';
	gm = class( gm, 'game' );
case 4
	gm.name = varargin{1};
	if ( length( varargin{3} ) ~= varargin{2} )
		error( 'game.m: Need to specify the number of actions that each agent has' );
	end
	gm.nAgents = varargin{2};
	gm.totalActions = varargin{3};
	gm.fileName = varargin{4};
	gm = class( gm, 'game' );
otherwise
	error_disp = sprintf( 'Valid Parameters:\nNo Parameters - defaults used\n1 Parameter - game object to copy\n3 Parameters - name of game, number of agents, array of actions per agent' );
	disp( error_disp );
	error( 'game.m: Wrong number of input arguments' );
end
