function gm = set( gm, varargin )

% Name: set.m
% Location: MALT/gameClasses/@game/set.m
% Purpose: Set game properties in the specified object
% Input Parameters: 	game object 
%							name of property to change and new value
% Output Parameters: Updated game object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'name'
		gm.name = newValue;
	case {'nagents', 'numberagents'}
		gm.nAgents = newValue;
	case 'totalactions'
		gm.totalActions = newValue;
	case 'filename'
		gm.fileName = newValue;
	otherwise
		error( '@game/set.m: Game properties: name, nActions, totalActions' );
	end
end

