function gm = subsasgn( gm, field, value )

% Name: subsasgn.m
% Location: MALT/gameClasses/@game/subsasgn.m
% Purpose: Define field name assignment for game objects
% Input Parameters:  game object 
%							field that is wanted, by name index
%							new value for the field
% Output Parameters: updated game object

switch field.type
case '()'
	error( '@game/subsasgn.m: Numeric array indexing not supported by game objects' );
case '.'
	switch lower( field.subs )
	case 'name'
		gm.name = value;
	case {'nagents', 'numberagents'}
		gm.nAgents = value;
	case 'totalactions'
		gm.totalActions = value;
	case 'filename'
		gm.filename = value;
	otherwise
		error( '@game/subsasgn.m: Invalid field name used for indexing - unknown' );
	end
case '{}'
	error( '@game/subsasgn.m: Cell array indexing not supported by game objects' );
end
