function value = subsref( gm, field )

% Name: subsref.m
% Location: MALT/gameClasses/@game/subsref.m
% Purpose: Define field name/numeric indexing for game objects
% Input Parameters:  game object 
%							field that is wanted, either numeric or name index
% Output Parameters: value of the field

switch field.type
case '()'
	error( '@game/subsref.m: Numeric array indexing not supported by game objects' );
case '.'
	switch lower( field.subs )
	case 'name'
		value = gm.name;
	case {'nagents', 'numberagents'}
		value = gm.nAgents;
	case 'totalactions'
		value = gm.totalActions;
	case 'filename'
		value = gm.fileName;
	otherwise
		error( '@game/subsref.m: Invalid field name used for indexing - unknown' );
	end
case '{}'
	error( '@game/subsref.m: Cell array indexing not supported by game objects' );
end
