function nfg_gm = set( nfg_gm, varargin )

% Name: set.m
% Location: MALT/gameClasses/@nfg_game/set.m
% Purpose: Set normal form game properties in the specified object
% Input Parameters: 	normal form game object 
%				 			name of property to change and new value
% Output Parameters: Updated normal form game object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'payoffs'
		nfg_gm.payoffs = newValue;
	case {'eqa', 'equilibria', 'equilibrium'}
		nfg_gm.eqa = newValue;
	case 'guaranteed'
		nfg_gm.guaranteed = newValue;
	case 'guaranteed_strategies'
		nfg_gm.guaranteed_strategies = newValue;
	case 'random_seed'
		nfg_gm.random_seed = newValue;
	case 'gamutcommand'
		nfg_gm.gamutCommand = newValue;
	otherwise
		nfg_gm.game = set( nfg_gm.game, property, newValue );
	end
end
