function nfg_gm = subsasgn( nfg_gm, field, value )

% Name: subsasgn.m
% Location: MALT/Classes/@nfg_game/subsasgn.m
% Purpose: Define field name assignment for normal form game objects
% Input Parameters:	normal form game object 
%						 	field that is wanted, by name index
%							new value for that field
% Output Parameters: updated normal form game object

switch field.type
case '()'
	error('@nfg_game/subsasgn.m: Numeric array assignment not supported by normal form game objects');
case '.'
	switch lower( field.subs )
	case 'payoffs'
		nfg_gm.payoffs = value;
	case 'eqa'
		nfg_gm.eqa = value;
	case 'guaranteed'
		nfg_gm.guaranteed = value;
	case 'guaranteed_strategies'
		nfg_gm.guaranteed_strategies = value;
	case 'random_seed'
		nfg_gm.random_seed = value;
	case 'gamutcommand'
		nfg_gm.gamutCommand = value;
	otherwise
		nfg_gm.game = subsasgn( nfg_gm.game, field, value );
	end
case '{}'
	error('@nfg_game/subsref.m: Cell array assignment not supported by normal form game objects');
end
