function value = subsref( nfg_gm, field )

% Location: MALT/gameClasses/@nfg_game/subsref.m
% Purpose: Define field name indexing for normal form game objects
% Input Parameters:	normal form game object 
%		 					field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@nfg_game/subsref.m: Numeric array indexing not supported by nfg_game objects');
case '.'
	switch lower( field.subs )
	case 'payoffs'
		value = nfg_gm.payoffs;
	case {'eqa', 'equilibrium', 'equilibria'}
		value = nfg_gm.eqa;
	case 'guaranteed'
		value = nfg_gm.guaranteed;
	case 'guaranteed_strategies'
		value = nfg_gm.guaranteed_strategies;
	case 'random_seed'
		value = nfg_gm.random_seed;
	case 'gamutcommand'
		value = nfg_gm.gamutCommand;
	otherwise
		value = subsref( nfg_gm.game, field );
	end
case '{}'
	error('@nfg_game/subsref.m: Cell array indexing not supported by normal form game objects');
end
