function nfg_gm_idr = call_gambit_idr( nfg_gm_idr, gambitFile )

% Name: call_gambit_idr.m
% Location: MALT/gameClasses/@nfg_game_idr/call_gambit_idr.m
% Purpose:	Calls the Gambit suite to obtain the undominated strategies of a game
% Input Parameters:	normal form game object
% Output Parameters:	Updated normal form game object, 
%							with undominated strategies updated

gambitCommand = '/cs/public/lib/pkg/gambit-0.97.0.6/bin/./gcl ';

printOut( 'Calling gambit to calculate undominated actions' );
% Make the gambit call to obtain the undominated actions

% Generate the gambit Code file
generateGambitCode( nfg_gm_idr, gambitFile, 'idr' );

returnDir = pwd;
cd( '/cs/public/lib/pkg/gambit-0.97.0.6/bin' );
% Make the call to Gambit with the correct filename
[callS, returnedDet] = system( [gambitCommand gambitFile] );
cd( returnDir );
printOut( callS );
printOut( returnedDet )

nfg_gm_idr = call_idr( nfg_gm_idr );
