function nfg_gm_idr = set( nfg_gm_idr, varargin )

% Name: set.m
% Location: MALT/gameClasses/@nfg_game_idr/set.m
% Purpose: Set normal form game (with IDR) properties in the specified object
% Input Parameters: 	normal form game (with IDR) object 
%				 			name of property to change and new value
% Output Parameters: Updated normal form game (with IDR) object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'guaranteed_idr'
		nfg_gm_idr.guaranteed_idr = newValue;
	case 'guaranteed_idr_strategies'
		nfg_gm_idr.guaranteed_idr_strategies = newValue;
	case 'undominated_actions'
		nfg_gm_idr.undominated_actions = newValue;
	case 'payoffs_idr'
		nfg_gm_idr.payoffs_idr = newValue;
	case 'undominated_strategies'
		nfg_gm_idr.undominated_strategies = newValue;
	otherwise
		nfg_gm_idr.nfg_game = set( nfg_gm_idr.nfg_game, property, newValue );
	end
end
