function nfg_gm_idr = subsasgn( nfg_gm_idr, field, value )

% Name: subsasgn.m
% Location: MALT/Classes/@nfg_game_idr/subsasgn.m
% Purpose: Define field name assignment for normal form game )with IDR properties) objects
% Input Parameters:	normal form game (with IDR properties) object 
%						 	field that is wanted, by name index
%							new value for that field
% Output Parameters: updated normal form game (with IDR properties) object

switch field.type
case '()'
	error('@nfg_game_idr/subsasgn.m: Numeric array assignment not supported by normal form game (with IDR properties) objects');
case '.'
switch lower( field.subs )
	case 'guaranteed_idr'
		nfg_gm_idr.guaranteed_idr = value;
	case 'guaranteed_idr_strategies'
		nfg_gm_idr.guaranteed_idr_strategies = value;
	case 'undominated_actions'
		nfg_gm_idr.undominated_actions = value;
	case 'payoffs_idr'
		nfg_gm_idr.payoffs_idr = value;
	case 'undominated_strategies'
		nfg_gm_idr.undominated_strategies = value;
	otherwise
		nfg_gm_idr.nfg_game = subsasgn( nfg_gm_idr.nfg_game, field, value );
	end
case '{}'
	error('@nfg_game_idr/subsref.m: Cell array assignment not supported by normal form game (with IDR properties) objects');
end
