function value = subsref( nfg_gm_idr, field )

% Location: MALT/gameClasses/@nfg_game_idr/subsref.m
% Purpose: Define field name indexing for normal form game (with IDR) objects
% Input Parameters:	normal form game (with IDR) object 
%		 					field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error( '@nfg_game_idr/subsref.m: Numeric array indexing not supported by nfg_game_idr objects' );
case '.'
	switch lower( field.subs )
	case 'guaranteed_idr'
		value = nfg_gm_idr.guaranteed_idr;
	case 'guaranteed_idr_strategies'
		value = nfg_gm_idr.guaranteed_idr_strategies;
	case 'undominated_actions'
		value = nfg_gm_idr.undominated_actions;
	case 'payoffs_idr'
		value = nfg_gm_idr.payoffs_idr;
	case 'undominated_strategies'
		value = nfg_gm_idr.undominated_strategies;
	otherwise
		value = subsref( nfg_gm_idr.nfg_game, field );
	end
case '{}'
	error('@nfg_game_idr/subsref.m: Cell array indexing not supported by normal form game (with IDR properties) objects');
end
