function adapt_data( )

% Name: adapt_data.m
% Location: MALT/general/adapt_data.m
% Purpose:  Takes the missingData file and converts the information to the
%           format required for the Sun Grid Engine job system
% Input Parameters:  none
% Output Parameters: none

% Make the global variables visible
global SessionObject
global MALT_HOME
global SESSION_NAME
global STORAGE_DIRECTORY

fName = 'missingData';

fID = fopen( fName, 'r' );

if ( fID == -1 )
   error( 'adapt_data.m: Unable to open missingData file' );
end

% Construct the file name
fileName = [MALT_HOME STORAGE_DIRECTORY '/' SESSION_NAME '/cluster_adapt'];
clustF = fopen( fileName, 'w' );

nextLine = fgetl( fID );
fileRuns = 1;

% For each line in the missingData file,
% we create a job file for use in the Sun Grid Engine
% Some of the extra lines that are printed to the file are for specific
% use within the setup at UBC

while ( nextLine ~= -1 )
	fidRunName = [MALT_HOME STORAGE_DIRECTORY '/' SESSION_NAME '/adaptJob_' num2str( fileRuns )];
	fidRun = fopen( fidRunName, 'w' );

	fprintf( fidRun, '%s \n\n', '#!/bin/sh' );

	fprintf( fidRun, '%s \n', 'use matlab-7.0.1' );

	fprintf( fidRun, '%s \n', nextLine );
	
	fclose( fidRun );
	
	nextLine = fgetl( fID );

	fprintf( clustF, '%s \n', ['qsub -e /cs/SCRATCH/alipson/GRID_OUTPUT/ -o /cs/SCRATCH/alipson/GRID_OUTPUT/ ' 'adaptJob_' num2str( fileRuns )] );

	fileRuns = fileRuns + 1;
end

fclose( clustF );
fclose( fID );
