function sd_data = chooseSeries( agnt1, agnt2, varargin );

% Name: chooseSeries.m
% Location: MALT/general/chooseSeries.m
% Purpose:  Chooses which series_data object to create, 
%           depending on what data items are requested
% Input Parameters:  The agent object for the first/row agent
%                    The agent object for the second/column agent
%                    The parameters that are used to create a series_data object 
%                    (excluding the list of what data items should be saved
% Output Parameters: A series_data or child object
%% (no longer used)  List of which agents are doing tracking

global SessionObject % Make the SessionObject visible

whatDataItemsWanted = SessionObject.dataItems;

found = 0;
for nDi = 1: length( whatDataItemsWanted )
	switch lower( whatDataItemsWanted{nDi} )
	case {'rewards'}
		if ( found < 1 )
			found = 1;
		end
	case 'expectedvalue'
		if ( found < 2 )
			found = 2;
		end
	case 'trackbeliefs'
		if ( found < 4 )
			found = 4;
		end
	end
end

%trackers = [];

% Switch over which type of series object we want
switch found
case 0
	error( 'general/chooseSeries.m: Need to specify at least one data item to save' );
case 1
    sd_data = snapshot_data( varargin{1}, varargin{2}, varargin{3}, varargin{4}, whatDataItemsWanted );

case 2
	sd_data = expected_value_data( varargin{1}, varargin{2}, varargin{3}, varargin{4}, whatDataItemsWanted );

case 4
  	sd_data = track_belief_data( varargin{1}, varargin{2}, varargin{3}, varargin{4}, whatDataItemsWanted );

end
