function fName = create_file_name( algName1, algName2, gameName, extension )

% Name: create_file_name.m
% Location MALT/general/create_file_name.m
% Purpose: Creates a file name from the supplied information
% Input Parameters:	Name of the first algorithm
%							Name of the second algorithm
%							Name of the game
%							Extension to add to the name
% Output Parameters: filename

global MALT_HOME
global SESSION_NAME
global STORAGE_DIRECTORY

if ( isequal( extension, 'session' ) )
	fName = ['session.mat'];
elseif ( isequal( extension, 'fileList' ) )
	fName = ['fileList'];
else
	fName = [algName1 '_' algName2 '_' gameName '-' extension '.mat'];
end

fName = [MALT_HOME STORAGE_DIRECTORY '/' SESSION_NAME '/' fName];
