function fName = create_file_name_cluster( algName1, algName2, gameName, runNumb, flipNumb, extension )

% Name: create_file_name_cluster.m
% Location MALT/general/create_file_name_cluster.m
% Purpose: Creates a file name from the supplied information
% Input Parameters:	Name of the first algorithm
%							Name of the second algorithm
%							Name of the game
%							Number of the run
%							Extension to add to the name
% Output Parameters: filename

global MALT_HOME
global SESSION_NAME
global STORAGE_DIRECTORY

% Runs through the possible extensions to find the correct file name,
% relevant to that extension
if ( isequal( extension, 'stats' ) )
	fName = [extension '.mat'];
elseif ( isequal( extension, 'session' ) )
	fName = ['session.mat'];
elseif ( isequal( extension, 'fileList' ) )
	fName = ['fileList'];
else
   if isequal( runNumb, '' )
   	fName = [algName1 '_' algName2 '_' gameName '_' num2str( flipNumb ) '-' extension '.mat'];
   else
      fName = [algName1 '_' algName2 '_' gameName '_' num2str( runNumb ) '_' num2str( flipNumb ) '-' extension '.mat'];
   end
end

fName = [MALT_HOME STORAGE_DIRECTORY '/' SESSION_NAME '/' fName];
