function [fName, number] = create_file_name( algName1, algName2, gameName, number, extension )

% Name: create_file_name.m
% Location MALT/general/create_file_name.m
% Purpose: Creates a file name from the supplied information
% Input Parameters:	Name of the first algorithm
%							Name of the second algorithm
%							Name of the game
%							Extension to add to the name
% Output Parameters: filename

% Make global variables visible
global MALT_HOME
global SESSION_NAME
global STORAGE_DIRECTORY

% Code below creates unique file names for the different suffixes
if ( number == 0 )
	% Create new number
	fValid = 0;
	while ( ~fValid )
		fValid = 1;
		if ( isequal( extension, 'stats' ) )
			fName = [SESSION_NAME '_' num2str( number ) '_' extension '.mat'];
		elseif ( isequal( extension, 'session' ) )
			fName = [SESSION_NAME '_session.mat'];
		else
			fName = [SESSION_NAME '_' num2str( number ) '_' algName1 '_' algName2 '_' gameName '-' extension '.mat'];
		end
		fID = fopen( fName );
		if ( fID ~= -1 )
			number = number + 1;
			tp = fclose( fID );
			fValid = 0;
		end
	end
else
	% Number previously created
	if ( isequal( extension, 'stats' ) )
		fName = [SESSION_NAME '_' num2str( number ) '_' extension '.mat'];
	elseif ( isequal( extension, 'session' ) )
		fName = [SESSION_NAME '_session.mat'];
	else
		fName = [SESSION_NAME '_' num2str( number ) '_' algName1 '_' algName2 '_' gameName '-' extension '.mat'];
	end
end

fName = [MALT_HOME STORAGE_DIRECTORY '/' SESSION_NAME '/' fName];
