function undomLstAll = idrReader( nAgents, fileName )

% Name: idrReader.m
% Location: MALT/general/idrReader.m
% Purpose:	Generate the Matlab matrix format of undominated strategies,
%				as calculated by Gambit
% Input Parameters:	Number of agents
%							Name of Gambit generated file
% Output Parameters:	Vector with a 1 in the undominated actions

% Open the file containing details of the iterated dominance
fid = fopen( fileName );

if ( fid == -1 )
% File doesn't exist
	error( ['general/idrReader.m: File ' fileName ' does not exist'] );
end

undomLstAll = cell(1, nAgents);
txtCount = 1;
lRead = fgetl( fid );

% Read through the file generated by Gambit
% This is just processing the text in the file

while ( ~isequal(lRead(1, txtCount), '{') )
	txtCount = txtCount + 1;
end % while: ~isequal
txtCount = txtCount + 1;

for agnt = 1:nAgents
	undomLst = [];
	while ( ~isequal(lRead(1, txtCount), '{') )
		txtCount = txtCount + 1;
	end % while: ~isequal '{'
	txtCount = txtCount + 1;
	while ( ~isequal(lRead(1, txtCount), '}') )
		if ( ~isequal(lRead(1, txtCount), '"') )
			undomLst = [undomLst lRead(1, txtCount)];
		end % if: ~isequal '"'
		txtCount = txtCount + 1;
	end % while: ~isequal '}'
	undomLstAll(1, agnt) = {str2num(undomLst)};
	
end

% Close the file
fclose( fid );
