function printOut( whatToPrint )

% Name: printOut.m
% Location: MALT/general/printOut.m
% Purpose:  Does a print out of "whatToPrint" to both the screen and a file
% Input Parameters:  What is to be displayed and printed
% Output Parameters: Nothing

global SESSION_NAME
global MALT_HOME
global DEBUG_MODE
global STORAGE_DIRECTORY

switch DEBUG_MODE
case 0
	% Do nothing
case 1
	% Will both print up output to screen and log to a file
	fid = fopen( [MALT_HOME STORAGE_DIRECTORY '/' SESSION_NAME '/logOutput.txt'], 'a' );
	if ( fid == -1 )
		error( 'general/printOut.m: Error - unable to open file for logging output' );
	end
	
	fprintf( fid, [whatToPrint '\n'] ); % Print to file
	
	fclose( fid );
	
	disp( whatToPrint ); % Print to screen
case 2
	% Printup all the displays to file
	fid = fopen( [MALT_HOME STORAGE_DIRECTORY '/' SESSION_NAME '/logOutput.txt'], 'a' );
   if ( fid == -1 )
	   error( 'general/printOut.m: Error - unable to open file for logging output' );
	end
	
	fprintf( fid, [whatToPrint '\n'] ); % Print to file
   fclose( fid );
case 3
	% Print up all the displays just to the screen
	disp( whatToPrint ); % Print to screen
end
