function combination = versusList( nNumb )

% Name: versusList.m
% Location: MALT/general/versusList.m
% Purpose: Creates a 2d list consisting of the combination of 
%				numbers from 1:nNumb
% Input Parameters: Single number (maximum number used)
% Output Parameters: Combination list of the number 1:nNumb against each other

% Each agent plays against each other agent,
% but we do not repeat combinations
combination = zeros(2, length(nNumb)^2);
tCount = 1;
for inT = 1:nNumb
	for exT = inT:nNumb
		combination(1, tCount) = inT;
		combination(2, tCount) = exT;
		tCount = tCount + 1;
	end
end

combination = combination(:, 1:tCount - 1);

