function exp_met = expected_value_metric( varargin )

% Name: expected_value_metric.m
% Location: MALT/metricClasses/@expected_value_metric/expected_value_metric.m
% Purpose:  Constructor for the expected_value_metric class
%           Just takes the expected value data that was stored and uses that as its data
% Input Parameters: no Parameters - defaults created
%                   1 Parameter - object to copy
%                              || frequency to store this metric at
% Output Parameters: expected_value_metric object

switch nargin
case 0 % Create default expected_value_metric object
	exp_met.name = 'expected_value_metric';
	% expected_value_metric class inherits from the metric class
	met = metric( 'expected_value_metric', 'Expected value of stage games',...
			{'expectedvalue'}, {'xlabel' 'iterations' 'ylabel' 'Expected value' 'title' 'Expected value of a stage game over iterations'}, '', 1 );

	exp_met = class( exp_met, 'expected_value_metric', met );
case 1 % Copy another expected_value_metric object
	if ( isa( varargin{1}, 'expected_value_metric' ) )
		exp_met = varargin{1};
	elseif isnumeric( varargin{1} )
		% Want to set the frequency of the metric ourselves
		exp_met.name = 'expected_value_metric';
		met = metric( 'expected_value_metric', 'Expected value of stage games',...
				{'expectedvalue'}, {'xlabel' 'iterations' 'ylabel' 'Expected value' 'title' ['Expected value of a stage game over iterations, with frequency ' num2str( varargin{1} )]}, '', varargin{1} );
				
		exp_met = class( exp_met, 'expected_value_metric', met );
	else
		error( 'expected_value_metric.m: Input argument is not an expected_value_metric object or a numeric singleton' );
	end
otherwise
	error_disp = sprintf( 'Valid parameters:\nNo Parameters - defaults used\n1 Parameter - Object to copy OR numeric value representing frequency' );
	disp( error_disp );
	error( 'expected_value_metric.m: Incorrect number of input arguments' );
end
