function kc_met = k_competitiveness_metric( varargin )

% Name: k_competitiveness_metric.m
% Location: MALT/metricClasses/@k_competitiveness_metric/k_competitiveness_metric.m
% Purpose:  Constructor for the k_competitiveness_metric class
%           Gives a percentage of best response at each iteration
% Input Parameters: no Parameters - defaults created
%                   1 Parameter - object to copy
%                              || frequency to store this metric at
% Output Parameters: k_competitiveness_metric object

switch nargin
case 0 % Create default k_competitiveness_metric object
	kc_met.name = 'k_competitiveness_metric';
	% k_competitiveness_metric class inhrits from the metric constructor
	met = metric( 'k_competitiveness_metric', 'Percent of best response achieved', {'rewards'}, {'xlabel' 'iterations' 'ylabel' 'Percent of best response' 'title' 'Percent of best response achieved at each stage game'}, '', 1 );

	kc_met = class( kc_met, 'k_competitiveness_metric', met );
case 1 % Copy another k_competitiveness_metric object
	if ( isa( varargin{1}, 'k_competitiveness_metric' ) )
		kc_met = varargin{1};
	elseif isnumeric( varargin{1} )
		% Want to set the frequency of the metric ourselves
		kc_met.name = 'k_competitiveness_metric';
		met = metric( 'k_competitiveness_metric', 'Percent of best response achieved', {'rewards'}, {'xlabel' 'iterations' 'ylabel' 'Percent of best response' 'title' ['Percent of best response achieved, with frequency ' num2str( varargin{1} )]}, '', varargin{1} );
				
		kc_met = class( kc_met, 'k_competitiveness_metric', met );
	else
		error( 'k_competitiveness_metric.m: Input argument is not an k_competitiveness_metric object or a numeric singleton' );
	end
otherwise
	error_disp = sprintf( 'Valid parameters:\nNo Parameters - defaults used\n1 Parameter - Object to copy OR numeric value representing frequency' );
	disp( error_disp );
	error( 'k_competitiveness_metric.m: Incorrect number of input arguments' );
end
