function display( met )

% Name: display.m
% Location: MALT/metricClasses/@metric/display.m
% Purpose: Displays a metric object
% Input Parameters:  metric object
% Output Parameters: none

% Take value of metric
% Can access as met.field, because it is an internal function
nNeed = length( met.needed_data );
nLabels = length( met.labels );
nProperties = length( met.properties )/2; % Divide by two since list is name + new value

metDisp = sprintf( 'Actual name: %s\nDisplay name: %s\nNeeded data: %d\nLabels: %d\nProperties: %d\nFrequency: %d ', met.name, met.displayName, nNeed, nLabels, nProperties, get( met, 'frequency' ) );

disp( metDisp );
