function met = set( met, varargin )

% Name: set.m
% Location: MALT/metricClasses/@metric/set.m
% Purpose: Set metric properties in the specified object
% Input Parameters: 	metric object 
%							name of property to change and new value
% Output Parameters: Updated metric object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'name'
		met.name = newValue;
	case 'displayname'
		met.displayName = newValue;
	case 'needed_data'
		met.needed_data = newValue;
	case 'labels'
		met.labels = newValue;
	case 'properties'
		met.properties = newValue;
	case 'frequency'
		met.frequency = newValue;
	otherwise
		error( '@metric/set.m: Metric properties: Name, Needed_data, Labels, Averaging' );
	end
end
