function met = subsasgn( met, field, value )

% Name: subsasgn.m
% Location: MALT/metricClasses/@metric/subsasgn.m
% Purpose: Define field name assignment for metric objects
% Input Parameters:  metric object 
%							field that is wanted, by name index
%							new value for the field
% Output Parameters: updated metric object

switch field.type
case '()'
	error('@metric/subsasgn.m: Numeric array indexing not supported by metric objects');
case '.'
	switch lower( field.subs )
	case 'name'
		met.name = value;
	case 'displayname'
		met.displayName = value;
	case 'needed_data'
		met.needed_data = value;
	case 'labels'
		met.labels = value;
	case 'properties'
		met.properties = value;
	case 'frequency'
		met.frequency = value;
	otherwise
		error('@metric/subsasgn.m: Invalid field name used for indexing - unknown');
	end
case '{}'
	error('@metric/subsasgn.m: Cell array indexing not supported by metric objects');
end
