function value = subsref( met, field )

% Name: subsref.m
% Location: MALT/metricClasses/@metric/subsref.m
% Purpose: Define field name indexing for metric objects
% Input Parameters:  metric object 
%							field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error( '@metric/subsref.m: Numeric array indexing not supported by metric objects' );
case '.'
	switch lower( field.subs )
	case 'name'
		value = met.name;
	case 'displayname'
		value = met.displayName;
	case 'needed_data'
		value = met.needed_data;
	case {'valid_visuals', 'valid_visualisations'}
		value = met.valid_visuals;
	case 'labels'
		value = met.labels;
	case 'properties'
		value = met.properties;
	case 'frequency'
		value = met.frequency;
	otherwise
		error( '@metric/subsref.m: Invalid field name used for indexing - unknown' );
	end
case '{}'
	error( '@metric/subsref.m: Cell array indexing not supported by metric objects' );
end
