function statMetObj = metric_cleanup( metObj, availMetData, gameName, agntNames )

% Name: metric_cleanup.m
% Location: MALT/metricClasses/@regret_metric/metric_cleanup.m
% Purpose:  Final conversation of the data generated by this metric into a metric statistic object
% Input Parameters: Metric object, for the metric being run
%                   Variable that is storing the data
%                   Current game name
%                   cell of the two agent names
% Output Parameter: Metric statistic object

% Take the data
agnt1Data = availMetData.agent1;
agnt2Data = availMetData.agent2;

regretData = [max( agnt1Data ); max( agnt2Data )];

% Call the metric_statistics constructor
statMetObj = metric_statistics( get( metObj, 'name' ),...
				[get( metObj, 'labels' ) {'gamename' gameName}],...
				get( metObj, 'properties' ), agntNames,...
				regretData, 'Generated by @regret_metric object' );
