function data_var = metric_data_format( metObj, varargin )

% Name: metric_data_format.m
% Location: MALT/metricClasses/@regret_metric/metric_data_format.m
% Purpose:  Method to create the correct sized "data variable",
%           for storing the statistics generated by the metric object
% Input Parameters: Metric object, for the metric being run
%                   varargin{1} = number of actions per agent
% Output Parameter: data variable

% Check that we have a regret_metric object being passed as a parameter
if ( ~isa( metObj, 'regret_metric' ) )
	error( '@wins_metric/metric_data_format.m: First argument should be a regret_metric object' );
end

% We need to know the number of iterations for this
allActs = varargin{1};
% Create a structure with that information
data_var = struct( 'agent1', zeros( 1, allActs(1) ), 'agent2', zeros( 1, allActs(2) ) );
