function data_var = metric_data_format( metObj, varargin )

% Name: metric_data_format.m
% Location: MALT/metricClasses/@reward_metric/metric_data_format.m
% Purpose:  Method to create the correct sized "data variable",
%           for storing the statistics generated by the metric object
% Input Parameters: Metric object, for the metric being run
%                   varargin{1} = number of actions per agent
% Output Parameter: data variable

% Check that we have a metric object as a parameter
if ( ~isa( metObj, 'metric' ) )
	error( '@wins_metric/metric_data_format.m: First argument should be a metric object' );
end

% We need to know the number of iterations for this
% Make global variable visible
global SessionObject
% Get parameter values
param = get( SessionObject, 'parameter' );
totIts = get( param, 'totalIterations' );
setIts = get( param, 'settle' );

data_var = zeros( 2, totIts - setIts );
