function availMetData = run_metric_single( metObj, varargin )

% Name: run_metric_single.m
% Location: MALT/metricClasses/@track_l1_metric/run_metric_single.m
% Purpose:  Adds the data that this metric requires, from this iteration
% Input Parameters: Metric object, for the metric being run
%                   Variable that is storing the data
%                   Data structure with information from this iteration
%                   First agent object
%                   Second agent object
%                   Number of the game being played
%                   Number of the current run
%                   Number of the current iteration *being saved* ie. relative number
% Output Parameter: Updated variable storing the data

% Make global variable visible
global SessionObject

% Copy the relevant input parameters to variables
availMetData = varargin{1};
dataStructure = varargin{2};
cIteration = varargin{7};

% Take the estimated and actual tracking values
itsEst = dataStructure.trackEst;
itsAct = dataStructure.trackActual;

% pre norm calculation step - determine the differences
preNorm = itsEst - itsAct;
% Then calculate the l1-norm for the two agents on this iteration and save it
availMetData(1, cIteration ) = norm( preNorm(1, : ), 1 );
availMetData(2, cIteration ) = norm( preNorm(2, : ), 1 );
