function availMetData = run_metric_single( metObj, varargin )

% Name: run_metric_single.m
% Location: MALT/metricClasses/@track_l2_metric/run_metric_single.m
% Purpose:  Adds the data that this metric requires, from this iteration
% Input Parameters: Metric object, for the metric being run
%                   Variable that is storing the data
%                   Data structure with information from this iteration
%                   First agent object
%                   Second agent object
%                   Number of the game being played
%                   Number of the current run
%                   Number of the current iteration *being saved* ie. relative number
% Output Parameter: Updated variable storing the data

% Make global variable visible
global SessionObject

% Save relevant inputs to variables
availMetData = varargin{1};
dataStructure = varargin{2};
cIteration = varargin{7};

% Take data
itsEst = dataStructure.trackEst;
itsAct = dataStructure.trackActual;

% pre norm calculation step - determine the differences
preNorm = itsEst - itsAct;
% Then calculate the l2-norm for the two agents on this iteration and save it
% Note: the l2-norm is the default for 'norm' and hence we don't specify it as a parameter,
% since this is a lot faster, than specifying the parameter
availMetData(1, cIteration ) = norm( preNorm(1, : ) );
availMetData(2, cIteration ) = norm( preNorm(2, : ) );
