function statMetObj = metric_cleanup( metObj, availMetData, gameName, agntNames )

% Name: metric_cleanup.m
% Location: MALT/metricClasses/@wins_metric/metric_cleanup.m
% Purpose:  Final conversation of the data generated by this metric into a metric statistic object
% Input Parameters: Metric object, for the metric being run
%                   Variable that is storing the data
%                   Current game name
%                   cell of the two agent names
% Output Parameter: Metric statistic object

% Vectorised version -- about 10x faster than a loop version over all the iterations
equalWins = availMetData( 1, : ) == availMetData( 2, : );
winAgnt1 = ( availMetData( 1, : ) > availMetData( 2, : ) ) + (1/2)*equalWins;
winAgnt2 = ( availMetData( 1, : ) < availMetData( 2, : ) ) + (1/2)*equalWins;

% Call the metric_statistics constructor
statMetObj = metric_statistics( get( metObj, 'name' ),...
				[get( metObj, 'labels' ) {'gamename' gameName}],...
				get( metObj, 'properties' ), agntNames, [winAgnt1; winAgnt2],...
				'Generated by @wins_metric object' );
