function data_var = metric_data_format( metObj, varargin )

% Name: metric_data_format.m
% Location: MALT/metricClasses/@wins_metric/metric_data_format.m
% Purpose:  Method to create the correct sized "data variable",
%           for storing the statistics generated by the metric object
% Input Parameters: Metric object, for the metric being run
%                   varargin{1} = number of actions per agent
% Output Parameter: data variable

% Check that the input is a metric object
if ( ~isa( metObj, 'metric' ) )
	error( '@wins_metric/metric_data_format.m: First argument should be a metric object' );
end

% We need to know the number of iterations for this
global SessionObject % Make global variable visible
param = get( SessionObject, 'parameter' );
totIts = get( param, 'totalIterations' );
setIts = get( param, 'settle' );

% Preallocate the data
data_var = zeros( 2, totIts - setIts );
