function availMetData = run_metric_single( metObj, varargin )

% Name: run_metric_single.m
% Location: MALT/metricClasses/@wins_metric/run_metric_single.m
% Purpose:  Adds the data that this metric requires, from this iteration
% Input Parameters: Metric object, for the metric being run
%                   Variable that is storing the data
%                   Data structure with information from this iteration
%                   First agent object
%                   Second agent object
%                   Number of the game being played
%                   Number of the current run
%                   Number of the current iteration *being saved* ie. relative number
% Output Parameter: Updated variable storing the data

% Save relevant input parameters to variables
availMetData = varargin{1};
dataStructure = varargin{2};
cIteration = varargin{7};

% Take reward values
itsRewards = dataStructure.rewards;

% Save back
availMetData( :, cIteration ) = itsRewards;
