function display( param )

% Name: display.m
% Location: MALT/parameterClasses/@parameter/display.m
% Purpose:	Display method for the parameter class
% Input Parameters: Parameter object
% Output Parameters: None

% Put the value of the parameters into a string for display
paramDisp = ['Game commands: '];
for gms = 1:length( param.gamutCommand )
	paramDisp = [paramDisp sprintf( '%s ', char( param.gamutCommand{gms} ) ) ', '];
end
disp( paramDisp );
	
algsDisp = ['Algorithms: '];
for algs = 1:length( param.algmList )
	algsDisp = [algsDisp sprintf( '%s ', char( param.algmList{algs} ) ) ', '];
end
disp( algsDisp );

metsDisp = ['Metric names: '];
for mets = 1:length( param.metricNames )
	metsDisp = [metsDisp sprintf( '%s ', char( param.metricNames{mets} ) ) ','];
end
disp( metsDisp );

restDisp = sprintf( 'Settling in iterations: %d\nTotal iterations: %d\nNumber of runs: %d\nSession type: %s', ...
		param.settle, param.totalIterations, param.runs, param.sessionType );
disp( restDisp );
