function param = set( param, varargin )

% Name: set.m
% Location: MALT/parameterClasses/@parameter/set.m
% Purpose: Set parameter properties in the specified object
% Input Parameters:	parameter object
%				name of property to change and new value
% Output Parameters:	Updated parameter object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};
	propertyArgIn = propertyArgIn(3:end);

	switch lower( property )
	case 'gamutcommand'
		param.gamutCommand = newValue;
	case 'algmlist'
		param.algList = newValue;
	case 'settle'
		param.settle = newValue;
	case 'totaliterations'
		param.totalIterations = newValue;
	case 'runs'
		param.runs = newValue;
	case 'sessiontype'
		param.sessionType = newValue;
	case 'metricnames'
		param.metricNames = newValue;
	otherwise
		error( '@parameter/set.m: Parameter fields: gamutCommand, algList, settle, iterations, runs' );
	end
end
