function param = subsasgn( param, field, value )

% Name: subsasgn.m
% Location: MALT/parameters/@parameter/subsasgn.m
% Purpose: Define field name assignment for parameter objects
% Input Parameters:	parameter object
%			field that is wanted, by name index
%			new value for that field
% Output Parameters:	updated parameter object

switch field.type
case '()'
	error( '@parameter/subsasgn.m: Numeric array indexing not supported by parameter objects' );
case '.'
	switch lower( field.subs )
	case 'gamutcommand'
		param.gamutCommand = value;
	case 'algmlist'
		param.algmList = value;
	case 'settle'
		param.settle = value;
	case 'totaliterations'
		param.totalIterations = value;
	case 'runs'
		param.runs = value;
	case 'sessiontype'
		param.sessionType = value;
	case 'metricnames'
		param.metricNames = value;
	otherwise
		error( '@parameter/subsasgn.m: Invalid field name used for indexing' );
	end
case '{}'
	error( '@parameter/subsasgn.m: Cell array indexing not supported by parameter objects' );
end
