function value = subsref( param, field )

% Name: subsref.m
% Location: MALT/parameters/@parameter/subsref.m
% Purpose: Define field name indexing for parameter objects
% Input Parameters:	parameter object
%			field that is wanted, by name index
% Output Parameters:	value of the field

switch field.type
case '()'
	error( '@parameter/subsref.m: Numeric array indexing not supported by parameter object' );

case '.'
	switch lower( field.subs )
	case 'gamutcommand'
		value = param.gamutCommand;
	case 'algmlist'
		value = param.algmList;
	case 'settle'
		value = param.settle;
	case 'totaliterations'
		value = param.totalIterations;
	case 'runs'
		value = param.runs;
	case 'sessiontype'
		value = param.sessionType;
	case 'metricnames'
		value = param.metricNames;
	otherwise
		error( '@parameter/subsref.m: Invalid field name used for indexing - unknown' );
	end
case '{}'
	error( '@parameter/subsref.m: Cell array indexing not suppported by parameter object' );
end

