function display( sn )

% Name: display.m
% Location: MALT/sessionClasses/@session/display.m
% Purpose: Displays a session object
% Input Parameters: session object
% Output Parameters: none

% Obtain values of the fields in the sessionObject 
agLength = length( sn.agentList );
gmLength = size( sn.gameList, 2 );
mtLength = length( sn.metricList );
pmLength = length( sn.parameter );
dmLength = length( sn.dataItems );
dtaOften = sn.howOften;

hwDisp = [];
for hw = 1:dmLength
	hw = [hw dtaOften( hw )];
end

[cRow cCol] = size( sn.agentCombination );
tFlist = sn.fileList;
flLength = length( tFlist );

emp = 0;
for empCheck = 1: flLength
	tFileName = tFlist{ empCheck };
	if ( ~isempty( tFileName ) )
		emp = emp + 1;
	end
end

snDisp = [sprintf( 'Agent list: %d agent(s)\nGame list: %d game(s)\nMetric list: %d metric(s) \nParameter: %d parameter\nData Items: %d item(s)\nData snapshots: ', agLength, gmLength, mtLength, pmLength, dmLength ) hwDisp sprintf('\nAgent combination: %d combination(s)\nFile list: %d/%d saved', ...
			 cCol, emp, flLength )];

disp( snDisp );
