function value = get( sn, property )

% Name: get.m
% Location: MALT/sessionClasses/@session/get.m
% Purpose: Get session properties from the specified object
% Input Parameters:	session object 
%			  				name of property that is requested
% Output Parameters: value of the property

switch lower( property )
case 'agentlist'
	value = sn.agentList;
case 'gamelist'
	value = sn.gameList;
case 'metriclist'
	value = sn.metricList;
case 'parameter'
	value = sn.parameter;
case 'dataitems'
	value = sn.dataItems;
case 'howoften'
	value = sn.howOften;
case 'agentcombination'
	value = sn.agentCombination;
case 'filelist'
	value = sn.fileList;
otherwise
	error( sprintf( '@session/get.m: %s is not a valid session property.\nSession properties - agentList, gameList, metricList, parameter, agentCombination', property ) );
end
