function sn = set( sn, varargin )

% Name: set.m
% Location: MALT/sessionClasses/@session/set.m
% Purpose: Set session properties in the specified object
% Input Parameters: 	session object 
%				 			name of property to change and new value
% Output Parameters: Updated session object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'agentlist'
		sn.agentList = newValue;
	case 'gamelist'
		sn.gameList = newValue;
	case 'metriclist'
		sn.metricList = newValue;
	case 'parameter'
		sn.parameter = newValue;
	case 'dataitems'
		sn.dataItems = newValue;
	case 'howoften'
		sn.howOften = newValue;
	case 'agentcombination'
		sn.agentCombination = newValue;
	case 'filelist'
		sn.fileList = newValue;
	otherwise
		error( sprintf( '@session/set.m: Attempt to set invalid property.\nSession properties - agentList, gameList, metricList, parameter, agentCombination' ) );
	end
end
