function sn = subsasgn( sn, field, value )

% Name: subsasgn.m
% Location: MALT/sessionClasses/@session/subsasgn.m
% Purpose: Define field name assignment for session objects
% Input Parameters:	session object 
%						 	field that is wanted, by name index
%							new value for that field
% Output Parameters: updated session object

switch field.type
case '()'
	error('@session/subsasgn.m: Numeric array assignment not supported by session objects');
case '.'
	switch lower( field.subs )
	case 'agentlist'
		sn.agentList = value;
	case 'gamelist'
		sn.gameList = value;
	case 'metriclist'
		sn.metricList = value;
	case 'parameter'
		sn.parameter = value;
	case 'dataitems'
		sn.dataItems = value;
	case 'howoften'
		sn.howOften = value;
	case 'agentcombination'
		sn.agentCombination = value;
	case 'filelist'
		sn.fileList = value;
	otherwise
		error('@session/subsref.m: Invalid field name used for assignment - unknown');
	end
case '{}'
	error('@session/subsref.m: Cell array assignment not supported by session objects');
end
