function value = subsref( sn, field )

% Location: MALT/sessionClasses/@session/subsref.m
% Purpose: Define field name indexing for session objects
% Input Parameters:	session object 
%		 					field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@session/subsref.m: Numeric array indexing not supported by session objects');
case '.'
	switch lower( field.subs )
	case 'agentlist'
		value = sn. agentList;
	case 'gamelist'
		value = sn.gameList;
	case 'metriclist'
		value = sn.metricList;
	case 'parameter'
		value = sn.parameter;
	case 'dataitems'
		value = sn.dataItems;
	case 'howoften'
		value = sn.howOften;
	case 'agentcombination'
		value = sn.agentCombination;
	case 'filelist'
		value = sn.fileList;
	otherwise
		error('@sessionClassed/subsref.m: Invalid field name used for indexing - unknown');
	end
case '{}'
	error('@session/subsref.m: Cell array indexing not supported by session objects');
end
