function [stratValue, strat] = return_guaranteed( nGame, agntNumb )

% Name: return_guaranteed.m
% Location: MALT/sessionClasses/GlobalFiles/Normal_Form_Games/return_guaranteed.m
% Purpose:  Returns the guaranteed value of game for a specific agent
% Input Parameters:  number of the game being played
%                    number of the agent
% Output Parameters: Guaranteed value of the game for the agent
%                    and the strategy that plays that guaranteed value
%                    *optional* the global SessionObject might be updated

% Make the global variable visible
global SessionObject

% Get the normal_form_game object
gamesAll = get( SessionObject, 'gameList' );
nfg_gm = gamesAll{nGame};

% Get the values and strategies for the guaranteed values
allValues = get( nfg_gm, 'guaranteed' );
allValuesStrat = get( nfg_gm, 'guaranteed_strategies' );
needToCreate = 0;

if isempty( allValues ) % Guaranteed payoffs has not been previously created
	needToCreate = 1;
	% Call the method to obtain the guaranteed values
	nfg_gm = call_guaranteed( nfg_gm );

	allValues = get( nfg_gm, 'guaranteed' );
	allValuesStrat = get( nfg_gm, 'guaranteed_strategies' );
end

% Determine which agent to return
stratValue = allValues( agntNumb );
strat = allValuesStrat( agntNumb, : );

% Update the normal form game with those values
gamesAll(nGame) = {nfg_gm};
SessionObject = set( SessionObject, 'gameList', gamesAll );
