function retVal = value( nGame, allStrats, agentNumb )

% Name: value.m
% Location: MALT/sessionClasses/GlobalFiles/Normal_Form_Games/value.m
% Purpose:	Returns the value of a strategy in a particular normal form game
% Input Parameters:  Number of the game being played
%                    Action distribution for both agents (in the usual strategy format)
%                    Number of the agent running this
% Output Parameters: Value of a NFG game for a specific set of strategies
% This value method is specifically for NORMAL FORM GAMES

% Make the global variable visible
global SessionObject;

% Get the list of game objects
gamesAll = get( SessionObject, 'gameList' );
% Take the relevant normal form game
nfg_gm = gamesAll{nGame};
payMat = return_payoff_matrix( nfg_gm, agentNumb ); % Agent's payoff matrix
tActsAll = get( nfg_gm, 'totalActions' ); % Number of actions for each agent

% Calculate the payoff for that agent
% This method assumes two actions per player
retVal = 0;
for ag1Action = 1:tActsAll(1, 1)
	tVal = 0;
	for ag2Action = 1:tActsAll(1, 2)

		tVal = tVal + allStrats(2, ag2Action)*payMat( [ag1Action + (ag2Action-1)*tActsAll(1, 1)] );

	end % for: ag2Action
	retVal = retVal + allStrats(1, ag1Action)*tVal;
end % for: ag1Action

