function display( met_stat )

% Name: display.m
% Location: MALT/statisticsClasses/@metric_statistics/display.m
% Purpose: Displays a metric_statistics object
% Input Parameters:  metric_statistics object
% Output Parameters: none

% Get the values of the different fields
nLabels = length( met_stat.labels );
nProperties = length( met_stat.properties )/2; % List contains names and new values
allAlgs = met_stat.algorithms;
dspAlgs = [allAlgs{1} ' ' allAlgs{2}];
[rRow, rCol] = size( met_stat.results );

metStatDisp = sprintf( 'Name: %s \nLabels: %d\nProperties to change: %d\nAlgorithms: %s\nResults: %dx%d\nComments: %s', met_stat.name, nLabels, nProperties, dspAlgs, rRow, rCol, met_stat.comments );

disp( metStatDisp );
