function met_stat = set( met_stat, varargin )

% Name: set.m
% Location: MALT/statisticsClasses/@metric_statistics/set.m
% Purpose: Set metric_statistics properties in the specified object
% Input Parameters: 	metric_statistics object 
%							name of property to change and new value
% Output Parameters: Updated metric_statistics object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'name'
		met_stat.name = newValue;
	case 'labels'
		met_stat.labels = newValue;
	case 'properties'
		met_stat.properties = newValue;
	case 'algorithms'
		met_stat.algorithms = newValue;
	case 'results'
		met_stat.results = newValue;
	case 'comments'
		met_stat.comments = newValue;
	otherwise
		error( '@metric_statistics/set.m: Metric_statistics properties: Name, valid_visuals, labels, results' );
	end
end

