function met_stat = subsasgn( met_stat, field, value )

% Name: subsasgn.m
% Location: MALT/statisticsClasses/@metric_statistics/subsasgn.m
% Purpose: Define field name assignment for metric_statistics objects
% Input Parameters:  metric_statistics object 
%							field that is wanted, by name index
%							new value for the field
% Output Parameters: updated metric_statistics object

switch field.type
case '()'
	error('@metric_statistics/subsasgn.m: Numeric array indexing not supported by metric_statistics objects');
case '.'
	switch lower( field.subs )
	case 'name'
		met_stat.name = value;
	case 'labels'
		met_stat.labels = value;
	case 'properties'
		met_stat.properties = value;
	case 'algorithms'
		met_stat.algorithms = value;
	case 'results'
		met_stat.results = value;
	case 'comments'
		met_stat.comments = value;
	otherwise
		error('@metric_statistics/subsasgn.m: Invalid field name used for indexing - unknown');
	end
case '{}'
	error('@metric_statistics/subsasgn.m: Cell array indexing not supported by metric_statistics objects');
end
