function value = subsref( met_stat, field )

% Name: subsref.m
% Location: MALT/statisticsClasses/@metric_statistics/subsref.m
% Purpose: Define field name indexing for metric_statistics objects
% Input Parameters:  metric_statistics object 
%							field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error( '@metric_statistics/subsref.m: Numeric array indexing not supported by metric_statistics objects' );
case '.'
	switch lower( field.subs )
	case 'name'
		value = met_stat.name;
	case 'labels'
		value = met_stat.labels;
	case 'properties'
		value = met_stat.properties;
	case 'algorithms'
		value = met_stat.algorithms;
	case 'results'
		value = met_stat.results;
	case 'comments'
		value = met_stat.comments;
	otherwise
		error( '@metric_statistics/subsref.m: Invalid field name used for indexing - unknown' );
	end
case '{}'
	error( '@metric_statistics/subsref.m: Cell array indexing not supported by metric_statistics objects' );
end
