function stats = add_to_statistics( stats, struct_metStat, whichRow, whichCol )

% Name: add_to_statistics.m
% Location: MALT/statisticsClasses/@statistics/add_to_statistics.m
% Purpose:  Adds a structure to a statistics object
%           Now the structure in fact holds a group of metric_statistics objects
%           Each metric_statistic object is the results of one metric on that run
% Input Parameters: statistics object
%                   structure of metric_statistics objects
%                   number of the row where it should be saved
%                   number of the column where it should be saved
% Output Parameters: updated statistics object

% Get the cell array of metric statistics' objects
allMets = get( stats, 'metric_stats' );
% Get the size of the cell array
[nMetsSchedRow, nMetsSchedCol] = size( allMets );

% Check that the place where we want to add, exists
if ( ( whichRow > nMetsSchedRow ) || ( whichCol > nMetsSchedCol ) )
	error( 'add_to_statistics.m: Trying to add more metric statistics structures than initially scheduled' );
end

% Add the metric statistic
allMets( whichRow, whichCol ) = {struct_metStat};
% Save this back to the statistic object
stats = set( stats, 'metric_stats', allMets );
