function metStat = get_from_statistics( stats, whichMetric, whichRow, whichCol )

% Name: get_from_statistics.m
% Location: MALT/statisticsClasses/@statistics/get_from_statistics.m
% Purpose:  Returns a metric statistics object from a statistics object
% Input Parameters: statistics object
%                   name of the metric statistic that is wanted
%                   which row of the metric_stats field (in fact the flip)
%                   which column of the metric_stats field (in fact the run)
% Output Parameters: metric_statistics object

% Get all the metric statistics stored in this statistics object
allMets = get( stats, 'metric_stats' );
% Determine the number of rows and columns
[nMetsRow, nMetsCol] = size( allMets );

% Check that the requested metric statistic exists
if ( ( whichRow > nMetsRow ) || ( whichCol > nMetsCol ) )
	error( 'get_from_statistics.m: Trying to obtain a metric statistics structure that does not exist' );
end

% Obtain that metric statistic object
dataStruct = allMets{ whichRow, whichCol };
metStat = getfield( dataStruct, whichMetric ); % Gets the wanted metric's data
