function stat = set( stat, varargin )

% Name: set.m
% Location: MALT/statisticsClasses/@statistics/set.m
% Purpose: Set statistics properties in the specified object
% Input Parameters:  statistics object 
%                    name of property to change and new value
% Output Parameters: Updated statistics object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case {'metric_stats', 'metric_statistics'}
		stat.metric_stats = newValue;
	otherwise
		error( '@statistics/set.m: Statistics properties: metric_stats' );
	end
end
