function stats = statistics( varargin )

% Name: statistic.m
% Location: MALT/statisticsClasses/@statistics/statistics.m
% Purpose: Constructor method for the statistics class
%          Stores all of the metric_statistics objects from a session 
% Input Parameters: No parameters - defaults used
%                   1 parameter   - statistics object (to copy the object)
%                   2 parameters  - number of rows in the cell array
%                                   number of columns in the cell array
% Output Parameters: Statistics object

switch nargin
case 0 % Create default statistics object
	stats.metric_stats = {};
	stats = class( stats, 'statistics' );
case 1 % Copy default statistics object
	if ( isa( varargin{1}, 'statistics' ) )
		stats = varargin{1};
	else
		error( 'statistics.m: Input argument is not a statistics object OR a double' );
	end
case 2 % Create statistics object with varargin{1} rows, varargin{2} columns
	stats.metric_stats = cell( varargin{1}, varargin{2} );
	stats = class( stats, 'statistics' );
otherwise
	error_disp = sprintf( 'Valid parameters:\nNo parameters - defaults used\n1 parameter - a copy of the object OR the number of metric_statistics to be saved\n2 Parameters - number of rows in the cell array\n\tnumber of columns in the cell array' );
	disp( error_disp );
	error( 'statistics.m: Incorrect number of input arguments' );
end
