function stat = subsasgn( stat, field, value )

% Name: subsasgn.m
% Location: MALT/statisticsClasses/@statistics/subsasgn.m
% Purpose: Define field name assignment for statistics objects
% Input Parameters:  statistics object 
%							field that is wanted, by name index
%							new value for the field
% Output Parameters: updated statistics object

switch field.type
case '()'
	error('@statistics/subsasgn.m: Numeric array indexing not supported by statistics objects');
case '.'
	switch lower( field.subs )
	case {'metric_stats', 'metric_statistics'}
		stat.metric_stats = value;
	otherwise
		error('@statistics/subsasgn.m: Invalid field name used for indexing - unknown');
	end
case '{}'
	error('@statistics/subsasgn.m: Cell array indexing not supported by statistics objects');
end
