function value = subsref( stat, field )

% Name: subsref.m
% Location: MALT/statisticsClasses/@statistics/subsref.m
% Purpose: Define field name indexing for statistics objects
% Input Parameters:  statistics object 
%							field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error( '@statistics/subsref.m: Numeric array indexing not supported by statistics objects' );
case '.'
	switch lower( field.subs )
	case {'metric_stats', 'metric_statistics'}
		value = stat.metric_stats;
	otherwise
		error( '@statistics/subsref.m: Invalid field name used for indexing - unknown' );
	end
case '{}'
	error( '@statistics/subsref.m: Cell array indexing not supported by statistics objects' );
end
