function [dataStore bxVsl] = plot_data_format( bxVsl, freeLengths, freeNames, condFree, aggMethod, errorbarStatus, lengthValues, metricObj )

% Name: plot_data_format.m
% Location: MALT/visualClasses/@boxplot_visual/plot_data_format.m
% Purpose:  Creates the data structure where all of the data will be stored,
%           This is the data from a metric, that will be visualised
% Input Parameters:  5 Parameters - boxplot visual object
%                                   array of lengths of free variables
%                                   array of labels within each free variable
%                                   names of free variables
%                                   method of aggregation on the non-selected free variables
%                                   array of length values for agents, games, runs
%                                   metric object
% 
% Output Parameters: data store variable, for storing the data
%                    updated boxplot object

% Preallocate space for the data storage
dataStore = zeros( lengthValues{1}, lengthValues{2}, lengthValues{3}, lengthValues{4} );

% Put the xlabel to be the name of the metric, ylabel is blank
bxVsl = set( bxVsl, 'labelX', get( metricObj, 'displayName' ) );
bxVsl = set( bxVsl, 'labelY', '' );
