function value = subsref( bxVsl, field )

% Name: subsref.m
% Location: MALT/visualClasses/@boxplot_visual/subsref.m
% Purpose: Define field name indexing for boxplot_visual objects
% Input Parameters:  boxplot_visual object
%                    field that is wanted, by name index
% Output Parameters: value of the field

value = subsref( bxVsl.visual, field );

% The boxplot_visual class does not add any extra parameters to the visual class and hence does not need to determine the value of any of its own parameters. 
% The value of all of the parameters is obtained by running the corresponding @value method.

