function htVsl = set( htVsl, varargin )

% Name: set.m
% Location: MALT/visualClasses/@heat_visual/set.m
% Purpose: Set heat_visual properties in the specified object
% Input Parameters:  heat_visual object 
%                    name of property to change and new value
% Output Parameters: Updated heat_visual object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};
	propertyArgIn = propertyArgIn(3:end);

	switch lower( property )
	case 'heatmap'
		htVsl.heatMap = newValue;
	otherwise
		htVsl.visual = set( htVsl.visual, property, newValue );
	end
end
