function htVsl = subsasgn( htVsl, field, value )

% Name: subsasgn.m
% Location: MALT/visualClasses/@heat_visual/subsasgn.m
% Purpose: Define field name assignment for heat_visual objects
% Input Parameters:  heat_visual object 
%                    field that is wanted, by name index
%                    new value for the field
% Output Parameters: updated heat_visual object

switch field.type
case '()'
	error('@heat_visual/subsasgn.m: Numeric array indexing not supported by heat_visual objects');
case '.'
	switch lower( field.subs )
	case 'heatmap'
		htVsl.heatMap = value;
	otherwise
		htVsl.visual = subsasgn( htVsl.visual , field, value );
	end
case '{}'
	error('@heat_visual/subsasgn.m: Cell array indexing not supported by heat_visual objects');
end
