function value = subsref( htVsl, field )

% Name: subsref.m
% Location: MALT/visualClasses/@heat_visual/subsref.m
% Purpose: Define field name indexing for heat_visual objects
% Input Parameters:  heat_visual object
%                    field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error('@heat_visual/subsref.m: Numeric array indexing not supported by heat_visual objects');
case '.'
	switch lower( field.subs )
	case 'heatmap'
		value = htVsl.heatMap;
	otherwise
		value = subsref( htVsl.visual, field );
	end
case '{}'
	error('@heat_visual/subsref.m: Cell array indexing not supported by heat_visual objects');
end
