function display( vsl )

% Name: display.m
% Location: MALT/visualClasses/@visual/display.m
% Purpose: Displays a visual object
% Input Parameters:  visual object
% Output Parameters: none

% Get the values/lengths of fields in the visual object
nPropLst = length( get( vsl, 'propList' ) );
nPropVal = length( get( vsl, 'propValue' ) );
nLegends = length( get( vsl, 'legends' ) );
nGcaLabels = length( get( vsl, 'gcaLabels' ) );
nGcaTitles = length( get( vsl, 'gcaTitles' ) );
[rTitle cTitle] = size( get( vsl, 'title' ) );

vslDisp = sprintf( 'Method name: %s\nX label: %s\nY Label: %s\nTitle: %dx%d\nGame Name: %s\nProperty List: %d properties\nProperty values: %d new values\ngca titles: %d functions\ngca labels: %d labels set\nLegends: %d labels', vsl.name, vsl.labelX, vsl.labelY, rTitle, cTitle, vsl.gamename, nPropLst, nPropVal, nGcaLabels, nGcaTitles, nLegends );

disp( vslDisp );

disp( '---- Features for free variables and aggregation ----' );

% Properties for free variables and aggregation
aggForAll = get( vsl, 'aggregationForAll' );
aggAllowed = get( vsl, 'aggregationAllowed' );
errBars = get( vsl, 'errorBarsAllowed' );
freeVarsDis = get( vsl, 'freeVarsDisallowed' );
extraFeat = get( vsl, 'extraFeatures' );

blankAgg = [];
for aggA = 1:length( aggAllowed )
	blankAgg = [blankAgg ' ' aggAllowed{aggA}];
end

blankDis = [];
for freeV = 1:length( freeVarsDis )
	blankDis = [blankDis ' ' freeVarsDis{freeV}];
end

extraF = [];
for ext = 1:length( extraFeat )
	extraF = [extraF ' ' extraFeat{ext}];
end

vslExtraDisp = sprintf( 'Aggregation expected for all: %d\nAggregation methods allowed: %s\nError bars possible: %d\nFree variables disallowed: %s\nExtra features: %s\n', aggForAll, blankAgg, errBars, blankDis, extraF );

disp( vslExtraDisp );
