function value = get( vsl, property )

% Name: get.m
% Location: MALT/visualClasses/@visual/get.m
% Purpose: Get visual properties from the specified object
% Input Parameters: 	visual object
%							name of property
% Output Parameters: Value of the property

switch lower( property )
case 'name'
	value = vsl.name;
case 'labelx'
	value = vsl.labelX;
case 'labely'
	value = vsl.labelY;
case 'gcalabels'
	value = vsl.gcaLabels;
case 'gcatitles'
	value = vsl.gcaTitles;
case 'title'
	value = vsl.title;
case 'gamename'
	value = vsl.gamename;
case {'proplist', 'properties'}
	value = vsl.propList;
case 'propvalue'
	value = vsl.propValue;
case {'legends', 'legend'}
	value = vsl.legends;
case {'aggregationforall'}
	value = vsl.aggregationForAll;
case {'aggregationallowed'}
	value = vsl.aggregationAllowed;
case {'errorbarsallowed'}
	value = vsl.errorBarsAllowed;
case {'freevarsdisallowed'}
	value = vsl.freeVarsDisallowed;
case {'extrafeatures'}
	value = vsl.extraFeatures;
otherwise
	error( ['@visual/get.m: ', property,' is not a valid visual object property'] );
end
