function vsl = set( vsl, varargin )

% Name: set.m
% Location: MALT/visualClasses/@visual/set.m
% Purpose: Set visual object properties in the specified object
% Input Parameters: 	visual object object 
%							name of property to change and new value
% Output Parameters: Updated visual object object

propertyArgIn = varargin;

while length( propertyArgIn ) >= 2,
	property = propertyArgIn{1};
	newValue = propertyArgIn{2};

	propertyArgIn = propertyArgIn(3:end);
	switch lower( property )
	case 'name'
		vsl.name = newValue;
	case 'labelx'
	   vsl.labelX = newValue;
	case 'labely'
	   vsl.labelY = newValue;
	case 'gcalabels'
		vsl.gcaLabels = newValue;
	case 'gcatitles'
		vsl.gcaTitles = newValue;
	case 'title'
	   vsl.title = newValue;
	case 'gamename'
	   vsl.gamename = newValue;
	case {'proplist', 'properties'}
	   vsl.propList = newValue;
	case 'propvalue'
	   vsl.propValue = newValue;
	case {'legends', 'legend'}
	   vsl.legends = newValue;
	case {'aggregationforall'}
		vsl.aggregationForAll = newValue;
	case {'aggregationallowed'}
		vsl.aggregationAllowed = newValue;
	case {'errorbarsallowed'}
		vsl.errorBarsAllowed = newValue;
	case {'freevarsdisallowed'}
		vsl.freeVarsDisallowed = newValue;
	case {'extrafeatures'}
		vsl.extraFeatures = newValue;
	otherwise
		error( '@visual/set.m: Visual properties: labelX, labelY, title, gamename, proplist, propvalue, legends' );
	end
end

