function vsl = subsasgn( vsl, field, value )

% Name: subsasgn.m
% Location: MALT/visualClasses/@visual/subsasgn.m
% Purpose: Define field name assignment for visual objects
% Input Parameters:  visual object 
%							field that is wanted, by name index
%							new value for the field
% Output Parameters: updated visual object

switch field.type
case '()'
	error('@visual/subsasgn.m: Numeric array indexing not supported by visual objects');
case '.'
	switch lower( field.subs )
	case 'name'
		vsl.name = value;
	case 'labelx'
	   vsl.labelX = value;
	case 'labely'
		vsl.labelY = value;
	case 'gcalabels'
		vsl.gcaLabels = value;
	case 'gcatitles'
		vsl.gcaTitles = value;
	case 'title'
		vsl.title = value;
	case 'gamename'
	   vsl.gamename = value;
	case {'proplist', 'properties'}
   	vsl.propList = value;
	case 'propvalue'
	   vsl.propValue = value;
	case {'legends', 'legend'}
	   vsl.legends = value;
	case {'aggregationforall'}
		vsl.aggregationForAll = value;
	case {'aggregationallowed'}
		vsl.aggregationAllowed = value;
	case {'errorbarsallowed'}
		vsl.errorBarsAllowed = value;
	case {'freevarsdisallowed'}
		vsl.freeVarsDisallowed = value;
	case {'extrafeatures'}
		vsl.extraFeatures = value;
	otherwise
		error('@visual/subsasgn.m: Invalid field name used for indexing - unknown');
	end
case '{}'
	error('@visual/subsasgn.m: Cell array indexing not supported by visual objects');
end
