function value = subsref( vsl, field )

% Name: subsref.m
% Location: MALT/visualClasses/@visual/subsref.m
% Purpose: Define field name indexing for visuak objects
% Input Parameters:  visual object 
%							field that is wanted, by name index
% Output Parameters: value of the field

switch field.type
case '()'
	error( '@visual/subsref.m: Numeric array indexing not supported by visual objects' );
case '.'
	switch lower( field.subs )
	case 'name'
		value = vsl.name;
	case 'labelx'
		value = vsl.labelX;
	case 'labely'
		value = vsl.labelY;
	case 'gcalabels'
		value = vsl.gcaLabels;
	case 'gcatitles'
		value = vsl.gcaTitles;
	case 'title'
		value = vsl.title.;
	case 'gamename'
		value = vsl.gamename;
	case {'proplist', 'properties'}
		value = vsl.propList;
	case 'propvalue'
		value = vsl.propValue;
	case {'legends', 'legend'}
		value = vsl.legends;
	case {'aggregationforall'}
		value = vsl.aggregationForAll;
	case {'aggregationallowed'}
		value = vsl.aggregationAllowed;
	case {'errorbarsallowed'}
		value = vsl.errorBarsAllowed;
	case {'freevarsdisallowed'}
		value = vsl.freeVarsDisallowed;
	case {'extrafeatures'}
		value = vsl.extraFeatures;	
	otherwise
		error( '@visual/subsref.m: Invalid field name used for indexing - unknown' );
	end
case '{}'
	error( '@visual/subsref.m: Cell array indexing not supported by visual objects' );
end
