function actionTaken = selectaction( q_agnt, varargin )

% Name: selectaction.m
% Location: MALT/agentClasses/@q_agent/selectaction.m
% Purpose: Selects an action from the Q-learning agent's distribution over actions
% Input Parameters: q_agent object
% Output Parameters: action taken by the q_agent this round

nActions = get(q_agnt, 'actions');
if ( rand < get(q_agnt, 'explore') )
	% Choose a random action if exploring
	tList = ones( 1, nActions )/nActions;
	actionTaken = draw_sample( tList );
else
	% If exploiting, then draw a sample from our strategy
	% We can sample from the strategy (which is set at the learning stage)
	actionTaken = draw_sample( returnstrategy( q_agnt ) );
end

% Decay the exploration rate
q_agnt.explore = q_agnt.explore * q_agnt.exploreDecay;
